=== modified file 'Makefile'
--- Makefile	2005-09-15 13:34:01 +0000
+++ Makefile	2005-09-01 06:32:52 +0000
@@ -1,15 +1,9 @@
-all: executables
-
-executables:
+all:
 	chmod u+x ./bzr
-	chmod u+x ./setup.py
 
 check:
 	./bzr selftest
 
-clean: executables
-	./setup.py clean
-
 .PHONY: all
 
 

=== modified file 'NEWS'
--- NEWS	2005-09-28 09:35:50 +0000
+++ NEWS	2005-09-13 23:18:12 +0000
@@ -1,111 +1,25 @@
-DEVELOPMENT HEAD
-
-  BUG FIXES:
-  
-    * bzr-man.py has been updated to work again. Contributed by
-      Rob Weir.
-
-    * Locking is now done with fcntl.lockf which works with NFS
-      file systems. Contributed by Harald Meland.
-
-  IMPROVEMENTS:
-
-    * 'branch' now accepts a --basis parameter which will take advantage
-      of local history when making a new branch. This allows faster 
-      branching of remote branches. Contributed by Aaron Bentley.
-
-    * New tree format based on weave files, called version 5.
-      Existing branches can be upgraded to this format using 
-      'bzr upgrade'.
-
-  INTERNALS:
-
-    * Test case failures have the exception printed after the log for your
-      viewing pleasure.
-
-      
-bzr 0.0.9 2005-09-23
-
-  BUG FIXES:
-
-    * Fixed "branch -r" option.
-
-    * Fix remote access to branches containing non-compressed history.
-      (Robert Collins).
-
-    * Better reliability of http server tests.  (John Arbash-Meinel)
-
-    * Merge graph maximum distance calculation fix.  (Aaron Bentley)
-   
-    * Various minor bug in windows support have been fixed, largely in the
-      test suite. Contributed by Alexander Belchenko.
-
-  IMPROVEMENTS:
-
-    * Status now accepts a -r argument to give status between chosen
-      revisions. Contributed by Heikki Paajanen.
-
-    * Revision arguments no longer use +/-/= to control ranges, instead
-      there is a 'before' namespace, which limits the successive namespace.
-      For example '$ bzr log -r date:yesterday..before:date:today' will
-      select everything from yesterday and before today. Contributed by
-      Robey Pointer
-
-    * There is now a bzr.bat file created by distutils when building on 
-      Windows. Contributed by Alexander Belchenko.
-
-  INTERNALS:
-
-    * Removed uuid() as it was unused.
+development head
+
+  INTERNALS:
+
+    * Refactor xml packing/unpacking.
 
     * Improved 'fetch' code for pulling revisions from one branch into
       another (used by pull, merged, etc.)
 
 
-bzr 0.0.8 2005-09-20
-
-  IMPROVEMENTS:
-
-    * Adding a file whose parent directory is not versioned will
-      implicitly add the parent, and so on up to the root. This means
-      you should never need to explictly add a directory, they'll just
-      get added when you add a file in the directory.  Contributed by
-      Michael Ellerman.
-
-    * Ignore .DS_Store (contains Mac metadata) by default.  Patch from
-      Nir Soffer.
-
-    * If you set BZR_EDITOR in the environment, it is checked in
-      preference to EDITOR and the config file for the interactive commit
-      editing program. Related to this is a bugfix where a missing program
-      set in EDITOR would cause editing to fail, now the fallback program
-      for the operating system is still tried.
-
-    * Files that are not directories/symlinks/regular files will no longer
-      cause bzr to fail, it will just ignore them by default. You cannot add
-      them to the tree though - they are not versionable.
-
-
-  INTERNALS:
-
-    * Refactor xml packing/unpacking.
-
-  BUG FIXES: 
-
-    * Fixed 'bzr mv' by Ollie Rutherfurd.
-
-    * Fixed strange error when trying to access a nonexistent http
-      branch.
-
-    * Make sure that the hashcache gets written out if it can't be
-      read.
-
-
-  PORTABILITY:
-
-    * Various Windows fixes from Ollie Rutherfurd.
-
-    * Quieten warnings about locking; patch from Matt Lavin.
+  CHANGES:
+
+    * New tree format based on weave files, called version 5.
+
+
+  API:
+
+    * New method-object style interface for Commit() and Fetch().
+
+    * Renamed Branch.last_patch() to Branch.last_revision(), since
+      we call them revisions not patches.
+  
 
 
 bzr-0.0.7 2005-09-02

=== modified file 'NEWS.developers'
--- NEWS.developers	2005-09-23 05:57:06 +0000
+++ NEWS.developers	2005-09-19 08:02:41 +0000
@@ -3,8 +3,3 @@
  * Remove RevisionReference class; Revision.parent_ids is now simply a
    list of their ids and parent_sha1s is a list of their corresponding
    sha1s (for old branches only at the moment.)
-
- * New method-object style interface for Commit() and Fetch().
-
- * Renamed Branch.last_patch() to Branch.last_revision(), since
-   we call them revisions not patches.

=== modified file 'TODO'
--- TODO	2005-09-19 02:52:24 +0000
+++ TODO	2005-09-01 12:34:34 +0000
@@ -24,11 +24,6 @@
 
   2005-11-05      mbp  Flowers for stephane
 
-* Fix tests so that import errors caused by modules don't produce false reports
-  that the tests themselves don't exist.
-
-* Fix tests so that one test failure doesn't prevent other tests from running
-
 * print a message at the end of running the tests telling them that the
   test log and output exists but can be removed
 
@@ -208,9 +203,6 @@
 
 * BZRDIR should be in branch.py not __init__.py.
 
-* ``status `` should accept a -r option to show changes relative to a revision,
-  or between revisions
-
 Medium things
 -------------
 

=== modified file 'bzr'
--- bzr	2005-09-29 05:06:14 +0000
+++ bzr	2005-08-25 07:46:11 +0000
@@ -40,22 +40,12 @@
     print >>sys.stderr, "bzr: error: cannot find a suitable python interpreter"
     print >>sys.stderr, "  (need %d.%d or later)" % NEED_VERS
     sys.exit(1)
-if hasattr(os, "unsetenv"):
-    os.unsetenv(REINVOKE)
+os.unsetenv(REINVOKE)
 
-try:
-    import bzrlib
-    import bzrlib.commands
-    import bzrlib.trace
-except ImportError, e:
-    sys.stderr.write("bzr: ERROR: "
-                     "Couldn't import bzrlib and dependencies.\n"
-                     "Please check bzrlib is on your PYTHONPATH.\n"
-                     "\n")
-    raise
+import bzrlib
+import bzrlib.commands
+import bzrlib.trace
 
 if __name__ == '__main__':
     bzrlib.trace.enable_default_logging()
     sys.exit(bzrlib.commands.main(sys.argv))
-else:
-    pass    # should this give an error? - it can't be used as a lib

=== modified file 'bzr-man.py'
--- bzr-man.py	2005-09-28 04:58:18 +0000
+++ bzr-man.py	2005-06-06 13:24:18 +0000
@@ -42,8 +42,7 @@
     print >>sys.stderr, "bzr-man.py: error: cannot find a suitable python interpreter"
     print >>sys.stderr, "  (need %d.%d or later)" % NEED_VERS
     sys.exit(1)
-if hasattr(os, "unsetenv"):
-    os.unsetenv(REINVOKE)
+os.unsetenv(REINVOKE)
 
 import bzrlib, bzrlib.help
 
@@ -91,17 +90,15 @@
 
     def parse_line(self, line):
         m = self.usage_exp.match(line)
-	if line == '':
-		return
         if m:
             if self.state == 0:
                 if self.usage:
                     self.command_usage.append((self.command,self.usage,self.descr))
                     self.all_commands.append(self.command)
-                self.usage = " ".join(line.split(" ")[1:])
+                self.usage = line
                 self.command = m.groups()[0]
             else:
-                raise RuntimeError, "matching usage line in state %d" % state
+                raise Error, "matching usage line in state %d" % state
             self.state = 1
             return
         m = self.descr_exp.match(line)
@@ -109,10 +106,10 @@
             if self.state == 1:
                 self.descr = m.groups()[0]
             else:
-                raise RuntimeError, "matching descr line in state %d" % state
+                raise Error, "matching descr line in state %d" % state
             self.state = 0
             return
-        raise RuntimeError, "Cannot parse this line ('%s')." % line
+        raise Error, "Cannot parse this line"
 
     def end_parse(self):
         if self.state == 0:
@@ -120,7 +117,7 @@
                 self.command_usage.append((self.command,self.usage,self.descr))
                 self.all_commands.append(self.command)
         else:
-            raise RuntimeError, "ending parse in state %d" % state
+            raise Error, "ending parse in state %d" % state
 
     def write_to_manpage(self, outfile):
         bzrcmd = self.params["bzrcmd"]

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-09-23 09:20:45 +0000
+++ bzrlib/__init__.py	2005-09-05 04:07:23 +0000
@@ -28,18 +28,17 @@
                   'BitKeeper',
                   '.git',
                   'TAGS', '.make.state', '.sconsign', '.tmp*',
-                  '.del-*',
-                  '.DS_Store',]
+                  '.del-*']
 
 IGNORE_FILENAME = ".bzrignore"
 
-import os
 import locale
 user_encoding = locale.getpreferredencoding() or 'ascii'
 del locale
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
-__version__ = '0.0.9'
+__author__ = "Martin Pool <mbp@canonical.com>"
+__version__ = '0.1pre'
 
 
 def get_bzr_revision():
@@ -48,7 +47,7 @@
     from bzrlib.branch import Branch
     
     try:
-        branch = Branch.open(os.path.dirname(__path__[0]))
+        branch = Branch(__path__[0])
         rh = branch.revision_history()
         if rh:
             return len(rh), rh[-1]

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-09-23 09:25:16 +0000
+++ bzrlib/add.py	2005-09-01 07:28:14 +0000
@@ -18,10 +18,10 @@
 from bzrlib.errors import NotBranchError
 from bzrlib.branch import Branch
 from bzrlib.osutils import quotefn
-from os.path import dirname
 
 def glob_expand_for_win32(file_list):
     import glob
+    
     expanded_file_list = []
     for possible_glob in file_list:
         glob_files = glob.glob(possible_glob)
@@ -63,7 +63,7 @@
     Returns the number of files added.
     """
     file_list = _prepare_file_list(file_list)
-    b = Branch.open_containing(file_list[0])
+    b = Branch(file_list[0], find_root=True)
     return smart_add_branch(b, file_list, recurse, reporter)
 
         
@@ -78,8 +78,11 @@
     Returns the number of files added.
     """
     import os
+    import sys
+    from bzrlib.osutils import quotefn
     from bzrlib.errors import BadFileKindError, ForbiddenFileError
     import bzrlib.branch
+    import bzrlib.osutils
 
     assert isinstance(recurse, bool)
 
@@ -111,7 +114,7 @@
 
         if kind == 'directory':
             try:
-                sub_branch = Branch.open(af)
+                sub_branch = Branch(af, find_root=False)
                 sub_tree = True
             except NotBranchError:
                 sub_tree = False
@@ -126,7 +129,10 @@
         elif sub_tree:
             mutter("%r is a bzr tree" %f)
         else:
-            count += __add_one(branch, inv, rf, kind, reporter)
+            entry = inv.add_path(rf, kind=kind)
+            mutter("added %r kind %r file_id={%s}" % (rf, kind, entry.file_id))
+            count += 1 
+            reporter(rf, kind, entry)
 
         if kind == 'directory' and recurse and not sub_tree:
             for subf in os.listdir(af):
@@ -146,21 +152,3 @@
         branch._write_inventory(inv)
 
     return count
-
-def __add_one(branch, inv, path, kind, reporter):
-    """Add a file or directory, automatically add unversioned parents."""
-
-    # Nothing to do if path is already versioned.
-    # This is safe from infinite recursion because the branch root is
-    # always versioned.
-    if inv.path2id(path) != None:
-        return 0
-
-    # add parent
-    count = __add_one(branch, inv, dirname(path), 'directory', reporter)
-
-    entry = inv.add_path(path, kind=kind)
-    mutter("added %r kind %r file_id={%s}" % (path, kind, entry.file_id))
-    reporter(path, kind, entry)
-
-    return count + 1

=== removed file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2005-09-22 13:32:02 +0000
+++ bzrlib/annotate.py	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""File annotate based on weave storage"""
-
-import sys
-import os
-
-import bzrlib.weave
-
-def annotate_file(branch, rev_id, file_id, to_file=None):
-    if to_file is None:
-        to_file = sys.stdout
-    rh = branch.revision_history()
-    w = branch.weave_store.get_weave(file_id)
-    last_origin = None
-    for origin, text in w.annotate_iter(rev_id):
-        text = text.rstrip('\r\n')
-        if origin == last_origin:
-            print '      | %s' % (text)
-        else:
-            last_origin = origin
-            line_rev_id = w.idx_to_name(origin)
-            try:
-                revno = rh.index(line_rev_id) + 1
-                print '%5d | %s' % (revno, text)
-            except ValueError:
-                print 'merge | %s' % (text)
-
-
-
-if __name__ == '__main__':
-    from bzrlib.branch import find_branch
-    from bzrlib.trace import enable_default_logging
-
-    enable_default_logging()
-    b = find_branch(sys.argv[1])
-    rp = b.relpath(sys.argv[1])
-    tree = b.revision_tree(b.last_revision())
-    file_id = tree.inventory.path2id(rp)
-    file_version = tree.inventory[file_id].text_version
-    annotate_file(b, file_version, file_id, sys.stdout)

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2005-09-23 09:25:16 +0000
+++ bzrlib/atomicfile.py	2005-05-26 16:09:45 +0000
@@ -17,7 +17,7 @@
 
 
 from warnings import warn
-from osutils import rename
+
 
 class AtomicFile(object):
     """A file that does an atomic-rename to move into place.
@@ -65,7 +65,16 @@
         self.f.close()
         self.f = None
         
-        rename(self.tmpfilename, self.realfilename)
+        if sys.platform == 'win32':
+            # windows cannot rename over an existing file
+            try:
+                os.remove(self.realfilename)
+            except OSError, e:
+                import errno
+                if e.errno != errno.ENOENT:
+                    raise
+                
+        os.rename(self.tmpfilename, self.realfilename)
 
 
     def abort(self):

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-09-29 03:44:15 +0000
+++ bzrlib/branch.py	2005-09-22 07:04:14 +0000
@@ -23,20 +23,20 @@
 
 import bzrlib
 from bzrlib.trace import mutter, note
-from bzrlib.osutils import (isdir, quotefn, compact_date, rand_bytes, 
-                            rename, splitpath, sha_file, appendpath, 
-                            file_kind)
+from bzrlib.osutils import isdir, quotefn, compact_date, rand_bytes, \
+     splitpath, \
+     sha_file, appendpath, file_kind
+
 from bzrlib.errors import (BzrError, InvalidRevisionNumber, InvalidRevisionId,
                            NoSuchRevision, HistoryMissing, NotBranchError,
-                           DivergedBranches, LockError, UnlistableStore,
-                           UnlistableBranch)
+                           LockError)
 from bzrlib.textui import show_status
-from bzrlib.revision import Revision, validate_revision_id, is_ancestor
+from bzrlib.revision import Revision, validate_revision_id
 from bzrlib.delta import compare_trees
 from bzrlib.tree import EmptyTree, RevisionTree
 from bzrlib.inventory import Inventory
 from bzrlib.weavestore import WeaveStore
-from bzrlib.store import copy_all, ImmutableStore
+from bzrlib.store import ImmutableStore
 import bzrlib.xml5
 import bzrlib.ui
 
@@ -51,10 +51,34 @@
 # cache in memory to make this faster.  In general anything can be
 # cached in memory between lock and unlock operations.
 
-def find_branch(*ignored, **ignored_too):
-    # XXX: leave this here for about one release, then remove it
-    raise NotImplementedError('find_branch() is not supported anymore, '
-                              'please use one of the new branch constructors')
+# TODO: please move the revision-string syntax stuff out of the branch
+# object; it's clutter
+
+
+def find_branch(f, **args):
+    if f and (f.startswith('http://') or f.startswith('https://')):
+        import remotebranch 
+        return remotebranch.RemoteBranch(f, **args)
+    else:
+        return Branch(f, **args)
+
+
+def find_cached_branch(f, cache_root, **args):
+    from remotebranch import RemoteBranch
+    br = find_branch(f, **args)
+    def cacheify(br, store_name):
+        from meta_store import CachedStore
+        cache_path = os.path.join(cache_root, store_name)
+        os.mkdir(cache_path)
+        new_store = CachedStore(getattr(br, store_name), cache_path)
+        setattr(br, store_name, new_store)
+
+    if isinstance(br, RemoteBranch):
+        cacheify(br, 'inventory_store')
+        cacheify(br, 'text_store')
+        cacheify(br, 'revision_store')
+    return br
+
 
 def _relpath(base, path):
     """Return path relative to base, or raise exception.
@@ -116,6 +140,13 @@
 
 
 
+# XXX: move into bzrlib.errors; subclass BzrError    
+class DivergedBranches(Exception):
+    def __init__(self, branch1, branch2):
+        self.branch1 = branch1
+        self.branch2 = branch2
+        Exception.__init__(self, "These branches have diverged.")
+
 
 ######################################################################
 # branch objects
@@ -124,62 +155,7 @@
     """Branch holding a history of revisions.
 
     base
-        Base directory/url of the branch.
-    """
-    base = None
-
-    def __init__(self, *ignored, **ignored_too):
-        raise NotImplementedError('The Branch class is abstract')
-
-    @staticmethod
-    def open_downlevel(base):
-        """Open a branch which may be of an old format.
-        
-        Only local branches are supported."""
-        return LocalBranch(base, find_root=False, relax_version_check=True)
-        
-    @staticmethod
-    def open(base):
-        """Open an existing branch, rooted at 'base' (url)"""
-        if base and (base.startswith('http://') or base.startswith('https://')):
-            from bzrlib.remotebranch import RemoteBranch
-            return RemoteBranch(base, find_root=False)
-        else:
-            return LocalBranch(base, find_root=False)
-
-    @staticmethod
-    def open_containing(url):
-        """Open an existing branch which contains url.
-        
-        This probes for a branch at url, and searches upwards from there.
-        """
-        if url and (url.startswith('http://') or url.startswith('https://')):
-            from bzrlib.remotebranch import RemoteBranch
-            return RemoteBranch(url)
-        else:
-            return LocalBranch(url)
-
-    @staticmethod
-    def initialize(base):
-        """Create a new branch, rooted at 'base' (url)"""
-        if base and (base.startswith('http://') or base.startswith('https://')):
-            from bzrlib.remotebranch import RemoteBranch
-            return RemoteBranch(base, init=True)
-        else:
-            return LocalBranch(base, init=True)
-
-    def setup_caching(self, cache_root):
-        """Subclasses that care about caching should override this, and set
-        up cached stores located under cache_root.
-        """
-
-
-class LocalBranch(Branch):
-    """A branch stored in the actual filesystem.
-
-    Note that it's "local" in the context of the filesystem; it doesn't
-    really matter if it's on an nfs/smb/afs/coda/... share, as long as
-    it's writable, and can be accessed via the normal filesystem API.
+        Base directory of the branch.
 
     _lock_mode
         None, or 'r' or 'w'
@@ -191,10 +167,7 @@
     _lock
         Lock object from bzrlib.lock.
     """
-    # We actually expect this class to be somewhat short-lived; part of its
-    # purpose is to try to isolate what bits of the branch logic are tied to
-    # filesystem access, so that in a later step, we can extricate them to
-    # a separarte ("storage") class.
+    base = None
     _lock_mode = None
     _lock_count = None
     _lock = None
@@ -205,31 +178,11 @@
     # This should match a prefix with a function which accepts
     REVISION_NAMESPACES = {}
 
-    def push_stores(self, branch_to):
-        """Copy the content of this branches store to branch_to."""
-        if (self._branch_format != branch_to._branch_format
-            or self._branch_format != 4):
-            from bzrlib.fetch import greedy_fetch
-            mutter("falling back to fetch logic to push between %s(%s) and %s(%s)",
-                   self, self._branch_format, branch_to, branch_to._branch_format)
-            greedy_fetch(to_branch=branch_to, from_branch=self,
-                         revision=self.last_revision())
-            return
-
-        store_pairs = ((self.text_store,      branch_to.text_store),
-                       (self.inventory_store, branch_to.inventory_store),
-                       (self.revision_store,  branch_to.revision_store))
-        try:
-            for from_store, to_store in store_pairs: 
-                copy_all(from_store, to_store)
-        except UnlistableStore:
-            raise UnlistableBranch(from_store)
-
     def __init__(self, base, init=False, find_root=True,
                  relax_version_check=False):
         """Create new branch object at a particular location.
 
-        base -- Base directory for the branch. May be a file:// url.
+        base -- Base directory for the branch.
         
         init -- If True, create new control files in a previously
              unversioned directory.  If False, the branch must already
@@ -252,25 +205,19 @@
         elif find_root:
             self.base = find_branch_root(base)
         else:
-            if base.startswith("file://"):
-                base = base[7:]
             self.base = os.path.realpath(base)
             if not isdir(self.controlfilename('.')):
                 raise NotBranchError('not a bzr branch: %s' % quotefn(base),
                                      ['use "bzr init" to initialize a '
                                       'new working tree'])
         self._check_format(relax_version_check)
-        cfn = self.controlfilename
+	cfn = self.controlfilename
         if self._branch_format == 4:
             self.inventory_store = ImmutableStore(cfn('inventory-store'))
             self.text_store = ImmutableStore(cfn('text-store'))
-        elif self._branch_format == 5:
-            self.control_weaves = WeaveStore(cfn([]))
-            self.weave_store = WeaveStore(cfn('weaves'))
-            if init:
-                # FIXME: Unify with make_control_files
-                self.control_weaves.put_empty_weave('inventory')
-                self.control_weaves.put_empty_weave('ancestry')
+	elif self._branch_format == 5:
+	    self.control_weaves = WeaveStore(cfn([]))
+	    self.weave_store = WeaveStore(cfn('weaves'))
         self.revision_store = ImmutableStore(cfn('revision-store'))
 
 
@@ -283,11 +230,10 @@
 
     def __del__(self):
         if self._lock_mode or self._lock:
-            # XXX: This should show something every time, and be suitable for
-            # headless operation and embedding
             warn("branch %r was not explicitly unlocked" % self)
             self._lock.unlock()
 
+
     def lock_write(self):
         if self._lock_mode:
             if self._lock_mode != 'w':
@@ -388,6 +334,7 @@
         # simplicity.
         f = self.controlfile('inventory','w')
         bzrlib.xml5.serializer_v5.write_inventory(Inventory(), f)
+        
 
 
     def _check_format(self, relax_version_check):
@@ -399,8 +346,8 @@
         In the future, we might need different in-memory Branch
         classes to support downlevel branches.  But not yet.
         """
-        try:
-            fmt = self.controlfile('branch-format', 'r').read()
+	try:
+	    fmt = self.controlfile('branch-format', 'r').read()
         except IOError, e:
             if e.errno == errno.ENOENT:
                 raise NotBranchError(self.base)
@@ -414,9 +361,11 @@
 
         if (not relax_version_check
             and self._branch_format != 5):
-            raise BzrError('sorry, branch format %r not supported' % fmt,
-                           ['use a different bzr version',
-                            'or remove the .bzr directory and "bzr init" again'])
+            raise BzrError('sorry, branch format "%s" not supported; ' 
+                           'use a different bzr version, '
+                           'or run "bzr upgrade"'
+                           % fmt.rstrip('\n\r'))
+        
 
     def get_root_id(self):
         """Return the id of this branches root"""
@@ -546,7 +495,7 @@
         """Print `file` to stdout."""
         self.lock_read()
         try:
-            tree = self.revision_tree(self.get_rev_id(revno))
+            tree = self.revision_tree(self.lookup_revision(revno))
             # use inventory as it was in that revision
             file_id = tree.inventory.path2id(file)
             if not file_id:
@@ -655,8 +604,7 @@
 
         This does not necessarily imply the revision is merge
         or on the mainline."""
-        return (revision_id is None
-                or revision_id in self.revision_store)
+        return revision_id in self.revision_store
 
 
     def get_revision_xml_file(self, revision_id):
@@ -668,7 +616,7 @@
         try:
             try:
                 return self.revision_store[revision_id]
-            except (IndexError, KeyError):
+            except IndexError:
                 raise bzrlib.errors.NoSuchRevision(self, revision_id)
         finally:
             self.unlock()
@@ -714,6 +662,7 @@
 
         return compare_trees(old_tree, new_tree)
 
+        
 
     def get_revision_sha1(self, revision_id):
         """Hash the stored value of a revision, and return it."""
@@ -722,16 +671,14 @@
 
     def _get_ancestry_weave(self):
         return self.control_weaves.get_weave('ancestry')
-        
+	
 
     def get_ancestry(self, revision_id):
         """Return a list of revision-ids integrated by a revision.
         """
         # strip newlines
-        if revision_id is None:
-            return [None]
-        w = self._get_ancestry_weave()
-        return [None] + [l[:-1] for l in w.get_iter(w.lookup(revision_id))]
+	w = self._get_ancestry_weave()
+        return [l[:-1] for l in w.get_iter(w.lookup(revision_id))]
 
 
     def get_inventory_weave(self):
@@ -783,21 +730,20 @@
 
     def common_ancestor(self, other, self_revno=None, other_revno=None):
         """
-        >>> from bzrlib.commit import commit
+        >>> import commit
         >>> sb = ScratchBranch(files=['foo', 'foo~'])
         >>> sb.common_ancestor(sb) == (None, None)
         True
-        >>> commit(sb, "Committing first revision", verbose=False)
+        >>> commit.commit(sb, "Committing first revision")
         >>> sb.common_ancestor(sb)[0]
         1
         >>> clone = sb.clone()
-        >>> commit(sb, "Committing second revision", verbose=False)
+        >>> commit.commit(sb, "Committing second revision")
         >>> sb.common_ancestor(sb)[0]
         2
         >>> sb.common_ancestor(clone)[0]
         1
-        >>> commit(clone, "Committing divergent second revision", 
-        ...               verbose=False)
+        >>> commit.commit(clone, "Committing divergent second revision")
         >>> sb.common_ancestor(clone)[0]
         1
         >>> sb.common_ancestor(clone) == clone.common_ancestor(sb)
@@ -891,39 +837,64 @@
             assert isinstance(stop_revision, int)
             if stop_revision > other_len:
                 raise bzrlib.errors.NoSuchRevision(self, stop_revision)
+        
         return other_history[self_len:stop_revision]
 
-    def update_revisions(self, other, stop_revision=None):
-        """Pull in new perfect-fit revisions."""
+
+    def update_revisions(self, other, stop_revno=None):
+        """Pull in new perfect-fit revisions.
+        """
         from bzrlib.fetch import greedy_fetch
-        from bzrlib.revision import get_intervening_revisions
-        if stop_revision is None:
-            stop_revision = other.last_revision()
+
+        if stop_revno:
+            stop_revision = other.lookup_revision(stop_revno)
+        else:
+            stop_revision = None
         greedy_fetch(to_branch=self, from_branch=other,
                      revision=stop_revision)
-        pullable_revs = self.missing_revisions(
-            other, other.revision_id_to_revno(stop_revision))
+
+        pullable_revs = self.missing_revisions(other, stop_revision)
+
         if pullable_revs:
             greedy_fetch(to_branch=self,
                          from_branch=other,
                          revision=pullable_revs[-1])
             self.append_revision(*pullable_revs)
-    
+
 
     def commit(self, *args, **kw):
         from bzrlib.commit import Commit
         Commit().commit(self, *args, **kw)
-    
+        
+
+    def lookup_revision(self, revision):
+        """Return the revision identifier for a given revision information."""
+        revno, info = self._get_revision_info(revision)
+        return info
+
+
     def revision_id_to_revno(self, revision_id):
         """Given a revision id, return its revno"""
-        if revision_id is None:
-            return 0
         history = self.revision_history()
         try:
             return history.index(revision_id) + 1
         except ValueError:
             raise bzrlib.errors.NoSuchRevision(self, revision_id)
 
+
+    def get_revision_info(self, revision):
+        """Return (revno, revision id) for revision identifier.
+
+        revision can be an integer, in which case it is assumed to be revno (though
+            this will translate negative values into positive ones)
+        revision can also be a string, in which case it is parsed for something like
+            'date:' or 'revid:' etc.
+        """
+        revno, rev_id = self._get_revision_info(revision)
+        if revno is None:
+            raise bzrlib.errors.NoSuchRevision(self, revision)
+        return revno, rev_id
+
     def get_rev_id(self, revno, history=None):
         """Find the revision id of the specified revno."""
         if revno == 0:
@@ -934,6 +905,172 @@
             raise bzrlib.errors.NoSuchRevision(self, revno)
         return history[revno - 1]
 
+    def _get_revision_info(self, revision):
+        """Return (revno, revision id) for revision specifier.
+
+        revision can be an integer, in which case it is assumed to be revno
+        (though this will translate negative values into positive ones)
+        revision can also be a string, in which case it is parsed for something
+        like 'date:' or 'revid:' etc.
+
+        A revid is always returned.  If it is None, the specifier referred to
+        the null revision.  If the revid does not occur in the revision
+        history, revno will be None.
+        """
+        
+        if revision is None:
+            return 0, None
+        revno = None
+        try:# Convert to int if possible
+            revision = int(revision)
+        except ValueError:
+            pass
+        revs = self.revision_history()
+        if isinstance(revision, int):
+            if revision < 0:
+                revno = len(revs) + revision + 1
+            else:
+                revno = revision
+            rev_id = self.get_rev_id(revno, revs)
+        elif isinstance(revision, basestring):
+            for prefix, func in Branch.REVISION_NAMESPACES.iteritems():
+                if revision.startswith(prefix):
+                    result = func(self, revs, revision)
+                    if len(result) > 1:
+                        revno, rev_id = result
+                    else:
+                        revno = result[0]
+                        rev_id = self.get_rev_id(revno, revs)
+                    break
+            else:
+                raise BzrError('No namespace registered for string: %r' %
+                               revision)
+        else:
+            raise TypeError('Unhandled revision type %s' % revision)
+
+        if revno is None:
+            if rev_id is None:
+                raise bzrlib.errors.NoSuchRevision(self, revision)
+        return revno, rev_id
+
+    def _namespace_revno(self, revs, revision):
+        """Lookup a revision by revision number"""
+        assert revision.startswith('revno:')
+        try:
+            return (int(revision[6:]),)
+        except ValueError:
+            return None
+    REVISION_NAMESPACES['revno:'] = _namespace_revno
+
+    def _namespace_revid(self, revs, revision):
+        assert revision.startswith('revid:')
+        rev_id = revision[len('revid:'):]
+        try:
+            return revs.index(rev_id) + 1, rev_id
+        except ValueError:
+            return None, rev_id
+    REVISION_NAMESPACES['revid:'] = _namespace_revid
+
+    def _namespace_last(self, revs, revision):
+        assert revision.startswith('last:')
+        try:
+            offset = int(revision[5:])
+        except ValueError:
+            return (None,)
+        else:
+            if offset <= 0:
+                raise BzrError('You must supply a positive value for --revision last:XXX')
+            return (len(revs) - offset + 1,)
+    REVISION_NAMESPACES['last:'] = _namespace_last
+
+    def _namespace_tag(self, revs, revision):
+        assert revision.startswith('tag:')
+        raise BzrError('tag: namespace registered, but not implemented.')
+    REVISION_NAMESPACES['tag:'] = _namespace_tag
+
+    def _namespace_date(self, revs, revision):
+        assert revision.startswith('date:')
+        import datetime
+        # Spec for date revisions:
+        #   date:value
+        #   value can be 'yesterday', 'today', 'tomorrow' or a YYYY-MM-DD string.
+        #   it can also start with a '+/-/='. '+' says match the first
+        #   entry after the given date. '-' is match the first entry before the date
+        #   '=' is match the first entry after, but still on the given date.
+        #
+        #   +2005-05-12 says find the first matching entry after May 12th, 2005 at 0:00
+        #   -2005-05-12 says find the first matching entry before May 12th, 2005 at 0:00
+        #   =2005-05-12 says find the first match after May 12th, 2005 at 0:00 but before
+        #       May 13th, 2005 at 0:00
+        #
+        #   So the proper way of saying 'give me all entries for today' is:
+        #       -r {date:+today}:{date:-tomorrow}
+        #   The default is '=' when not supplied
+        val = revision[5:]
+        match_style = '='
+        if val[:1] in ('+', '-', '='):
+            match_style = val[:1]
+            val = val[1:]
+
+        today = datetime.datetime.today().replace(hour=0,minute=0,second=0,microsecond=0)
+        if val.lower() == 'yesterday':
+            dt = today - datetime.timedelta(days=1)
+        elif val.lower() == 'today':
+            dt = today
+        elif val.lower() == 'tomorrow':
+            dt = today + datetime.timedelta(days=1)
+        else:
+            import re
+            # This should be done outside the function to avoid recompiling it.
+            _date_re = re.compile(
+                    r'(?P<date>(?P<year>\d\d\d\d)-(?P<month>\d\d)-(?P<day>\d\d))?'
+                    r'(,|T)?\s*'
+                    r'(?P<time>(?P<hour>\d\d):(?P<minute>\d\d)(:(?P<second>\d\d))?)?'
+                )
+            m = _date_re.match(val)
+            if not m or (not m.group('date') and not m.group('time')):
+                raise BzrError('Invalid revision date %r' % revision)
+
+            if m.group('date'):
+                year, month, day = int(m.group('year')), int(m.group('month')), int(m.group('day'))
+            else:
+                year, month, day = today.year, today.month, today.day
+            if m.group('time'):
+                hour = int(m.group('hour'))
+                minute = int(m.group('minute'))
+                if m.group('second'):
+                    second = int(m.group('second'))
+                else:
+                    second = 0
+            else:
+                hour, minute, second = 0,0,0
+
+            dt = datetime.datetime(year=year, month=month, day=day,
+                    hour=hour, minute=minute, second=second)
+        first = dt
+        last = None
+        reversed = False
+        if match_style == '-':
+            reversed = True
+        elif match_style == '=':
+            last = dt + datetime.timedelta(days=1)
+
+        if reversed:
+            for i in range(len(revs)-1, -1, -1):
+                r = self.get_revision(revs[i])
+                # TODO: Handle timezone.
+                dt = datetime.datetime.fromtimestamp(r.timestamp)
+                if first >= dt and (last is None or dt >= last):
+                    return (i+1,)
+        else:
+            for i in range(len(revs)):
+                r = self.get_revision(revs[i])
+                # TODO: Handle timezone.
+                dt = datetime.datetime.fromtimestamp(r.timestamp)
+                if first <= dt and (last is None or dt <= last):
+                    return (i+1,)
+    REVISION_NAMESPACES['date:'] = _namespace_date
+
     def revision_tree(self, revision_id):
         """Return Tree for a revision on this branch.
 
@@ -950,7 +1087,7 @@
 
     def working_tree(self):
         """Return a `Tree` for the working copy."""
-        from bzrlib.workingtree import WorkingTree
+        from workingtree import WorkingTree
         return WorkingTree(self.base, self.read_working_inventory())
 
 
@@ -1000,7 +1137,7 @@
             from_abs = self.abspath(from_rel)
             to_abs = self.abspath(to_rel)
             try:
-                rename(from_abs, to_abs)
+                os.rename(from_abs, to_abs)
             except OSError, e:
                 raise BzrError("failed to rename %r to %r: %s"
                         % (from_abs, to_abs, e[1]),
@@ -1069,7 +1206,7 @@
                 result.append((f, dest_path))
                 inv.rename(inv.path2id(f), to_dir_id, name_tail)
                 try:
-                    rename(self.abspath(f), self.abspath(dest_path))
+                    os.rename(self.abspath(f), self.abspath(dest_path))
                 except OSError, e:
                     raise BzrError("failed to rename %r to %r: %s" % (f, dest_path, e[1]),
                             ["rename rolled back"])
@@ -1215,10 +1352,9 @@
             raise InvalidRevisionNumber(revno)
         
         
-        
-
-
-class ScratchBranch(LocalBranch):
+
+
+class ScratchBranch(Branch):
     """Special test class: a branch that cleans up after itself.
 
     >>> b = ScratchBranch()
@@ -1241,7 +1377,7 @@
         if base is None:
             base = mkdtemp()
             init = True
-        LocalBranch.__init__(self, base, init=init)
+        Branch.__init__(self, base, init=init)
         for d in dirs:
             os.mkdir(self.abspath(d))
             
@@ -1253,11 +1389,7 @@
         """
         >>> orig = ScratchBranch(files=["file1", "file2"])
         >>> clone = orig.clone()
-        >>> if os.name != 'nt':
-        ...   os.path.samefile(orig.base, clone.base)
-        ... else:
-        ...   orig.base == clone.base
-        ...
+        >>> os.path.samefile(orig.base, clone.base)
         False
         >>> os.path.isfile(os.path.join(clone.base, "file1"))
         True
@@ -1346,41 +1478,45 @@
     return gen_file_id('TREE_ROOT')
 
 
-def copy_branch(branch_from, to_location, revision=None, basis_branch=None):
+def pull_loc(branch):
+    # TODO: Should perhaps just make attribute be 'base' in
+    # RemoteBranch and Branch?
+    if hasattr(branch, "baseurl"):
+        return branch.baseurl
+    else:
+        return branch.base
+
+
+def copy_branch(branch_from, to_location, revision=None):
     """Copy branch_from into the existing directory to_location.
 
     revision
         If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.  Must be a
-        revid or None.
+        The head of the new branch will be that revision.  Can be a
+        revno or revid.
 
     to_location
         The name of a local directory that exists but is empty.
-
-    revno
-        The revision to copy up to
-
-    basis_branch
-        A local branch to copy revisions from, related to branch_from
     """
     # TODO: This could be done *much* more efficiently by just copying
     # all the whole weaves and revisions, rather than getting one
     # revision at a time.
     from bzrlib.merge import merge
+    from bzrlib.branch import Branch
 
     assert isinstance(branch_from, Branch)
     assert isinstance(to_location, basestring)
     
-    br_to = Branch.initialize(to_location)
-    mutter("copy branch from %s to %s", branch_from, br_to)
-    if basis_branch is not None:
-        basis_branch.push_stores(br_to)
+    br_to = Branch(to_location, init=True)
     br_to.set_root_id(branch_from.get_root_id())
     if revision is None:
-        revision = branch_from.last_revision()
-    br_to.update_revisions(branch_from, stop_revision=revision)
+        revno = None
+    else:
+        revno, rev_id = branch_from.get_revision_info(revision)
+    br_to.update_revisions(branch_from, stop_revno=revno)
     merge((to_location, -1), (to_location, 0), this_dir=to_location,
           check_clean=False, ignore_zero=True)
-    br_to.set_parent(branch_from.base)
-    mutter("copied")
-    return br_to
+    
+    from_location = pull_loc(branch_from)
+    br_to.set_parent(pull_loc(branch_from))
+

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-09-28 09:35:50 +0000
+++ bzrlib/builtins.py	2005-09-22 11:57:15 +0000
@@ -22,7 +22,7 @@
 import bzrlib.trace
 from bzrlib.trace import mutter, note, log_error, warning
 from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError, NotBranchError
-from bzrlib.branch import Branch
+from bzrlib.branch import find_branch
 from bzrlib import BZRDIR
 from bzrlib.commands import Command
 
@@ -63,67 +63,45 @@
     files or directories is reported.  If a directory is given, status
     is reported for everything inside that directory.
 
-    If a revision argument is given, the status is calculated against
-    that revision, or between two revisions if two are provided.
+    If a revision is specified, the changes since that revision are shown.
     """
-    # XXX: FIXME: bzr status should accept a -r option to show changes
-    # relative to a revision, or between revisions
-
     takes_args = ['file*']
     takes_options = ['all', 'show-ids', 'revision']
     aliases = ['st', 'stat']
     
-    def run(self, all=False, show_ids=False, file_list=None, revision=None):
+    def run(self, all=False, show_ids=False, file_list=None):
         if file_list:
-            b = Branch.open_containing(file_list[0])
+            b = find_branch(file_list[0])
             file_list = [b.relpath(x) for x in file_list]
             # special case: only one path was given and it's the root
             # of the branch
             if file_list == ['']:
                 file_list = None
         else:
-            b = Branch.open_containing('.')
+            b = find_branch('.')
             
         from bzrlib.status import show_status
         show_status(b, show_unchanged=all, show_ids=show_ids,
-                    specific_files=file_list, revision=revision)
+                    specific_files=file_list)
 
 
 class cmd_cat_revision(Command):
-    """Write out metadata for a revision.
-    
-    The revision to print can either be specified by a specific
-    revision identifier, or you can use --revision.
-    """
+    """Write out metadata for a revision."""
 
     hidden = True
-    takes_args = ['revision_id?']
-    takes_options = ['revision']
+    takes_args = ['revision_id']
     
-    def run(self, revision_id=None, revision=None):
-        from bzrlib.revisionspec import RevisionSpec
+    def run(self, revision_id):
+        b = find_branch('.')
+        sys.stdout.write(b.get_revision_xml_file(revision_id).read())
 
-        if revision_id is not None and revision is not None:
-            raise BzrCommandError('You can only supply one of revision_id or --revision')
-        if revision_id is None and revision is None:
-            raise BzrCommandError('You must supply either --revision or a revision_id')
-        b = Branch.open_containing('.')
-        if revision_id is not None:
-            sys.stdout.write(b.get_revision_xml_file(revision_id).read())
-        elif revision is not None:
-            for rev in revision:
-                if rev is None:
-                    raise BzrCommandError('You cannot specify a NULL revision.')
-                revno, rev_id = rev.in_history(b)
-                sys.stdout.write(b.get_revision_xml_file(rev_id).read())
-    
 
 class cmd_revno(Command):
     """Show current revision number.
 
     This is equal to the number of revisions on this branch."""
     def run(self):
-        print Branch.open_containing('.').revno()
+        print find_branch('.').revno()
 
 
 class cmd_revision_info(Command):
@@ -132,26 +110,21 @@
     hidden = True
     takes_args = ['revision_info*']
     takes_options = ['revision']
-    def run(self, revision=None, revision_info_list=[]):
-        from bzrlib.revisionspec import RevisionSpec
+    def run(self, revision=None, revision_info_list=None):
+        from bzrlib.branch import find_branch
 
         revs = []
         if revision is not None:
             revs.extend(revision)
         if revision_info_list is not None:
-            for rev in revision_info_list:
-                revs.append(RevisionSpec(rev))
+            revs.extend(revision_info_list)
         if len(revs) == 0:
             raise BzrCommandError('You must supply a revision identifier')
 
-        b = Branch.open_containing('.')
+        b = find_branch('.')
 
         for rev in revs:
-            revinfo = rev.in_history(b)
-            if revinfo.revno is None:
-                print '     %s' % revinfo.rev_id
-            else:
-                print '%4d %s' % (revinfo.revno, revinfo.rev_id)
+            print '%4d %s' % b.get_revision_info(rev)
 
     
 class cmd_add(Command):
@@ -172,10 +145,8 @@
     Therefore simply saying 'bzr add' will version all files that
     are currently unknown.
 
-    Adding a file whose parent directory is not versioned will
-    implicitly add the parent, and so on up to the root. This means
-    you should never need to explictly add a directory, they'll just
-    get added when you add a file in the directory.
+    TODO: Perhaps adding a file whose directly is not versioned should
+    recursively add that parent, rather than giving an error?
     """
     takes_args = ['file*']
     takes_options = ['verbose', 'no-recurse']
@@ -200,7 +171,7 @@
         for d in dir_list:
             os.mkdir(d)
             if not b:
-                b = Branch.open_containing(d)
+                b = find_branch(d)
             b.add([d])
             print 'added', d
 
@@ -211,7 +182,7 @@
     hidden = True
     
     def run(self, filename):
-        print Branch.open_containing(filename).relpath(filename)
+        print find_branch(filename).relpath(filename)
 
 
 
@@ -220,14 +191,14 @@
     takes_options = ['revision', 'show-ids']
     
     def run(self, revision=None, show_ids=False):
-        b = Branch.open_containing('.')
-        if revision is None:
+        b = find_branch('.')
+        if revision == None:
             inv = b.read_working_inventory()
         else:
             if len(revision) > 1:
                 raise BzrCommandError('bzr inventory --revision takes'
                     ' exactly one revision identifier')
-            inv = b.get_revision_inventory(revision[0].in_history(b).rev_id)
+            inv = b.get_revision_inventory(b.lookup_revision(revision[0]))
 
         for path, entry in inv.entries():
             if show_ids:
@@ -246,7 +217,7 @@
     """
     takes_args = ['source$', 'dest']
     def run(self, source_list, dest):
-        b = Branch.open_containing('.')
+        b = find_branch('.')
 
         # TODO: glob expansion on windows?
         b.move([b.relpath(s) for s in source_list], b.relpath(dest))
@@ -269,7 +240,7 @@
     takes_args = ['from_name', 'to_name']
     
     def run(self, from_name, to_name):
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         b.rename_one(b.relpath(from_name), b.relpath(to_name))
 
 
@@ -291,7 +262,7 @@
     def run(self, names_list):
         if len(names_list) < 2:
             raise BzrCommandError("missing file argument")
-        b = Branch.open_containing(names_list[0])
+        b = find_branch(names_list[0])
 
         rel_names = [b.relpath(x) for x in names_list]
         
@@ -303,8 +274,8 @@
             if len(names_list) != 2:
                 raise BzrCommandError('to mv multiple files the destination '
                                       'must be a versioned directory')
-            b.rename_one(rel_names[0], rel_names[1])
-            print "%s => %s" % (rel_names[0], rel_names[1])
+            for pair in b.move(rel_names[0], rel_names[1]):
+                print "%s => %s" % pair
             
     
 
@@ -330,9 +301,15 @@
         import tempfile
         from shutil import rmtree
         import errno
+        from bzrlib.branch import pull_loc
         
-        br_to = Branch.open_containing('.')
-        stored_loc = br_to.get_parent()
+        br_to = find_branch('.')
+        stored_loc = None
+        try:
+            stored_loc = br_to.controlfile("x-pull", "rb").read().rstrip('\n')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
         if location is None:
             if stored_loc is None:
                 raise BzrCommandError("No pull location known or specified.")
@@ -340,15 +317,14 @@
                 print "Using last location: %s" % stored_loc
                 location = stored_loc
         cache_root = tempfile.mkdtemp()
-        from bzrlib.errors import DivergedBranches
-        br_from = Branch.open_containing(location)
-        location = br_from.base
+        from bzrlib.branch import DivergedBranches
+        br_from = find_branch(location)
+        location = pull_loc(br_from)
         old_revno = br_to.revno()
         try:
-            from bzrlib.errors import DivergedBranches
-            br_from = Branch.open(location)
-            br_from.setup_caching(cache_root)
-            location = br_from.base
+            from branch import find_cached_branch, DivergedBranches
+            br_from = find_cached_branch(location, cache_root)
+            location = pull_loc(br_from)
             old_revno = br_to.revno()
             try:
                 br_to.update_revisions(br_from)
@@ -358,7 +334,7 @@
                 
             merge(('.', -1), ('.', old_revno), check_clean=False)
             if location != stored_loc:
-                br_to.set_parent(location)
+                br_to.controlfile("x-pull", "wb").write(location + "\n")
         finally:
             rmtree(cache_root)
 
@@ -372,17 +348,13 @@
 
     To retrieve the branch as of a particular revision, supply the --revision
     parameter, as in "branch foo/bar -r 5".
-
-    --basis is to speed up branching from remote branches.  When specified, it
-    copies all the file-contents, inventory and revision data from the basis
-    branch before copying anything from the remote branch.
     """
     takes_args = ['from_location', 'to_location?']
-    takes_options = ['revision', 'basis']
+    takes_options = ['revision']
     aliases = ['get', 'clone']
 
-    def run(self, from_location, to_location=None, revision=None, basis=None):
-        from bzrlib.branch import copy_branch
+    def run(self, from_location, to_location=None, revision=None):
+        from bzrlib.branch import copy_branch, find_cached_branch
         import tempfile
         import errno
         from shutil import rmtree
@@ -394,22 +366,13 @@
                 raise BzrCommandError(
                     'bzr branch --revision takes exactly 1 revision value')
             try:
-                br_from = Branch.open(from_location)
+                br_from = find_cached_branch(from_location, cache_root)
             except OSError, e:
                 if e.errno == errno.ENOENT:
                     raise BzrCommandError('Source location "%s" does not'
                                           ' exist.' % to_location)
                 else:
                     raise
-            br_from.setup_caching(cache_root)
-            if basis is not None:
-                basis_branch = Branch.open_containing(basis)
-            else:
-                basis_branch = None
-            if len(revision) == 1 and revision[0] is not None:
-                revision_id = revision[0].in_history(br_from)[1]
-            else:
-                revision_id = None
             if to_location is None:
                 to_location = os.path.basename(from_location.rstrip("/\\"))
             try:
@@ -424,13 +387,11 @@
                 else:
                     raise
             try:
-                copy_branch(br_from, to_location, revision_id, basis_branch)
+                copy_branch(br_from, to_location, revision[0])
             except bzrlib.errors.NoSuchRevision:
                 rmtree(to_location)
                 msg = "The branch %s has no revision %d." % (from_location, revision[0])
                 raise BzrCommandError(msg)
-            except bzrlib.errors.UnlistableBranch:
-                msg = "The branch %s cannot be used as a --basis"
         finally:
             rmtree(cache_root)
 
@@ -445,7 +406,7 @@
     takes_args = ['dir?']
 
     def run(self, dir='.'):
-        b = Branch.open_containing(dir)
+        b = find_branch(dir)
         old_inv = b.basis_tree().inventory
         new_inv = b.read_working_inventory()
 
@@ -462,7 +423,7 @@
     def run(self, branch=None):
         import info
 
-        b = Branch.open_containing(branch)
+        b = find_branch(branch)
         info.show_info(b)
 
 
@@ -476,7 +437,7 @@
     takes_options = ['verbose']
     
     def run(self, file_list, verbose=False):
-        b = Branch.open_containing(file_list[0])
+        b = find_branch(file_list[0])
         b.remove([b.relpath(f) for f in file_list], verbose=verbose)
 
 
@@ -490,7 +451,7 @@
     hidden = True
     takes_args = ['filename']
     def run(self, filename):
-        b = Branch.open_containing(filename)
+        b = find_branch(filename)
         i = b.inventory.path2id(b.relpath(filename))
         if i == None:
             raise BzrError("%r is not a versioned file" % filename)
@@ -506,7 +467,7 @@
     hidden = True
     takes_args = ['filename']
     def run(self, filename):
-        b = Branch.open_containing(filename)
+        b = find_branch(filename)
         inv = b.inventory
         fid = inv.path2id(b.relpath(filename))
         if fid == None:
@@ -519,7 +480,7 @@
     """Display list of revision ids on this branch."""
     hidden = True
     def run(self):
-        for patchid in Branch.open_containing('.').revision_history():
+        for patchid in find_branch('.').revision_history():
             print patchid
 
 
@@ -535,7 +496,7 @@
 class cmd_directories(Command):
     """Display list of versioned directories in this branch."""
     def run(self):
-        for name, ie in Branch.open_containing('.').read_working_inventory().directories():
+        for name, ie in find_branch('.').read_working_inventory().directories():
             if name == '':
                 print '.'
             else:
@@ -557,7 +518,7 @@
     """
     def run(self):
         from bzrlib.branch import Branch
-        Branch.initialize('.')
+        Branch('.', init=True)
 
 
 class cmd_diff(Command):
@@ -584,7 +545,7 @@
     examples:
         bzr diff
         bzr diff -r1
-        bzr diff -r1..2
+        bzr diff -r1:2
     """
     
     takes_args = ['file*']
@@ -595,13 +556,13 @@
         from bzrlib.diff import show_diff
 
         if file_list:
-            b = Branch.open_containing(file_list[0])
+            b = find_branch(file_list[0])
             file_list = [b.relpath(f) for f in file_list]
             if file_list == ['']:
                 # just pointing to top-of-tree
                 file_list = None
         else:
-            b = Branch.open_containing('.')
+            b = find_branch('.')
 
         if revision is not None:
             if len(revision) == 1:
@@ -626,7 +587,7 @@
     TODO: Show files deleted since a previous revision, or between two revisions.
     """
     def run(self, show_ids=False):
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         old = b.basis_tree()
         new = b.working_tree()
 
@@ -649,7 +610,7 @@
     def run(self):
         from bzrlib.delta import compare_trees
 
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         td = compare_trees(b.basis_tree(), b.working_tree())
 
         for path, id, kind in td.modified:
@@ -661,7 +622,7 @@
     """List files added in working tree."""
     hidden = True
     def run(self):
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         wt = b.working_tree()
         basis_inv = b.basis_tree().inventory
         inv = wt.inventory
@@ -683,8 +644,8 @@
     takes_args = ['filename?']
     def run(self, filename=None):
         """Print the branch root."""
-        b = Branch.open_containing(filename)
-        print b.base
+        b = find_branch(filename)
+        print getattr(b, 'base', None) or getattr(b, 'baseurl')
 
 
 class cmd_log(Command):
@@ -719,24 +680,24 @@
         direction = (forward and 'forward') or 'reverse'
         
         if filename:
-            b = Branch.open_containing(filename)
+            b = find_branch(filename)
             fp = b.relpath(filename)
             if fp:
                 file_id = b.read_working_inventory().path2id(fp)
             else:
                 file_id = None  # points to branch root
         else:
-            b = Branch.open_containing('.')
+            b = find_branch('.')
             file_id = None
 
         if revision is None:
             rev1 = None
             rev2 = None
         elif len(revision) == 1:
-            rev1 = rev2 = revision[0].in_history(b).revno
+            rev1 = rev2 = b.get_revision_info(revision[0])[0]
         elif len(revision) == 2:
-            rev1 = revision[0].in_history(b).revno
-            rev2 = revision[1].in_history(b).revno
+            rev1 = b.get_revision_info(revision[0])[0]
+            rev2 = b.get_revision_info(revision[1])[0]
         else:
             raise BzrCommandError('bzr log --revision takes one or two values.')
 
@@ -778,7 +739,7 @@
     hidden = True
     takes_args = ["filename"]
     def run(self, filename):
-        b = Branch.open_containing(filename)
+        b = find_branch(filename)
         inv = b.read_working_inventory()
         file_id = inv.path2id(b.relpath(filename))
         for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
@@ -792,11 +753,11 @@
     """
     hidden = True
     def run(self, revision=None, verbose=False):
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         if revision == None:
             tree = b.working_tree()
         else:
-            tree = b.revision_tree(revision.in_history(b).rev_id)
+            tree = b.revision_tree(b.lookup_revision(revision))
 
         for fp, fc, kind, fid in tree.list_files():
             if verbose:
@@ -817,7 +778,7 @@
     """List unknown files."""
     def run(self):
         from bzrlib.osutils import quotefn
-        for f in Branch.open_containing('.').unknowns():
+        for f in find_branch('.').unknowns():
             print quotefn(f)
 
 
@@ -845,7 +806,7 @@
         from bzrlib.atomicfile import AtomicFile
         import os.path
 
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         ifn = b.abspath('.bzrignore')
 
         if os.path.exists(ifn):
@@ -885,7 +846,7 @@
 
     See also: bzr ignore"""
     def run(self):
-        tree = Branch.open_containing('.').working_tree()
+        tree = find_branch('.').working_tree()
         for path, file_class, kind, file_id in tree.list_files():
             if file_class != 'I':
                 continue
@@ -909,7 +870,7 @@
         except ValueError:
             raise BzrCommandError("not a valid revision-number: %r" % revno)
 
-        print Branch.open_containing('.').get_rev_id(revno)
+        print find_branch('.').lookup_revision(revno)
 
 
 class cmd_export(Command):
@@ -928,13 +889,13 @@
     takes_options = ['revision', 'format', 'root']
     def run(self, dest, revision=None, format=None, root=None):
         import os.path
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         if revision is None:
             rev_id = b.last_revision()
         else:
             if len(revision) != 1:
                 raise BzrError('bzr export --revision takes exactly 1 argument')
-            rev_id = revision[0].in_history(b).rev_id
+            revno, rev_id = b.get_revision_info(revision[0])
         t = b.revision_tree(rev_id)
         root, ext = os.path.splitext(dest)
         if not format:
@@ -956,12 +917,12 @@
     takes_args = ['filename']
 
     def run(self, filename, revision=None):
-        if revision is None:
+        if revision == None:
             raise BzrCommandError("bzr cat requires a revision number")
         elif len(revision) != 1:
             raise BzrCommandError("bzr cat --revision takes exactly one number")
-        b = Branch.open_containing('.')
-        b.print_file(b.relpath(filename), revision[0].in_history(b).revno)
+        b = find_branch('.')
+        b.print_file(b.relpath(filename), revision[0])
 
 
 class cmd_local_time_offset(Command):
@@ -1004,7 +965,7 @@
         from bzrlib.status import show_status
         from cStringIO import StringIO
 
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         if selected_list:
             selected_list = [b.relpath(s) for s in selected_list]
             
@@ -1040,13 +1001,16 @@
 
     This command checks various invariants about the branch storage to
     detect data corruption or bzr bugs.
+
+    If given the --update flag, it will update some optional fields
+    to help ensure data consistency.
     """
     takes_args = ['dir?']
 
     def run(self, dir='.'):
         from bzrlib.check import check
 
-        check(Branch.open_containing(dir))
+        check(find_branch(dir))
 
 
 class cmd_scan_cache(Command):
@@ -1085,13 +1049,14 @@
         upgrade(dir)
 
 
+
 class cmd_whoami(Command):
     """Show bzr user id."""
     takes_options = ['email']
     
     def run(self, email=False):
         try:
-            b = bzrlib.branch.Branch.open_containing('.')
+            b = bzrlib.branch.find_branch('.')
         except NotBranchError:
             b = None
         
@@ -1163,8 +1128,8 @@
     def run(self, branch, other):
         from bzrlib.revision import common_ancestor, MultipleRevisionSources
         
-        branch1 = Branch.open_containing(branch)
-        branch2 = Branch.open_containing(other)
+        branch1 = find_branch(branch)
+        branch2 = find_branch(other)
 
         history_1 = branch1.revision_history()
         history_2 = branch2.revision_history()
@@ -1233,18 +1198,15 @@
             other = [branch, -1]
         else:
             if len(revision) == 1:
+                other = [branch, revision[0]]
                 base = [None, None]
-                other = [branch, revision[0].in_history(branch).revno]
             else:
                 assert len(revision) == 2
                 if None in revision:
                     raise BzrCommandError(
                         "Merge doesn't permit that revision specifier.")
-                from bzrlib.branch import Branch
-                b = Branch.open(branch)
-
-                base = [branch, revision[0].in_history(b).revno]
-                other = [branch, revision[1].in_history(b).revno]
+                base = [branch, revision[0]]
+                other = [branch, revision[1]]
 
         try:
             merge(other, base, check_clean=(not force), merge_type=merge_type)
@@ -1278,19 +1240,16 @@
             if len(file_list) == 0:
                 raise BzrCommandError("No files specified")
         if revision is None:
-            revno = -1
+            revision = [-1]
         elif len(revision) != 1:
             raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
-        else:
-            b = Branch.open_containing('.')
-            revno = revision[0].in_history(b).revno
-        merge(('.', revno), parse_spec('.'),
+        merge(('.', revision[0]), parse_spec('.'),
               check_clean=False,
               ignore_zero=True,
               backup_files=not no_backup,
               file_list=file_list)
         if not file_list:
-            Branch.open_containing('.').set_pending_merges([])
+            Branch('.').set_pending_merges([])
 
 
 class cmd_assert_fail(Command):
@@ -1362,7 +1321,7 @@
         if verbose and quiet:
             raise BzrCommandError('Cannot pass both quiet and verbose')
 
-        b = Branch.open_containing('.')
+        b = find_branch('.')
         parent = b.get_parent()
         if remote is None:
             if parent is None:
@@ -1372,10 +1331,9 @@
                     print "Using last location: %s" % parent
                 remote = parent
         elif parent is None:
-            # We only update parent if it did not exist, missing
-            # should not change the parent
-            b.set_parent(remote)
-        br_remote = Branch.open_containing(remote)
+            # We only update x-pull if it did not exist, missing should not change the parent
+            b.controlfile('x-pull', 'wb').write(remote + '\n')
+        br_remote = find_branch(remote)
 
         return show_missing(b, br_remote, verbose=verbose, quiet=quiet)
 

=== modified file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2005-09-26 08:56:15 +0000
+++ bzrlib/changeset.py	2005-08-27 04:42:41 +0000
@@ -18,7 +18,6 @@
 import patch
 import stat
 from bzrlib.trace import mutter
-from bzrlib.osutils import rename
 
 # XXX: mbp: I'm not totally convinced that we should handle conflicts
 # as part of changeset application, rather than only in the merge
@@ -43,6 +42,7 @@
         newdict[value] = key
     return newdict
 
+
        
 class ChangeUnixPermissions(object):
     """This is two-way change, suitable for file modification, creation,
@@ -92,7 +92,6 @@
     def __ne__(self, other):
         return not (self == other)
 
-
 def dir_create(filename, conflict_handler, reverse):
     """Creates the directory, or deletes it if reverse is true.  Intended to be
     used with ReplaceContents.
@@ -118,12 +117,14 @@
         try:
             os.rmdir(filename)
         except OSError, e:
-            if e.errno != errno.ENOTEMPTY:
+            if e.errno != 39:
                 raise
             if conflict_handler.rmdir_non_empty(filename) == "skip":
                 return
             os.rmdir(filename)
 
+                
+            
 
 class SymlinkCreate(object):
     """Creates or deletes a symlink (for use with ReplaceContents)"""
@@ -352,7 +353,7 @@
         status = patch.diff3(new_file, filename, base, other)
         if status == 0:
             os.chmod(new_file, os.stat(filename).st_mode)
-            rename(new_file, filename)
+            os.rename(new_file, filename)
             return
         else:
             assert(status == 1)
@@ -830,7 +831,7 @@
             if src_path is not None:
                 src_path = os.path.join(dir, src_path)
                 try:
-                    rename(src_path, to_name)
+                    os.rename(src_path, to_name)
                     temp_name[entry.id] = to_name
                 except OSError, e:
                     if e.errno != errno.ENOENT:
@@ -873,7 +874,7 @@
             if old_path is None:
                 continue
             try:
-                rename(old_path, new_path)
+                os.rename(old_path, new_path)
                 changed_inventory[entry.id] = new_tree_path
             except OSError, e:
                 raise Exception ("%s is missing" % new_path)
@@ -1002,6 +1003,9 @@
     descend from this class if they have a better way to handle some or
     all types of conflict.
     """
+    def __init__(self, dir):
+        self.dir = dir
+    
     def missing_parent(self, pathname):
         parent = os.path.dirname(pathname)
         raise Exception("Parent directory missing for %s" % pathname)
@@ -1080,7 +1084,7 @@
     :rtype: Dictionary
     """
     if conflict_handler is None:
-        conflict_handler = ExceptionConflictHandler()
+        conflict_handler = ExceptionConflictHandler(dir)
     temp_dir = os.path.join(dir, "bzr-tree-change")
     try:
         os.mkdir(temp_dir)

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-09-27 07:24:40 +0000
+++ bzrlib/check.py	2005-09-22 07:14:40 +0000
@@ -39,23 +39,21 @@
     """Check a branch"""
     def __init__(self, branch):
         self.branch = branch
-        branch.lock_read()
-        try:
-            branch.weave_store.enable_cache = True
-            branch.control_weaves.enable_cache = True
-            self.run()
-        finally:
-            branch.unlock()
-            branch.weave_store.enable_cache = False
-            branch.control_weaves.enable_cache = False
+	branch.lock_read()
+	try:
+	    self.run()
+	finally:
+   	    branch.unlock()
 
 
     def run(self):
         branch = self.branch
 
+	branch.weave_store.enable_cache = True
+	branch.control_weaves.enable_cache = True
 
-        self.checked_text_cnt = 0
-        self.checked_rev_cnt = 0
+	self.checked_text_cnt = 0
+	self.checked_rev_cnt = 0
         self.repeated_text_cnt = 0
         self.missing_inventory_sha_cnt = 0
         self.missing_revision_cnt = 0
@@ -71,100 +69,100 @@
         for rev_id in history:
             self.progress.update('checking revision', revno, revcount)
             revno += 1
-            self.check_one_rev(rev_id, last_rev_id)
-            last_rev_id = rev_id
+	    self.check_one_rev(rev_id, last_rev_id)
+	    last_rev_id = rev_id
         self.progress.clear()
-        self.report_results()
+	self.report_results()
 
 
     def report_results(self):
-        note('checked branch %s format %d',
-             self.branch.base, 
-             self.branch._branch_format)
+	note('checked branch %s format %d',
+	     self.branch.base, 
+	     self.branch._branch_format)
 
         note('%6d revisions', self.checked_rev_cnt)
         note('%6d unique file texts', self.checked_text_cnt)
         note('%6d repeated file texts', self.repeated_text_cnt)
         if self.missing_inventory_sha_cnt:
             note('%d revisions are missing inventory_sha1',
-                 self.missing_inventory_sha_cnt)
+		 self.missing_inventory_sha_cnt)
         if self.missing_revision_cnt:
             note('%d revisions are mentioned but not present',
-                 self.missing_revision_cnt)
+		 self.missing_revision_cnt)
 
 
     def check_one_rev(self, rev_id, last_rev_id):
-        """Check one revision.
-
-        rev_id - the one to check
-
-        last_rev_id - the previous one on the mainline, if any.
-        """
-
-        # mutter('    revision {%s}' % rev_id)
-        branch = self.branch
-        rev = branch.get_revision(rev_id)
-        if rev.revision_id != rev_id:
-            raise BzrCheckError('wrong internal revision id in revision {%s}'
-                                % rev_id)
-
-        # check the previous history entry is a parent of this entry
-        if rev.parent_ids:
-            if last_rev_id is None:
-                raise BzrCheckError("revision {%s} has %d parents, but is the "
-                                    "start of the branch"
-                                    % (rev_id, len(rev.parent_ids)))
-            for parent_id in rev.parent_ids:
-                if parent_id == last_rev_id:
-                    break
-            else:
-                raise BzrCheckError("previous revision {%s} not listed among "
-                                    "parents of {%s}"
-                                    % (last_rev_id, rev_id))
-        elif last_rev_id:
-            raise BzrCheckError("revision {%s} has no parents listed "
-                                "but preceded by {%s}"
-                                % (rev_id, last_rev_id))
-
-        if rev.inventory_sha1:
-            inv_sha1 = branch.get_inventory_sha1(rev_id)
-            if inv_sha1 != rev.inventory_sha1:
-                raise BzrCheckError('Inventory sha1 hash doesn\'t match'
-                    ' value in revision {%s}' % rev_id)
-        else:
-            missing_inventory_sha_cnt += 1
-            mutter("no inventory_sha1 on revision {%s}" % rev_id)
-        self._check_revision_tree(rev_id)
+	"""Check one revision.
+
+	rev_id - the one to check
+
+	last_rev_id - the previous one on the mainline, if any.
+	"""
+
+	# mutter('    revision {%s}' % rev_id)
+	branch = self.branch
+	rev = branch.get_revision(rev_id)
+	if rev.revision_id != rev_id:
+	    raise BzrCheckError('wrong internal revision id in revision {%s}'
+				% rev_id)
+
+	# check the previous history entry is a parent of this entry
+	if rev.parent_ids:
+	    if last_rev_id is None:
+		raise BzrCheckError("revision {%s} has %d parents, but is the "
+				    "start of the branch"
+				    % (rev_id, len(rev.parent_ids)))
+	    for parent_id in rev.parent_ids:
+		if parent_id == last_rev_id:
+		    break
+	    else:
+		raise BzrCheckError("previous revision {%s} not listed among "
+				    "parents of {%s}"
+				    % (last_rev_id, rev_id))
+	elif last_rev_id:
+	    raise BzrCheckError("revision {%s} has no parents listed "
+				"but preceded by {%s}"
+				% (rev_id, last_rev_id))
+
+	if rev.inventory_sha1:
+	    inv_sha1 = branch.get_inventory_sha1(rev_id)
+	    if inv_sha1 != rev.inventory_sha1:
+		raise BzrCheckError('Inventory sha1 hash doesn\'t match'
+		    ' value in revision {%s}' % rev_id)
+	else:
+	    missing_inventory_sha_cnt += 1
+	    mutter("no inventory_sha1 on revision {%s}" % rev_id)
+	self._check_revision_tree(rev_id)
         self.checked_rev_cnt += 1
 
     def _check_revision_tree(self, rev_id):
-        tree = self.branch.revision_tree(rev_id)
-        inv = tree.inventory
-        seen_ids = {}
-        for file_id in inv:
-            if file_id in seen_ids:
-                raise BzrCheckError('duplicated file_id {%s} '
-                                    'in inventory for revision {%s}'
-                                    % (file_id, rev_id))
-            seen_ids[file_id] = True
-        for file_id in inv:
-            self._check_one_entry(rev_id, inv, tree, file_id)
-        seen_names = {}
-        for path, ie in inv.iter_entries():
-            if path in seen_names:
-                raise BzrCheckError('duplicated path %s '
-                                    'in inventory for revision {%s}'
-                                    % (path, rev_id))
-            seen_names[path] = True
+	tree = self.branch.revision_tree(rev_id)
+	inv = tree.inventory
+	seen_ids = {}
+	for file_id in inv:
+	    if file_id in seen_ids:
+		raise BzrCheckError('duplicated file_id {%s} '
+				    'in inventory for revision {%s}'
+				    % (file_id, rev_id))
+	    seen_ids[file_id] = True
+	for file_id in inv:
+	    self._check_one_entry(rev_id, inv, tree, file_id)
+	seen_names = {}
+	for path, ie in inv.iter_entries():
+	    if path in seen_names:
+		raise BzrCheckError('duplicated path %s '
+				    'in inventory for revision {%s}'
+				    % (path, rev_id))
+	    seen_names[path] = True
 
-        
+	
     def _check_one_entry(self, rev_id, inv, tree, file_id):
-        ie = inv[file_id]
-        if ie.parent_id != None:
-            if not inv.has_id(ie.parent_id):
-                raise BzrCheckError('missing parent {%s} in inventory for revision {%s}'
-                        % (ie.parent_id, rev_id))
-        if ie.kind == 'file':
+	ie = inv[file_id]
+	if ie.parent_id != None:
+	    if not inv.has_id(ie.parent_id):
+		raise BzrCheckError('missing parent {%s} in inventory for revision {%s}'
+			% (ie.parent_id, rev_id))
+	if ie.kind == 'file':
             text_version = ie.text_version
             t = (file_id, text_version)
             if t in self.checked_texts:
@@ -174,24 +172,24 @@
                                         (file_id, rev_id))
                 else:
                     self.repeated_text_cnt += 1
-                    return
+		    return
             mutter('check version {%s} of {%s}', rev_id, file_id)
-            file_lines = tree.get_file_lines(file_id)
-            self.checked_text_cnt += 1 
-            if ie.text_size != sum(map(len, file_lines)):
-                raise BzrCheckError('text {%s} wrong size' % ie.text_id)
-            if ie.text_sha1 != sha_strings(file_lines):
-                raise BzrCheckError('text {%s} wrong sha1' % ie.text_id)
+	    file_lines = tree.get_file_lines(file_id)
+	    self.checked_text_cnt += 1 
+	    if ie.text_size != sum(map(len, file_lines)):
+		raise BzrCheckError('text {%s} wrong size' % ie.text_id)
+	    if ie.text_sha1 != sha_strings(file_lines):
+		raise BzrCheckError('text {%s} wrong sha1' % ie.text_id)
             self.checked_texts[t] = ie.text_sha1
-        elif ie.kind == 'directory':
-            if ie.text_sha1 != None or ie.text_size != None or ie.text_id != None:
-                raise BzrCheckError('directory {%s} has text in revision {%s}'
-                        % (file_id, rev_id))
-        elif ie.kind == 'root_directory':
-            pass
-        else:
-            raise BzrCheckError('unknown entry kind %r in revision {%s}' % 
-                                (ie.kind, rev_id))
+	elif ie.kind == 'directory':
+	    if ie.text_sha1 != None or ie.text_size != None or ie.text_id != None:
+		raise BzrCheckError('directory {%s} has text in revision {%s}'
+			% (file_id, rev_id))
+	elif ie.kind == 'root_directory':
+	    pass
+	else:
+	    raise BzrCheckError('unknown entry kind %r in revision {%s}' % 
+				(ie.kind, rev_id))
 
 
 def check(branch):

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-09-28 09:35:50 +0000
+++ bzrlib/commands.py	2005-09-22 06:10:15 +0000
@@ -25,13 +25,6 @@
 # would help with validation and shell completion.
 
 
-# TODO: Help messages for options.
-
-# TODO: Define arguments by objects, rather than just using names.
-# Those objects can specify the expected type of the argument, which
-# would help with validation and shell completion.
-
-
 
 import sys
 import os
@@ -41,8 +34,8 @@
 import bzrlib
 import bzrlib.trace
 from bzrlib.trace import mutter, note, log_error, warning
-from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError, NotBranchError
-from bzrlib.revisionspec import RevisionSpec
+from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError
+from bzrlib.branch import find_branch
 from bzrlib import BZRDIR
 
 plugin_cmds = {}
@@ -76,71 +69,87 @@
 def _parse_revision_str(revstr):
     """This handles a revision string -> revno.
 
-    This always returns a list.  The list will have one element for
-    each revision.
+    This always returns a list.  The list will have one element for 
+
+    It supports integers directly, but everything else it
+    defers for passing to Branch.get_revision_info()
 
     >>> _parse_revision_str('234')
-    [<RevisionSpec_int 234>]
+    [234]
     >>> _parse_revision_str('234..567')
-    [<RevisionSpec_int 234>, <RevisionSpec_int 567>]
+    [234, 567]
     >>> _parse_revision_str('..')
-    [<RevisionSpec None>, <RevisionSpec None>]
+    [None, None]
     >>> _parse_revision_str('..234')
-    [<RevisionSpec None>, <RevisionSpec_int 234>]
+    [None, 234]
     >>> _parse_revision_str('234..')
-    [<RevisionSpec_int 234>, <RevisionSpec None>]
+    [234, None]
     >>> _parse_revision_str('234..456..789') # Maybe this should be an error
-    [<RevisionSpec_int 234>, <RevisionSpec_int 456>, <RevisionSpec_int 789>]
+    [234, 456, 789]
     >>> _parse_revision_str('234....789') # Error?
-    [<RevisionSpec_int 234>, <RevisionSpec None>, <RevisionSpec_int 789>]
+    [234, None, 789]
     >>> _parse_revision_str('revid:test@other.com-234234')
-    [<RevisionSpec_revid revid:test@other.com-234234>]
+    ['revid:test@other.com-234234']
     >>> _parse_revision_str('revid:test@other.com-234234..revid:test@other.com-234235')
-    [<RevisionSpec_revid revid:test@other.com-234234>, <RevisionSpec_revid revid:test@other.com-234235>]
+    ['revid:test@other.com-234234', 'revid:test@other.com-234235']
     >>> _parse_revision_str('revid:test@other.com-234234..23')
-    [<RevisionSpec_revid revid:test@other.com-234234>, <RevisionSpec_int 23>]
+    ['revid:test@other.com-234234', 23]
     >>> _parse_revision_str('date:2005-04-12')
-    [<RevisionSpec_date date:2005-04-12>]
+    ['date:2005-04-12']
     >>> _parse_revision_str('date:2005-04-12 12:24:33')
-    [<RevisionSpec_date date:2005-04-12 12:24:33>]
+    ['date:2005-04-12 12:24:33']
     >>> _parse_revision_str('date:2005-04-12T12:24:33')
-    [<RevisionSpec_date date:2005-04-12T12:24:33>]
+    ['date:2005-04-12T12:24:33']
     >>> _parse_revision_str('date:2005-04-12,12:24:33')
-    [<RevisionSpec_date date:2005-04-12,12:24:33>]
+    ['date:2005-04-12,12:24:33']
     >>> _parse_revision_str('-5..23')
-    [<RevisionSpec_int -5>, <RevisionSpec_int 23>]
+    [-5, 23]
     >>> _parse_revision_str('-5')
-    [<RevisionSpec_int -5>]
+    [-5]
     >>> _parse_revision_str('123a')
-    Traceback (most recent call last):
-      ...
-    BzrError: No namespace registered for string: '123a'
+    ['123a']
     >>> _parse_revision_str('abc')
-    Traceback (most recent call last):
-      ...
-    BzrError: No namespace registered for string: 'abc'
+    ['abc']
     """
     import re
     old_format_re = re.compile('\d*:\d*')
     m = old_format_re.match(revstr)
-    revs = []
     if m:
         warning('Colon separator for revision numbers is deprecated.'
                 ' Use .. instead')
+        revs = []
         for rev in revstr.split(':'):
             if rev:
-                revs.append(RevisionSpec(int(rev)))
-            else:
-                revs.append(RevisionSpec(None))
-    else:
-        for x in revstr.split('..'):
-            if not x:
-                revs.append(RevisionSpec(None))
-            else:
-                revs.append(RevisionSpec(x))
+                revs.append(int(rev))
+            else:
+                revs.append(None)
+        return revs
+    revs = []
+    for x in revstr.split('..'):
+        if not x:
+            revs.append(None)
+        else:
+            try:
+                revs.append(int(x))
+            except ValueError:
+                revs.append(x)
     return revs
 
 
+def get_merge_type(typestring):
+    """Attempt to find the merge class/factory associated with a string."""
+    from merge import merge_types
+    try:
+        return merge_types[typestring][0]
+    except KeyError:
+        templ = '%s%%7s: %%s' % (' '*12)
+        lines = [templ % (f[0], f[1][1]) for f in merge_types.iteritems()]
+        type_list = '\n'.join(lines)
+        msg = "No known merge type %s. Supported types are:\n%s" %\
+            (typestring, type_list)
+        raise BzrCommandError(msg)
+    
+
 def _builtin_commands():
     import bzrlib.builtins
     r = {}
@@ -333,12 +342,13 @@
     return parsed
 
 
+
+
 # list of all available options; the rhs can be either None for an
 # option that takes no argument, or a constructor function that checks
 # the type.
 OPTIONS = {
     'all':                    None,
-    'basis':                  str,
     'diff-options':           str,
     'help':                   None,
     'file':                   unicode,
@@ -360,6 +370,7 @@
     'long':                   None,
     'root':                   str,
     'no-backup':              None,
+    'merge-type':             get_merge_type,
     'pattern':                str,
     }
 
@@ -392,13 +403,13 @@
     >>> parse_args('commit --message=biter'.split())
     (['commit'], {'message': u'biter'})
     >>> parse_args('log -r 500'.split())
-    (['log'], {'revision': [<RevisionSpec_int 500>]})
+    (['log'], {'revision': [500]})
     >>> parse_args('log -r500..600'.split())
-    (['log'], {'revision': [<RevisionSpec_int 500>, <RevisionSpec_int 600>]})
+    (['log'], {'revision': [500, 600]})
     >>> parse_args('log -vr500..600'.split())
-    (['log'], {'verbose': True, 'revision': [<RevisionSpec_int 500>, <RevisionSpec_int 600>]})
-    >>> parse_args('log -rrevno:500..600'.split()) #the r takes an argument
-    (['log'], {'revision': [<RevisionSpec_revno revno:500>, <RevisionSpec_int 600>]})
+    (['log'], {'verbose': True, 'revision': [500, 600]})
+    >>> parse_args('log -rv500..600'.split()) #the r takes an argument
+    (['log'], {'revision': ['v500', 600]})
     """
     args = []
     opts = {}
@@ -624,20 +635,12 @@
     bzrlib.trace.log_startup(argv)
     bzrlib.ui.ui_factory = bzrlib.ui.TextUIFactory()
 
-    return run_bzr_catch_errors(argv[1:])
-
-
-def run_bzr_catch_errors(argv):
     try:
         try:
-            try:
-                return run_bzr(argv)
-            finally:
-                # do this here inside the exception wrappers to catch EPIPE
-                sys.stdout.flush()
-        #wrap common errors as CommandErrors.
-        except (NotBranchError,), e:
-            raise BzrCommandError(str(e))
+            return run_bzr(argv[1:])
+        finally:
+            # do this here inside the exception wrappers to catch EPIPE
+            sys.stdout.flush()
     except BzrCommandError, e:
         # command line syntax error, etc
         log_error(str(e))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-09-29 00:24:44 +0000
+++ bzrlib/commit.py	2005-09-22 05:21:08 +0000
@@ -63,7 +63,6 @@
 
 
 import os
-import re
 import sys
 import time
 import pdb
@@ -199,7 +198,6 @@
 
         assert isinstance(message, basestring), type(message)
         self.message = message
-        self._escape_commit_message()
 
         self.branch.lock_write()
         try:
@@ -240,35 +238,17 @@
         """Store the inventory for the new revision."""
         inv_text = serializer_v5.write_inventory_to_string(self.new_inv)
         self.inv_sha1 = sha_string(inv_text)
-        s = self.branch.control_weaves
+	s = self.branch.control_weaves
         s.add_text('inventory', self.rev_id,
-                   split_lines(inv_text), self.parents)
+		   split_lines(inv_text), self.parents)
 
-    def _escape_commit_message(self):
-        """Replace xml-incompatible control characters."""
-        # Python strings can include characters that can't be
-        # represented in well-formed XML; escape characters that
-        # aren't listed in the XML specification
-        # (http://www.w3.org/TR/REC-xml/#NT-Char).
-        if isinstance(self.message, unicode):
-            char_pattern = u'[^\x09\x0A\x0D\u0020-\uD7FF\uE000-\uFFFD]'
-        else:
-            # Use a regular 'str' as pattern to avoid having re.subn
-            # return 'unicode' results.
-            char_pattern = '[^x09\x0A\x0D\x20-\xFF]'
-        self.message, escape_count = re.subn(
-            char_pattern,
-            lambda match: match.group(0).encode('unicode_escape'),
-            self.message)
-        if escape_count:
-            note("replaced %d control characters in message", escape_count)
 
     def _record_ancestry(self):
         """Append merged revision ancestry to the ancestry file.
 
         This should be the merged ancestry of all parents, plus the
         new revision id."""
-        s = self.branch.control_weaves
+	s = self.branch.control_weaves
         w = s.get_weave_or_empty('ancestry')
         lines = self._make_ancestry(w)
         w.add(self.rev_id, self.parents, lines)
@@ -317,7 +297,7 @@
         rev_tmp = StringIO()
         serializer_v5.write_revision(self.rev, rev_tmp)
         rev_tmp.seek(0)
-        self.branch.revision_store.add(rev_tmp, self.rev_id, compressed=True)
+        self.branch.revision_store.add(rev_tmp, self.rev_id, compressed=False)
         mutter('new revision_id is {%s}', self.rev_id)
 
 
@@ -532,3 +512,4 @@
     assert r not in seen
     ancs.append(r)
     return ancs
+

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2005-09-27 07:24:40 +0000
+++ bzrlib/delta.py	2005-09-07 04:00:21 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-09-16 12:53:47 +0000
+++ bzrlib/diff.py	2005-08-25 05:58:05 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
@@ -44,16 +45,14 @@
     ud = difflib.unified_diff(oldlines, newlines,
                               fromfile=old_label, tofile=new_label)
 
-    ud = list(ud)
     # work-around for difflib being too smart for its own good
     # if /dev/null is "1,0", patch won't recognize it as /dev/null
     if not oldlines:
+        ud = list(ud)
         ud[2] = ud[2].replace('-1,0', '-0,0')
     elif not newlines:
+        ud = list(ud)
         ud[2] = ud[2].replace('+1,0', '+0,0')
-    # work around for difflib emitting random spaces after the label
-    ud[0] = ud[0][:-2] + '\n'
-    ud[1] = ud[1][:-2] + '\n'
 
     for line in ud:
         to_file.write(line)
@@ -145,7 +144,7 @@
 
 
 def show_diff(b, revision, specific_files, external_diff_options=None,
-              revision2=None, output=None):
+              revision2=None):
     """Shortcut for showing the diff to the working tree.
 
     b
@@ -157,21 +156,19 @@
     The more general form is show_diff_trees(), where the caller
     supplies any two trees.
     """
-    if output is None:
-        import sys
-        output = sys.stdout
+    import sys
 
-    if revision is None:
+    if revision == None:
         old_tree = b.basis_tree()
     else:
-        old_tree = b.revision_tree(revision.in_history(b).rev_id)
+        old_tree = b.revision_tree(b.lookup_revision(revision))
 
-    if revision2 is None:
+    if revision2 == None:
         new_tree = b.working_tree()
     else:
-        new_tree = b.revision_tree(revision2.in_history(b).rev_id)
+        new_tree = b.revision_tree(b.lookup_revision(revision2))
 
-    show_diff_trees(old_tree, new_tree, output, specific_files,
+    show_diff_trees(old_tree, new_tree, sys.stdout, specific_files,
                     external_diff_options)
 
 
@@ -212,7 +209,7 @@
                           specific_files=specific_files)
 
     for path, file_id, kind in delta.removed:
-        print >>to_file, '=== removed %s %r' % (kind, path)
+        print >>to_file, '*** removed %s %r' % (kind, path)
         if kind == 'file':
             diff_file(old_label + path,
                       old_tree.get_file(file_id).readlines(),
@@ -221,7 +218,7 @@
                       to_file)
 
     for path, file_id, kind in delta.added:
-        print >>to_file, '=== added %s %r' % (kind, path)
+        print >>to_file, '*** added %s %r' % (kind, path)
         if kind == 'file':
             diff_file(DEVNULL,
                       [],
@@ -230,7 +227,7 @@
                       to_file)
 
     for old_path, new_path, file_id, kind, text_modified in delta.renamed:
-        print >>to_file, '=== renamed %s %r => %r' % (kind, old_path, new_path)
+        print >>to_file, '*** renamed %s %r => %r' % (kind, old_path, new_path)
         if text_modified:
             diff_file(old_label + old_path,
                       old_tree.get_file(file_id).readlines(),
@@ -239,7 +236,7 @@
                       to_file)
 
     for path, file_id, kind in delta.modified:
-        print >>to_file, '=== modified %s %r' % (kind, path)
+        print >>to_file, '*** modified %s %r' % (kind, path)
         if kind == 'file':
             diff_file(old_label + path,
                       old_tree.get_file(file_id).readlines(),

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-09-29 00:24:44 +0000
+++ bzrlib/errors.py	2005-09-13 23:33:28 +0000
@@ -1,3 +1,4 @@
+#! /usr/bin/env python
 # -*- coding: UTF-8 -*-
 
 # This program is free software; you can redistribute it and/or modify
@@ -104,45 +105,27 @@
                           % (branch, object_type, object_id))
 
 
-class DivergedBranches(BzrError):
-    def __init__(self, branch1, branch2):
-        BzrError.__init__(self, "These branches have diverged.")
-        self.branch1 = branch1
-        self.branch2 = branch2
-
-
 class UnrelatedBranches(BzrCommandError):
     def __init__(self):
         msg = "Branches have no common ancestor, and no base revision"\
             " specified."
         BzrCommandError.__init__(self, msg)
 
-class NoCommonAncestor(BzrError):
-    def __init__(self, revision_a, revision_b):
-        msg = "Revisions have no common ancestor: %s %s." \
-            % (revision_a, revision_b) 
-        BzrError.__init__(self, msg)
-
-class NoCommonRoot(BzrError):
-    def __init__(self, revision_a, revision_b):
-        msg = "Revisions are not derived from the same root: %s %s." \
-            % (revision_a, revision_b) 
-        BzrError.__init__(self, msg)
 
 class NotAncestor(BzrError):
     def __init__(self, rev_id, not_ancestor_id):
+        self.rev_id = rev_id
+        self.not_ancestor_id = not_ancestor_id
         msg = "Revision %s is not an ancestor of %s" % (not_ancestor_id, 
                                                         rev_id)
         BzrError.__init__(self, msg)
-        self.rev_id = rev_id
-        self.not_ancestor_id = not_ancestor_id
 
 
 class InstallFailed(BzrError):
     def __init__(self, revisions):
+        self.revisions = revisions
         msg = "Could not install revisions:\n%s" % " ,".join(revisions)
         BzrError.__init__(self, msg)
-        self.revisions = revisions
 
 
 class AmbiguousBase(BzrError):
@@ -152,18 +135,3 @@
         BzrError.__init__(self, msg)
         self.bases = bases
 
-class NoCommits(BzrError):
-    def __init__(self, branch):
-        msg = "Branch %s has no commits." % branch
-        BzrError.__init__(self, msg)
-
-class UnlistableStore(BzrError):
-    def __init__(self, store):
-        BzrError.__init__(self, "Store %s is not listable" % store)
-
-class UnlistableBranch(BzrError):
-    def __init__(self, br):
-        BzrError.__init__(self, "Stores for branch %s are not listable" % br)
-
-
-from bzrlib.weave import WeaveError

=== modified file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2005-09-26 08:56:15 +0000
+++ bzrlib/externalcommand.py	2005-09-01 11:53:02 +0000
@@ -21,7 +21,6 @@
 
 import os
 import sys
-
 from bzrlib.commands import Command
 
 
@@ -44,7 +43,7 @@
     def __init__(self, path):
         self.path = path
 
-
+ 
     def name(self):
         return self.path.split(os.sep)[-1]
 

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-09-29 02:01:49 +0000
+++ bzrlib/fetch.py	2005-09-22 05:18:24 +0000
@@ -23,7 +23,7 @@
 from bzrlib.progress import ProgressBar
 from bzrlib.xml5 import serializer_v5
 from bzrlib.osutils import sha_string, split_lines
-from bzrlib.errors import InstallFailed, NoSuchRevision, WeaveError
+from bzrlib.errors import NoSuchRevision
 
 """Copying of history from one branch to another.
 
@@ -87,10 +87,10 @@
     def __init__(self, to_branch, from_branch, last_revision=None, pb=None):
         self.to_branch = to_branch
         self.to_weaves = to_branch.weave_store
-        self.to_control = to_branch.control_weaves
+	self.to_control = to_branch.control_weaves
         self.from_branch = from_branch
         self.from_weaves = from_branch.weave_store
-        self.from_control = from_branch.control_weaves
+	self.from_control = from_branch.control_weaves
         self.failed_revisions = []
         self.count_copied = 0
         self.count_total = 0
@@ -99,19 +99,13 @@
             self.pb = bzrlib.ui.ui_factory.progress_bar()
         else:
             self.pb = pb
-        try:
-            self.last_revision = self._find_last_revision(last_revision)
-        except NoSuchRevision, e:
-            mutter('failed getting last revision: %s', e)
-            raise InstallFailed([last_revision])
+        self.last_revision = self._find_last_revision(last_revision)
         mutter('fetch up to rev {%s}', self.last_revision)
-        try:
-            revs_to_fetch = self._compare_ancestries()
-        except WeaveError:
-            raise InstallFailed([self.last_revision])
+        revs_to_fetch = self._compare_ancestries()
         self._copy_revisions(revs_to_fetch)
         self.new_ancestry = revs_to_fetch
 
+        
 
     def _find_last_revision(self, last_revision):
         """Find the limiting source revision.
@@ -124,8 +118,10 @@
         from_history = self.from_branch.revision_history()
         self.pb.update('get destination history')
         if last_revision:
-            self.from_branch.get_revision(last_revision)
-            return last_revision
+            if last_revision not in from_history:
+                raise NoSuchRevision(self.from_branch, last_revision)
+            else:
+                return last_revision
         elif from_history:
             return from_history[-1]
         else:
@@ -155,13 +151,13 @@
         mutter('need to get %d revisions in total', len(to_fetch))
         self.count_total = len(to_fetch)
         return to_fetch
+                
+
 
     def _copy_revisions(self, revs_to_fetch):
         i = 0
         for rev_id in revs_to_fetch:
             i += 1
-            if rev_id is None:
-                continue
             if self.to_branch.has_revision(rev_id):
                 continue
             self.pb.update('fetch revision', i, self.count_total)

=== removed file 'bzrlib/graph.py'
--- bzrlib/graph.py	2005-09-21 15:33:23 +0000
+++ bzrlib/graph.py	1970-01-01 00:00:00 +0000
@@ -1,104 +0,0 @@
-# (C) 2005 Canonical
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-def max_distance(node, ancestors, distances, root_descendants):
-    """Calculate the max distance to an ancestor.  
-    Return None if not all possible ancestors have known distances"""
-    best = None
-    if node in distances:
-        best = distances[node]
-    for ancestor in ancestors[node]:
-        # skip ancestors we will never traverse:
-        if root_descendants is not None and ancestor not in root_descendants:
-            continue
-        # An ancestor which is not listed in ancestors will never be in
-        # distances, so we pretend it never existed.
-        if ancestor not in ancestors:
-            continue
-        if ancestor not in distances:
-            return None
-        if best is None or distances[ancestor]+1 > best:
-            best = distances[ancestor] + 1
-    return best
-
-    
-def node_distances(graph, ancestors, start, root_descendants=None):
-    """Produce a list of nodes, sorted by distance from a start node.
-    This is an algorithm devised by Aaron Bentley, because applying Dijkstra
-    backwards seemed too complicated.
-
-    For each node, we walk its descendants.  If all the descendant's ancestors
-    have a max-distance-to-start, (excluding ones that can never reach start),
-    we calculate their max-distance-to-start, and schedule their descendants.
-
-    So when a node's last parent acquires a distance, it will acquire a
-    distance on the next iteration.
-
-    Once we know the max distances for all nodes, we can return a list sorted
-    by distance, farthest first.
-    """
-    distances = {start: 0}
-    lines = set([start])
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            line_descendants = graph[line]
-            assert line not in line_descendants, "%s refers to itself" % line
-            for descendant in line_descendants:
-                distance = max_distance(descendant, ancestors, distances,
-                                        root_descendants)
-                if distance is None:
-                    continue
-                distances[descendant] = distance
-                new_lines.add(descendant)
-        lines = new_lines
-    return distances
-
-def nodes_by_distance(distances):
-    """Return a list of nodes sorted by distance"""
-    def by_distance(n):
-        return distances[n],n
-
-    node_list = distances.keys()
-    node_list.sort(key=by_distance, reverse=True)
-    return node_list
-
-def select_farthest(distances, common):
-    """Return the farthest common node, or None if no node qualifies."""
-    node_list = nodes_by_distance(distances)
-    for node in node_list:
-        if node in common:
-            return node
-
-def all_descendants(descendants, start):
-    """Produce a set of all descendants of the start node.
-    The input is a map of node->list of descendants for a graph encompassing
-    start.
-    """
-    result = set()
-    lines = set([start])
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            if line not in descendants:
-                continue
-            for descendant in descendants[line]:
-                if descendant in result:
-                    continue
-                result.add(descendant)
-                new_lines.add(descendant)
-        lines = new_lines
-    return result

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2005-09-16 03:32:44 +0000
+++ bzrlib/help.py	2005-09-05 04:08:03 +0000
@@ -30,24 +30,24 @@
 
 Basic commands:
 
-  bzr init           makes this directory a versioned branch
-  bzr branch         make a copy of another branch
-
-  bzr add            make files or directories versioned
-  bzr ignore         ignore a file or pattern
-  bzr mv             move or rename a versioned file
-
-  bzr status         summarize changes in working copy
-  bzr diff           show detailed diffs
-
-  bzr merge          pull in changes from another branch
-  bzr commit         save some or all changes
-
-  bzr log            show history of changes
-  bzr check          validate storage
-
-  bzr help init      more help on e.g. init command
-  bzr help commands  list all commands
+  bzr init      makes this branch versioned
+  bzr branch    make a copy of another branch
+
+  bzr add       make files or directories versioned
+  bzr ignore    ignore a file or pattern
+  bzr mv        move or rename a versioned file
+
+  bzr status    summarize changes in working copy
+  bzr diff      show detailed diffs
+
+  bzr merge     pull in changes from another branch
+  bzr commit    
+
+  bzr log       show history of changes
+  bzr check     validate storage
+
+Use e.g. 'bzr help init' for more details, or
+'bzr help commands' for all commands.
 """
 
 

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2005-09-27 07:24:40 +0000
+++ bzrlib/info.py	2005-09-16 07:49:36 +0000
@@ -18,7 +18,7 @@
 
 import time
 
-from bzrlib.osutils import format_date
+from osutils import format_date
 
 
 def _countiter(it):

=== modified file 'bzrlib/intset.py'
--- bzrlib/intset.py	2005-09-15 13:32:36 +0000
+++ bzrlib/intset.py	2005-07-17 18:26:45 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/python
+
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
@@ -208,3 +210,12 @@
         if not self._val & m:
             raise KeyError(to_remove)
         self._val ^= m
+        
+        
+            
+    
+
+if __name__ == '__main__':
+    import doctest
+    doctest.testmod()
+    

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-09-27 07:24:40 +0000
+++ bzrlib/inventory.py	2005-09-16 09:43:55 +0000
@@ -28,18 +28,15 @@
 ROOT_ID = "TREE_ROOT"
 
 
-import os.path
-import re
-import sys
-import types
+import sys, os.path, types, re
 
 import bzrlib
 from bzrlib.errors import BzrError, BzrCheckError
 
-from bzrlib.osutils import quotefn, splitpath, joinpath, appendpath
+from bzrlib.osutils import uuid, quotefn, splitpath, joinpath, appendpath
 from bzrlib.trace import mutter
 from bzrlib.errors import NotVersionedError
-
+        
 
 class InventoryEntry(object):
     """Description of a versioned file.
@@ -101,16 +98,16 @@
     InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> i['2326']
     InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
-    >>> for path, entry in i.iter_entries():
-    ...     print path.replace('\\\\', '/')     # for win32 os.sep
-    ...     assert i.path2id(path)
+    >>> for j in i.iter_entries():
+    ...     print j[0]
+    ...     assert i.path2id(j[0])
     ... 
     src
     src/bye.c
     src/hello.c
     src/wibble
     src/wibble/wibble.c
-    >>> i.id2path('2326').replace('\\\\', '/')
+    >>> i.id2path('2326')
     'src/wibble/wibble.c'
     """
     
@@ -272,7 +269,7 @@
         The inventory is created with a default root directory, with
         an id of None.
         """
-        # We are letting Branch.initialize() create a unique inventory
+        # We are letting Branch(init=True) create a unique inventory
         # root id. Rather than generating a random one here.
         #if root_id is None:
         #    root_id = bzrlib.branch.gen_file_id('TREE_ROOT')

=== modified file 'bzrlib/lock.py'
--- bzrlib/lock.py	2005-09-23 12:49:00 +0000
+++ bzrlib/lock.py	2005-07-21 12:01:14 +0000
@@ -84,7 +84,7 @@
         f = None
 
         def unlock(self):
-            fcntl.lockf(self.f, fcntl.LOCK_UN)
+            fcntl.flock(self.f, fcntl.LOCK_UN)
             self.f.close()
             del self.f 
 
@@ -92,7 +92,7 @@
     class _fcntl_WriteLock(_fcntl_FileLock):
         def __init__(self, filename):
             try:
-                fcntl.lockf(self._open(filename, 'wb'), fcntl.LOCK_EX)
+                fcntl.flock(self._open(filename, 'wb'), fcntl.LOCK_EX)
             except Exception, e:
                 raise LockError(e)
 
@@ -100,7 +100,7 @@
     class _fcntl_ReadLock(_fcntl_FileLock):
         def __init__(self, filename):
             try:
-                fcntl.lockf(self._open(filename, 'rb'), fcntl.LOCK_SH)
+                fcntl.flock(self._open(filename, 'rb'), fcntl.LOCK_SH)
             except Exception, e:
                 raise LockError(e)
 
@@ -168,8 +168,6 @@
                 LOCK_NB = 4
                 def unlock(self):
                     _msvc_unlock(self.f)
-                    self.f.close()
-                    self.f = None
 
 
             class _msvc_ReadLock(_msvc_FileLock):

=== modified file 'bzrlib/mdiff.py'
--- bzrlib/mdiff.py	2005-09-26 08:56:15 +0000
+++ bzrlib/mdiff.py	2005-08-25 05:58:05 +0000
@@ -27,13 +27,10 @@
 
 # FIXME: doesn't work properly on files without trailing newlines
 
-import difflib
-import struct
-import sys
 import unittest
+import difflib, sys, struct
 from cStringIO import StringIO
 
-
 def linesplit(a):
     """Split into two lists: content and line positions.
 

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-09-27 07:24:40 +0000
+++ bzrlib/merge.py	2005-09-13 23:18:12 +0000
@@ -15,27 +15,23 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-import os
+import os.path
 import tempfile
 import shutil
 import errno
+from fetch import greedy_fetch
 
 import bzrlib.osutils
 import bzrlib.revision
 from bzrlib.merge_core import merge_flex, ApplyMerge3, BackupBeforeChange
 from bzrlib.changeset import generate_changeset, ExceptionConflictHandler
 from bzrlib.changeset import Inventory, Diff3Merge
-from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError, UnrelatedBranches, NoCommonAncestor
-from bzrlib.errors import NoCommits
+from bzrlib.branch import find_branch
+from bzrlib.errors import BzrCommandError, UnrelatedBranches
 from bzrlib.delta import compare_trees
 from bzrlib.trace import mutter, warning
-from bzrlib.fetch import greedy_fetch, fetch
+from bzrlib.fetch import greedy_fetch
 from bzrlib.revision import is_ancestor
-from bzrlib.osutils import rename
-from bzrlib.revision import common_ancestor, MultipleRevisionSources
-from bzrlib.errors import NoSuchRevision
-
 
 # comments from abentley on irc: merge happens in two stages, each
 # of which generates a changeset object
@@ -50,8 +46,8 @@
     conflict that are not explicitly handled cause an exception and
     terminate the merge.
     """
-    def __init__(self, ignore_zero=False):
-        ExceptionConflictHandler.__init__(self)
+    def __init__(self, dir, ignore_zero=False):
+        ExceptionConflictHandler.__init__(self, dir)
         self.conflicts = 0
         self.ignore_zero = ignore_zero
 
@@ -87,7 +83,7 @@
             last_new_name = name
         new_name = last_new_name+suffix
         try:
-            rename(name, new_name)
+            os.rename(name, new_name)
             return new_name
         except OSError, e:
             if e.errno != errno.EEXIST and e.errno != errno.ENOTEMPTY:
@@ -111,7 +107,7 @@
         self.add_suffix(this_path, ".THIS")
         self.dump(base_lines, this_path+".BASE")
         self.dump(other_lines, this_path+".OTHER")
-        rename(new_file, this_path)
+        os.rename(new_file, this_path)
         self.conflict("Diff3 conflict encountered in %s" % this_path)
 
     def new_contents_conflict(self, filename, other_contents):
@@ -137,13 +133,13 @@
             
 def get_tree(treespec, temp_root, label, local_branch=None):
     location, revno = treespec
-    branch = Branch.open_containing(location)
+    branch = find_branch(location)
     if revno is None:
         revision = None
     elif revno == -1:
         revision = branch.last_revision()
     else:
-        revision = branch.get_rev_id(revno)
+        revision = branch.lookup_revision(revno)
     return branch, get_revid_tree(branch, revision, temp_root, label,
                                   local_branch)
 
@@ -238,15 +234,16 @@
     check_clean
         If true, this_dir must have no uncommitted changes before the
         merge begins.
-
-    All available ancestors of other_revision and base_revision are
+    all available ancestors of other_revision and base_revision are
     automatically pulled into the branch.
     """
+    from bzrlib.revision import common_ancestor, MultipleRevisionSources
+    from bzrlib.errors import NoSuchRevision
     tempdir = tempfile.mkdtemp(prefix="bzr-")
     try:
         if this_dir is None:
             this_dir = '.'
-        this_branch = Branch.open_containing(this_dir)
+        this_branch = find_branch(this_dir)
         this_rev_id = this_branch.last_revision()
         if this_rev_id is None:
             raise BzrCommandError("This branch has no commits")
@@ -259,22 +256,17 @@
                                             this_branch)
         if other_revision[1] == -1:
             other_rev_id = other_branch.last_revision()
-            if other_rev_id is None:
-                raise NoCommits(other_branch)
             other_basis = other_rev_id
         elif other_revision[1] is not None:
-            other_rev_id = other_branch.get_rev_id(other_revision[1])
+            other_rev_id = other_branch.lookup_revision(other_revision[1])
             other_basis = other_rev_id
         else:
             other_rev_id = None
             other_basis = other_branch.last_revision()
-            if other_basis is None:
-                raise NoCommits(other_branch)
         if base_revision == [None, None]:
-            try:
-                base_rev_id = common_ancestor(this_rev_id, other_basis, 
-                                              this_branch)
-            except NoCommonAncestor:
+            base_rev_id = common_ancestor(this_rev_id, other_basis, 
+                                          this_branch)
+            if base_rev_id is None:
                 raise UnrelatedBranches()
             base_tree = get_revid_tree(this_branch, base_rev_id, tempdir, 
                                        "base", None)
@@ -286,10 +278,13 @@
             elif base_revision[1] is None:
                 base_rev_id = None
             else:
-                base_rev_id = base_branch.get_rev_id(base_revision[1])
-            fetch(from_branch=base_branch, to_branch=this_branch)
-            base_is_ancestor = is_ancestor(this_rev_id, base_rev_id,
-                                           this_branch)
+                base_rev_id = base_branch.lookup_revision(base_revision[1])
+            if base_rev_id is not None:
+                base_is_ancestor = is_ancestor(this_rev_id, base_rev_id, 
+                                               MultipleRevisionSources(this_branch, 
+                                                                       base_branch))
+            else:
+                base_is_ancestor = False
         if file_list is None:
             interesting_ids = None
         else:
@@ -351,7 +346,8 @@
 
     inv_changes = merge_flex(this_tree, base_tree, other_tree,
                              generate_cset_optimized, get_inventory,
-                             MergeConflictHandler(ignore_zero=ignore_zero),
+                             MergeConflictHandler(base_tree.root,
+                                                  ignore_zero=ignore_zero),
                              merge_factory=merge_factory, 
                              interesting_ids=interesting_ids)
 
@@ -361,7 +357,7 @@
             if path == '.':
                 path = ''
             else:
-                assert path.startswith('.' + os.sep), "path is %s" % path
+                assert path.startswith('./'), "path is %s" % path
             path = path[2:]
         adjust_ids.append((path, id))
     if len(adjust_ids) > 0:

=== modified file 'bzrlib/merge_core.py'
--- bzrlib/merge_core.py	2005-09-23 09:25:16 +0000
+++ bzrlib/merge_core.py	2005-08-27 04:42:41 +0000
@@ -1,7 +1,7 @@
 import changeset
 from changeset import Inventory, apply_changeset, invert_dict
 import os.path
-from osutils import backup_file, rename
+from osutils import backup_file
 from merge3 import Merge3
 
 class ApplyMerge3:
@@ -51,7 +51,7 @@
         output_file.close()
         if not new_conflicts:
             os.chmod(new_file, os.stat(filename).st_mode)
-            rename(new_file, filename)
+            os.rename(new_file, filename)
             return
         else:
             conflict_handler.merge_conflict(new_file, filename, base_lines,

=== modified file 'bzrlib/meta_store.py'
--- bzrlib/meta_store.py	2005-09-26 08:56:15 +0000
+++ bzrlib/meta_store.py	2005-06-27 01:36:22 +0000
@@ -14,10 +14,9 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.trace import mutter
+from trace import mutter
 from bzrlib.store import ImmutableStore
 
-
 class CachedStore:
     """A store that caches data locally, to avoid repeated downloads.
     The precacache method should be used to avoid server round-trips for
@@ -37,9 +36,6 @@
         """Copy a series of ids into the cache, before they are used.
         For remote stores that support pipelining or async downloads, this can
         increase speed considerably.
-
-        Failures while prefetching are ignored.
         """
         mutter("Prefetch of ids %s" % ",".join(ids))
-        self.cache_store.copy_multi(self.source_store, ids, 
-                                    permit_failure=True)
+        self.cache_store.copy_multi(self.source_store, ids)

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2005-09-15 13:32:36 +0000
+++ bzrlib/missing.py	2005-08-30 05:30:43 +0000
@@ -1,3 +1,4 @@
+#!/usr/bin/env python
 """\
 A plugin for displaying what revisions are in 'other' but not in local.
 """

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2005-09-19 06:16:22 +0000
+++ bzrlib/msgeditor.py	2005-09-01 11:27:20 +0000
@@ -20,38 +20,31 @@
 """Commit message editor support."""
 
 import os
-from subprocess import call
 from bzrlib.errors import BzrError
 
 def _get_editor():
     """Return a sequence of possible editor binaries for the current platform"""
     from bzrlib.osutils import _read_config_value
     
-    try:
-        yield os.environ["BZR_EDITOR"]
-    except KeyError:
-        pass
-
     e = _read_config_value("editor")
     if e is not None:
         yield e
         
-    try:
-        yield os.environ["EDITOR"]
-    except KeyError:
-        pass
-
-    if os.name == "nt":
+    if os.name == "windows":
         yield "notepad.exe"
     elif os.name == "posix":
-        yield "/usr/bin/vi"
+        try:
+            yield os.environ["EDITOR"]
+        except KeyError:
+            yield "/usr/bin/vi"
 
 
 def _run_editor(filename):
     """Try to execute an editor to edit the commit message."""
     for e in _get_editor():
         edargs = e.split(' ')
-        x = call(edargs + [filename])
+        x = os.spawnvp(os.P_WAIT, edargs[0],
+                       edargs + [filename])
         if x == 0:
             return True
         elif x == 127:

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2005-09-28 09:35:50 +0000
+++ bzrlib/osutils.py	2005-09-13 08:20:13 +0000
@@ -1,40 +1,34 @@
 # Bazaar-NG -- distributed version control
-#
+
 # Copyright (C) 2005 by Canonical Ltd
-#
+
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-#
+
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
+
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from shutil import copyfile
-from stat import (S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE,
-                  S_ISCHR, S_ISBLK, S_ISFIFO, S_ISSOCK)
+import os, types, re, time, errno, sys
+import sha
 from cStringIO import StringIO
-import errno
-import os
-import re
-import sha
-import sys
-import time
-import types
-
-import bzrlib
+
+from stat import S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE
+
 from bzrlib.errors import BzrError
 from bzrlib.trace import mutter
-
+import bzrlib
 
 def make_readonly(filename):
     """Make a filename read-only."""
+    # TODO: probably needs to be fixed for windows
     mod = os.stat(filename).st_mode
     mod = mod & 0777555
     os.chmod(filename, mod)
@@ -57,7 +51,7 @@
     # TODO: I'm not really sure this is the best format either.x
     global _QUOTE_RE
     if _QUOTE_RE == None:
-        _QUOTE_RE = re.compile(r'([^a-zA-Z0-9.,:/\\_~-])')
+        _QUOTE_RE = re.compile(r'([^a-zA-Z0-9.,:/_~-])')
         
     if _QUOTE_RE.search(f):
         return '"' + f + '"'
@@ -73,16 +67,8 @@
         return 'directory'
     elif S_ISLNK(mode):
         return 'symlink'
-    elif S_ISCHR(mode):
-        return 'chardev'
-    elif S_ISBLK(mode):
-        return 'block'
-    elif S_ISFIFO(mode):
-        return 'fifo'
-    elif S_ISSOCK(mode):
-        return 'socket'
     else:
-        return 'unknown'
+        raise BzrError("can't handle file kind with mode %o of %r" % (mode, f))
 
 
 def kind_marker(kind):
@@ -96,6 +82,7 @@
         raise BzrError('invalid file kind %r' % kind)
 
 
+
 def backup_file(fn):
     """Copy a file to a backup.
 
@@ -119,11 +106,18 @@
     finally:
         outf.close()
 
-if os.name == 'nt':
-    import shutil
-    rename = shutil.move
-else:
-    rename = os.rename
+def rename(path_from, path_to):
+    """Basically the same as os.rename() just special for win32"""
+    if sys.platform == 'win32':
+        try:
+            os.remove(path_to)
+        except OSError, e:
+            if e.errno != e.ENOENT:
+                raise
+    os.rename(path_from, path_to)
+
+
+
 
 
 def isdir(f):
@@ -134,6 +128,7 @@
         return False
 
 
+
 def isfile(f):
     """True if f is a regular file."""
     try:
@@ -152,11 +147,11 @@
     The empty string as a dir name is taken as top-of-tree and matches 
     everything.
     
-    >>> is_inside('src', os.path.join('src', 'foo.c'))
+    >>> is_inside('src', 'src/foo.c')
     True
     >>> is_inside('src', 'srccontrol')
     False
-    >>> is_inside('src', os.path.join('src', 'a', 'a', 'a', 'foo.c'))
+    >>> is_inside('src', 'src/a/a/a/foo.c')
     True
     >>> is_inside('foo.c', 'foo.c')
     True
@@ -172,10 +167,10 @@
     
     if dir == '':
         return True
-
+    
     if dir[-1] != os.sep:
         dir += os.sep
-
+    
     return fname.startswith(dir)
 
 
@@ -193,6 +188,14 @@
     tofile.write(fromfile.read())
 
 
+def uuid():
+    """Return a new UUID"""
+    try:
+        return file('/proc/sys/kernel/random/uuid').readline().rstrip('\n')
+    except IOError:
+        return chomp(os.popen('uuidgen').readline())
+
+
 def sha_file(f):
     if hasattr(f, 'tell'):
         assert f.tell() == 0
@@ -220,6 +223,7 @@
     return s.hexdigest()
 
 
+
 def fingerprint_file(f):
     s = sha.new()
     b = f.read()
@@ -236,7 +240,7 @@
     
     TODO: Global option --config-dir to override this.
     """
-    return os.path.join(os.path.expanduser("~"), ".bzr.conf")
+    return os.path.expanduser("~/.bzr.conf")
 
 
 def _auto_user_id():
@@ -346,11 +350,11 @@
     if e:
         m = re.search(r'[\w+.-]+@[\w+.-]+', e)
         if not m:
-            raise BzrError("%r doesn't seem to contain "
-                           "a reasonable email address" % e)
+            raise BzrError("%r doesn't seem to contain a reasonable email address" % e)
         return m.group(0)
 
     return _auto_user_id()[1]
+    
 
 
 def compare_files(a, b):
@@ -365,6 +369,7 @@
             return True
 
 
+
 def local_time_offset(t=None):
     """Return offset of local zone from GMT, either at present or at time t."""
     # python2.3 localtime() can't take None
@@ -409,27 +414,21 @@
     """Return size of given open file."""
     return os.fstat(f.fileno())[ST_SIZE]
 
-# Define rand_bytes based on platform.
-try:
-    # Python 2.4 and later have os.urandom,
-    # but it doesn't work on some arches
-    os.urandom(1)
+
+if hasattr(os, 'urandom'): # python 2.4 and later
     rand_bytes = os.urandom
-except (NotImplementedError, AttributeError):
-    # If python doesn't have os.urandom, or it doesn't work,
-    # then try to first pull random data from /dev/urandom
-    if os.path.exists("/dev/urandom"):
-        rand_bytes = file('/dev/urandom', 'rb').read
-    # Otherwise, use this hack as a last resort
-    else:
-        # not well seeded, but better than nothing
-        def rand_bytes(n):
-            import random
-            s = ''
-            while n:
-                s += chr(random.randint(0, 255))
-                n -= 1
-            return s
+elif sys.platform == 'linux2':
+    rand_bytes = file('/dev/urandom', 'rb').read
+else:
+    # not well seeded, but better than nothing
+    def rand_bytes(n):
+        import random
+        s = ''
+        while n:
+            s += chr(random.randint(0, 255))
+            n -= 1
+        return s
+
 
 ## TODO: We could later have path objects that remember their list
 ## decomposition (might be too tricksy though.)
@@ -481,6 +480,13 @@
         return os.path.join(p1, p2)
     
 
+def extern_command(cmd, ignore_errors = False):
+    mutter('external command: %s' % `cmd`)
+    if os.system(cmd):
+        if not ignore_errors:
+            raise BzrError('command failed')
+
+
 def _read_config_value(name):
     """Read a config value from the file ~/.bzr.conf/<name>
     Return None if the file does not exist"""
@@ -493,23 +499,8 @@
         raise
 
 
+
 def split_lines(s):
     """Split s into lines, but without removing the newline characters."""
     return StringIO(s).readlines()
-
-
-def hardlinks_good():
-    return sys.platform not in ('win32', 'cygwin', 'darwin')
-
-
-def link_or_copy(src, dest):
-    """Hardlink a file, or copy it if it can't be hardlinked."""
-    if not hardlinks_good():
-        copyfile(src, dest)
-        return
-    try:
-        os.link(src, dest)
-    except (OSError, IOError), e:
-        if e.errno != errno.EXDEV:
-            raise
-        copyfile(src, dest)
+    

=== modified file 'bzrlib/patch.py'
--- bzrlib/patch.py	2005-09-23 09:25:16 +0000
+++ bzrlib/patch.py	2005-08-25 05:58:05 +0000
@@ -6,13 +6,8 @@
 __docformat__ = "restructuredtext"
 
 def write_to_cmd(args, input=""):
-    if os.name != 'nt':
-        process = Popen(args, bufsize=len(input), stdin=PIPE, stdout=PIPE,
-                        stderr=PIPE, close_fds=True)
-    else:
-        process = Popen(args, bufsize=len(input), stdin=PIPE, stdout=PIPE,
-                        stderr=PIPE)
-
+    process = Popen(args, bufsize=len(input), stdin=PIPE, stdout=PIPE,
+                    stderr=PIPE, close_fds=True)
     stdout, stderr = process.communicate(input)
     status = process.wait()
     if status < 0:

=== modified file 'bzrlib/remotebranch.py'
--- bzrlib/remotebranch.py	2005-09-29 02:01:49 +0000
+++ bzrlib/remotebranch.py	2005-09-07 04:00:21 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/env python
+
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
@@ -24,17 +26,13 @@
 
 import gzip
 from cStringIO import StringIO
-import os
 import urllib2
-import urlparse
 
 from bzrlib.errors import BzrError, BzrCheckError
-from bzrlib.branch import Branch, LocalBranch, BZR_BRANCH_FORMAT_5
+from bzrlib.branch import Branch, BZR_BRANCH_FORMAT_5
 from bzrlib.trace import mutter
-from bzrlib.weavestore import WeaveStore
 from bzrlib.xml5 import serializer_v5
 
-
 # velocitynet.com.au transparently proxies connections and thereby
 # breaks keep-alive -- sucks!
 
@@ -87,8 +85,8 @@
     orig_url = url
     while True:
         try:
-            fmt_url = url + '/.bzr/branch-format'
-            ff = get_url(fmt_url)
+            ff = get_url(url + '/.bzr/branch-format')
+
             fmt = ff.read()
             ff.close()
 
@@ -100,35 +98,27 @@
         except urllib2.URLError:
             pass
 
-        scheme, host, path = list(urlparse.urlparse(url))[:3]
-        # discard params, query, fragment
-        
-        # strip off one component of the path component
-        idx = path.rfind('/')
-        if idx == -1 or path == '/':
-            raise BzrError('no branch root found for URL %s'
-                           ' or enclosing directories'
-                           % orig_url)
-        path = path[:idx]
-        url = urlparse.urlunparse((scheme, host, path, '', '', ''))
-        
-
-
-class RemoteBranch(LocalBranch):
+        try:
+            idx = url.rindex('/')
+        except ValueError:
+            raise BzrError('no branch root found for URL %s' % orig_url)
+
+        url = url[:idx]        
+        
+
+
+class RemoteBranch(Branch):
     def __init__(self, baseurl, find_root=True):
         """Create new proxy for a remote branch."""
         if find_root:
-            self.base = _find_remote_root(baseurl)
+            self.baseurl = _find_remote_root(baseurl)
         else:
-            self.base = baseurl
-        self._check_format(False)
-        # is guaranteed to be a v5 store
+            self.baseurl = baseurl
+            self._check_format()
 
-        cfn = self.controlfilename
-        assert self._branch_format == 5
-        self.control_weaves = WeaveStore(cfn([]), get_url)
-        self.weave_store = WeaveStore(cfn('weaves'), get_url)
-        self.revision_store = RemoteStore(cfn('revision-store'))
+        self.inventory_store = RemoteStore(baseurl + '/.bzr/inventory-store/')
+        self.text_store = RemoteStore(baseurl + '/.bzr/text-store/')
+        self.revision_store = RemoteStore(baseurl + '/.bzr/revision-store/')
 
     def __str__(self):
         b = getattr(self, 'baseurl', 'undefined')
@@ -136,20 +126,10 @@
 
     __repr__ = __str__
 
-    def setup_caching(self, cache_root):
-        """Set up cached stores located under cache_root"""
-        from bzrlib.meta_store import CachedStore
-        for store_name in ('inventory_store', 'text_store', 'revision_store'):
-            if not isinstance(getattr(self, store_name), CachedStore):
-                cache_path = os.path.join(cache_root, store_name)
-                os.mkdir(cache_path)
-                new_store = CachedStore(getattr(self, store_name), cache_path)
-                setattr(self, store_name, new_store)
-
     def controlfile(self, filename, mode):
         if mode not in ('rb', 'rt', 'r'):
             raise BzrError("file mode %r not supported for remote branches" % mode)
-        return get_url(self.base + '/.bzr/' + filename, False)
+        return get_url(self.baseurl + '/.bzr/' + filename, False)
 
 
     def lock_read(self):
@@ -159,21 +139,22 @@
     def lock_write(self):
         from errors import LockError
         raise LockError("write lock not supported for remote branch %s"
-                        % self.base)
+                        % self.baseurl)
 
     def unlock(self):
         pass
     
 
     def relpath(self, path):
-        if not path.startswith(self.base):
+        if not path.startswith(self.baseurl):
             raise BzrError('path %r is not under base URL %r'
-                           % (path, self.base))
-        pl = len(self.base)
+                           % (path, self.baseurl))
+        pl = len(self.baseurl)
         return path[pl:].lstrip('/')
 
 
     def get_revision(self, revision_id):
+        from bzrlib.revision import Revision
         try:
             revf = self.revision_store[revision_id]
         except KeyError:
@@ -194,23 +175,12 @@
         if '/' in name:
             raise ValueError('invalid store id', name)
         return self._baseurl + '/' + name
-
-    def __contains__(self, fileid):
-        try:
-            self[fileid]
-            return True
-        except KeyError:
-            return False
         
     def __getitem__(self, fileid):
         p = self._path(fileid)
         try:
             return get_url(p, compressed=True)
-        except urllib2.URLError:
-            pass
-        try:
-            return get_url(p, compressed=False)
-        except urllib2.URLError:
+        except:
             raise KeyError(fileid)
     
 

=== modified file 'bzrlib/revfile.py'
--- bzrlib/revfile.py	2005-09-26 08:56:15 +0000
+++ bzrlib/revfile.py	2005-08-25 05:58:05 +0000
@@ -93,17 +93,9 @@
 # then ftell after writing to see where it went.  In any case we
 # assume the whole branch is protected by a lock.
 
-import os
-import sha
-import stat
-import struct
-import sys
-import zlib
+import sys, zlib, struct, mdiff, stat, os, sha
 from binascii import hexlify, unhexlify
 
-import bzrlib.mdiff as mdiff
-
-
 _RECORDSIZE = 48
 
 _HEADER = "bzr revfile v1\n"

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-09-27 07:24:40 +0000
+++ bzrlib/revision.py	2005-09-19 08:02:41 +0000
@@ -16,9 +16,7 @@
 
 
 import bzrlib.errors
-from bzrlib.graph import node_distances, select_farthest, all_descendants
 
-NULL_REVISION="null:"
 
 class Revision(object):
     """Single revision on a branch.
@@ -137,7 +135,7 @@
     return matches
 
 
-def old_common_ancestor(revision_a, revision_b, revision_source):
+def common_ancestor(revision_a, revision_b, revision_source):
     """Find the ancestor common to both revisions that is closest to both.
     """
     from bzrlib.trace import mutter
@@ -168,83 +166,6 @@
         raise bzrlib.errors.AmbiguousBase((a_closest[0], b_closest[0]))
     return a_closest[0]
 
-def revision_graph(revision, revision_source):
-    """Produce a graph of the ancestry of the specified revision.
-    Return root, ancestors map, descendants map
-
-    TODO: Produce graphs with the NULL revision as root, so that we can find
-    a common even when trees are not branches don't represent a single line
-    of descent.
-    """
-    ancestors = {}
-    descendants = {}
-    lines = [revision]
-    root = None
-    descendants[revision] = {}
-    while len(lines) > 0:
-        new_lines = set()
-        for line in lines:
-            if line == NULL_REVISION:
-                parents = []
-                root = NULL_REVISION
-            else:
-                try:
-                    rev = revision_source.get_revision(line)
-                    parents = list(rev.parent_ids)
-                    if len(parents) == 0:
-                        parents = [NULL_REVISION]
-                except bzrlib.errors.NoSuchRevision:
-                    if line == revision:
-                        raise
-                    parents = None
-            if parents is not None:
-                for parent in parents:
-                    if parent not in ancestors:
-                        new_lines.add(parent)
-                    if parent not in descendants:
-                        descendants[parent] = {}
-                    descendants[parent][line] = 1
-            if parents is not None:
-                ancestors[line] = set(parents)
-        lines = new_lines
-    assert root not in descendants[root]
-    assert root not in ancestors[root]
-    return root, ancestors, descendants
-
-def combined_graph(revision_a, revision_b, revision_source):
-    """Produce a combined ancestry graph.
-    Return graph root, ancestors map, descendants map, set of common nodes"""
-    root, ancestors, descendants = revision_graph(revision_a, revision_source)
-    root_b, ancestors_b, descendants_b = revision_graph(revision_b, 
-                                                        revision_source)
-    if root != root_b:
-        raise bzrlib.errors.NoCommonRoot(revision_a, revision_b)
-    common = set()
-    for node, node_anc in ancestors_b.iteritems():
-        if node in ancestors:
-            common.add(node)
-        else:
-            ancestors[node] = set()
-        ancestors[node].update(node_anc)
-    for node, node_dec in descendants_b.iteritems():
-        if node not in descendants:
-            descendants[node] = {}
-        descendants[node].update(node_dec)
-    return root, ancestors, descendants, common
-
-def common_ancestor(revision_a, revision_b, revision_source):
-    try:
-        root, ancestors, descendants, common = \
-            combined_graph(revision_a, revision_b, revision_source)
-    except bzrlib.errors.NoCommonRoot:
-        raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
-        
-    distances = node_distances (descendants, ancestors, root)
-    farthest = select_farthest(distances, common)
-    if farthest is None or farthest == NULL_REVISION:
-        raise bzrlib.errors.NoCommonAncestor(revision_a, revision_b)
-    return farthest
-
 class MultipleRevisionSources(object):
     """Proxy that looks in multiple branches for revisions."""
     def __init__(self, *args):
@@ -269,36 +190,47 @@
     Otherwise, rev_id will be the last entry.  ancestor_id will never appear.
     If ancestor_id is not an ancestor, NotAncestor will be thrown
     """
-    root, ancestors, descendants = revision_graph(rev_id, rev_source)
-    if len(descendants) == 0:
-        raise NoSuchRevision(rev_source, rev_id)
-    if ancestor_id not in descendants:
-        rev_source.get_revision(ancestor_id)
-        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
-    root_descendants = all_descendants(descendants, ancestor_id)
-    root_descendants.add(ancestor_id)
-    if rev_id not in root_descendants:
-        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
-    distances = node_distances(descendants, ancestors, ancestor_id,
-                               root_descendants=root_descendants)
-
-    def best_ancestor(rev_id):
-        best = None
-        for anc_id in ancestors[rev_id]:
-            try:
-                distance = distances[anc_id]
-            except KeyError:
-                continue
-            if revision_history is not None and anc_id in revision_history:
-                return anc_id
-            elif best is None or distance > best[1]:
-                best = (anc_id, distance)
-        return best[0]
-
-    next = rev_id
-    path = []
-    while next != ancestor_id:
-        path.append(next)
-        next = best_ancestor(next)
-    path.reverse()
-    return path
+    [rev_source.get_revision(r) for r in (ancestor_id, rev_id)]
+    if ancestor_id == rev_id:
+        return []
+    def historical_lines(line):
+        """Return a tuple of historical/non_historical lines, for sorting.
+        The non_historical count is negative, since non_historical lines are
+        a bad thing.
+        """
+        good_count = 0
+        bad_count = 0
+        for revision in line:
+            if revision in revision_history:
+                good_count += 1
+            else:
+                bad_count -= 1
+        return good_count, bad_count
+    active = [[rev_id]]
+    successful_lines = []
+    while len(active) > 0:
+        new_active = []
+        for line in active:
+            for parent in rev_source.get_revision(line[-1]).parent_ids:
+                line_copy = line[:]
+                if parent == ancestor_id:
+                    successful_lines.append(line_copy)
+                else:
+                    line_copy.append(parent)
+                    new_active.append(line_copy)
+        active = new_active
+    if len(successful_lines) == 0:
+        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
+    for line in successful_lines:
+        line.reverse()
+    if revision_history is not None:
+        by_historical_lines = []
+        for line in successful_lines:
+            count = historical_lines(line)
+            by_historical_lines.append((count, line))
+        by_historical_lines.sort()
+        if by_historical_lines[-1][0][0] > 0:
+            return by_historical_lines[-1][1]
+    assert len(successful_lines)
+    successful_lines.sort(cmp, len)
+    return successful_lines[-1]

=== removed file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2005-09-27 07:24:40 +0000
+++ bzrlib/revisionspec.py	1970-01-01 00:00:00 +0000
@@ -1,320 +0,0 @@
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import datetime
-import re
-from bzrlib.errors import BzrError, NoSuchRevision, NoCommits
-
-_marker = []
-
-class RevisionInfo(object):
-    """The results of applying a revision specification to a branch.
-
-    An instance has two useful attributes: revno, and rev_id.
-
-    They can also be accessed as spec[0] and spec[1] respectively,
-    so that you can write code like:
-    revno, rev_id = RevisionSpec(branch, spec)
-    although this is probably going to be deprecated later.
-
-    This class exists mostly to be the return value of a RevisionSpec,
-    so that you can access the member you're interested in (number or id)
-    or treat the result as a tuple.
-    """
-
-    def __init__(self, branch, revno, rev_id=_marker):
-        self.branch = branch
-        self.revno = revno
-        if rev_id is _marker:
-            # allow caller to be lazy
-            if self.revno is None:
-                self.rev_id = None
-            else:
-                self.rev_id = branch.get_rev_id(self.revno)
-        else:
-            self.rev_id = rev_id
-
-    def __nonzero__(self):
-        # first the easy ones...
-        if self.rev_id is None:
-            return False
-        if self.revno is not None:
-            return True
-        # TODO: otherwise, it should depend on how I was built -
-        # if it's in_history(branch), then check revision_history(),
-        # if it's in_store(branch), do the check below
-        return self.rev_id in self.branch.revision_store
-
-    def __len__(self):
-        return 2
-
-    def __getitem__(self, index):
-        if index == 0: return self.revno
-        if index == 1: return self.rev_id
-        raise IndexError(index)
-
-    def get(self):
-        return self.branch.get_revision(self.rev_id)
-
-    def __eq__(self, other):
-        if type(other) not in (tuple, list, type(self)):
-            return False
-        if type(other) is type(self) and self.branch is not other.branch:
-            return False
-        return tuple(self) == tuple(other)
-
-    def __repr__(self):
-        return '<bzrlib.revisionspec.RevisionInfo object %s, %s for %r>' % (
-            self.revno, self.rev_id, self.branch)
-
-# classes in this list should have a "prefix" attribute, against which
-# string specs are matched
-SPEC_TYPES = []
-
-class RevisionSpec(object):
-    """A parsed revision specification.
-
-    A revision specification can be an integer, in which case it is
-    assumed to be a revno (though this will translate negative values
-    into positive ones); or it can be a string, in which case it is
-    parsed for something like 'date:' or 'revid:' etc.
-
-    Revision specs are an UI element, and they have been moved out
-    of the branch class to leave "back-end" classes unaware of such
-    details.  Code that gets a revno or rev_id from other code should
-    not be using revision specs - revnos and revision ids are the
-    accepted ways to refer to revisions internally.
-
-    (Equivalent to the old Branch method get_revision_info())
-    """
-
-    prefix = None
-
-    def __new__(cls, spec, foo=_marker):
-        """Parse a revision specifier.
-        """
-        if spec is None:
-            return object.__new__(RevisionSpec, spec)
-
-        try:
-            spec = int(spec)
-        except ValueError:
-            pass
-
-        if isinstance(spec, int):
-            return object.__new__(RevisionSpec_int, spec)
-        elif isinstance(spec, basestring):
-            for spectype in SPEC_TYPES:
-                if spec.startswith(spectype.prefix):
-                    return object.__new__(spectype, spec)
-            else:
-                raise BzrError('No namespace registered for string: %r' %
-                               spec)
-        else:
-            raise TypeError('Unhandled revision type %s' % spec)
-
-    def __init__(self, spec):
-        if self.prefix and spec.startswith(self.prefix):
-            spec = spec[len(self.prefix):]
-        self.spec = spec
-
-    def _match_on(self, branch, revs):
-        return RevisionInfo(branch, 0, None)
-
-    def _match_on_and_check(self, branch, revs):
-        info = self._match_on(branch, revs)
-        if info:
-            return info
-        elif info == (0, None):
-            # special case - the empty tree
-            return info
-        elif self.prefix:
-            raise NoSuchRevision(branch, self.prefix + str(self.spec))
-        else:
-            raise NoSuchRevision(branch, str(self.spec))
-
-    def in_history(self, branch):
-        revs = branch.revision_history()
-        return self._match_on_and_check(branch, revs)
-
-    def __repr__(self):
-        # this is mostly for helping with testing
-        return '<%s %s%s>' % (self.__class__.__name__,
-                              self.prefix or '',
-                              self.spec)
-
-
-# private API
-
-class RevisionSpec_int(RevisionSpec):
-    """Spec is a number.  Special case."""
-    def __init__(self, spec):
-        self.spec = int(spec)
-
-    def _match_on(self, branch, revs):
-        if self.spec < 0:
-            revno = len(revs) + self.spec + 1
-        else:
-            revno = self.spec
-        rev_id = branch.get_rev_id(revno, revs)
-        return RevisionInfo(branch, revno, rev_id)
-
-
-class RevisionSpec_revno(RevisionSpec):
-    prefix = 'revno:'
-
-    def _match_on(self, branch, revs):
-        """Lookup a revision by revision number"""
-        try:
-            return RevisionInfo(branch, int(self.spec))
-        except ValueError:
-            return RevisionInfo(branch, None)
-
-SPEC_TYPES.append(RevisionSpec_revno)
-
-
-class RevisionSpec_revid(RevisionSpec):
-    prefix = 'revid:'
-
-    def _match_on(self, branch, revs):
-        try:
-            return RevisionInfo(branch, revs.index(self.spec) + 1, self.spec)
-        except ValueError:
-            return RevisionInfo(branch, None)
-
-SPEC_TYPES.append(RevisionSpec_revid)
-
-
-class RevisionSpec_last(RevisionSpec):
-
-    prefix = 'last:'
-
-    def _match_on(self, branch, revs):
-        try:
-            offset = int(self.spec)
-        except ValueError:
-            return RevisionInfo(branch, None)
-        else:
-            if offset <= 0:
-                raise BzrError('You must supply a positive value for --revision last:XXX')
-            return RevisionInfo(branch, len(revs) - offset + 1)
-
-SPEC_TYPES.append(RevisionSpec_last)
-
-
-class RevisionSpec_before(RevisionSpec):
-
-    prefix = 'before:'
-    
-    def _match_on(self, branch, revs):
-        r = RevisionSpec(self.spec)._match_on(branch, revs)
-        if (r.revno is None) or (r.revno == 0):
-            return r
-        return RevisionInfo(branch, r.revno - 1)
-
-SPEC_TYPES.append(RevisionSpec_before)
-
-
-class RevisionSpec_tag(RevisionSpec):
-    prefix = 'tag:'
-
-    def _match_on(self, branch, revs):
-        raise BzrError('tag: namespace registered, but not implemented.')
-
-SPEC_TYPES.append(RevisionSpec_tag)
-
-
-class RevisionSpec_date(RevisionSpec):
-    prefix = 'date:'
-    _date_re = re.compile(
-            r'(?P<date>(?P<year>\d\d\d\d)-(?P<month>\d\d)-(?P<day>\d\d))?'
-            r'(,|T)?\s*'
-            r'(?P<time>(?P<hour>\d\d):(?P<minute>\d\d)(:(?P<second>\d\d))?)?'
-        )
-
-    def _match_on(self, branch, revs):
-        """
-        Spec for date revisions:
-          date:value
-          value can be 'yesterday', 'today', 'tomorrow' or a YYYY-MM-DD string.
-          matches the first entry after a given date (either at midnight or
-          at a specified time).
-
-          So the proper way of saying 'give me all entries for today' is:
-              -r date:today..date:tomorrow
-        """
-        today = datetime.datetime.fromordinal(datetime.date.today().toordinal())
-        if self.spec.lower() == 'yesterday':
-            dt = today - datetime.timedelta(days=1)
-        elif self.spec.lower() == 'today':
-            dt = today
-        elif self.spec.lower() == 'tomorrow':
-            dt = today + datetime.timedelta(days=1)
-        else:
-            m = self._date_re.match(self.spec)
-            if not m or (not m.group('date') and not m.group('time')):
-                raise BzrError('Invalid revision date %r' % self.spec)
-
-            if m.group('date'):
-                year, month, day = int(m.group('year')), int(m.group('month')), int(m.group('day'))
-            else:
-                year, month, day = today.year, today.month, today.day
-            if m.group('time'):
-                hour = int(m.group('hour'))
-                minute = int(m.group('minute'))
-                if m.group('second'):
-                    second = int(m.group('second'))
-                else:
-                    second = 0
-            else:
-                hour, minute, second = 0,0,0
-
-            dt = datetime.datetime(year=year, month=month, day=day,
-                    hour=hour, minute=minute, second=second)
-        first = dt
-        for i in range(len(revs)):
-            r = branch.get_revision(revs[i])
-            # TODO: Handle timezone.
-            dt = datetime.datetime.fromtimestamp(r.timestamp)
-            if first <= dt:
-                return RevisionInfo(branch, i+1)
-        return RevisionInfo(branch, None)
-
-SPEC_TYPES.append(RevisionSpec_date)
-
-
-class RevisionSpec_ancestor(RevisionSpec):
-    prefix = 'ancestor:'
-
-    def _match_on(self, branch, revs):
-        from branch import Branch
-        from revision import common_ancestor, MultipleRevisionSources
-        other_branch = Branch.open_containing(self.spec)
-        revision_a = branch.last_revision()
-        revision_b = other_branch.last_revision()
-        for r, b in ((revision_a, branch), (revision_b, other_branch)):
-            if r is None:
-                raise NoCommits(b)
-        revision_source = MultipleRevisionSources(branch, other_branch)
-        rev_id = common_ancestor(revision_a, revision_b, revision_source)
-        try:
-            revno = branch.revision_id_to_revno(rev_id)
-        except NoSuchRevision:
-            revno = None
-        return RevisionInfo(branch, revno, rev_id)
-        
-SPEC_TYPES.append(RevisionSpec_ancestor)

=== removed file 'bzrlib/selftest/HTTPTestUtil.py'
--- bzrlib/selftest/HTTPTestUtil.py	2005-09-23 03:37:57 +0000
+++ bzrlib/selftest/HTTPTestUtil.py	1970-01-01 00:00:00 +0000
@@ -1,145 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import BaseHTTPServer, SimpleHTTPServer, socket, errno, time
-from bzrlib.selftest import TestCaseInTempDir
-
-
-class WebserverNotAvailable(Exception):
-    pass
-
-class BadWebserverPath(ValueError):
-    def __str__(self):
-        return 'path %s is not in %s' % self.args
-
-class TestingHTTPRequestHandler(SimpleHTTPServer.SimpleHTTPRequestHandler):
-    def log_message(self, format, *args):
-        self.server.test_case.log("webserver - %s - - [%s] %s" %
-                                  (self.address_string(),
-                                   self.log_date_time_string(),
-                                   format%args))
-
-    def handle_one_request(self):
-        """Handle a single HTTP request.
-
-        You normally don't need to override this method; see the class
-        __doc__ string for information on how to handle specific HTTP
-        commands such as GET and POST.
-
-        """
-        for i in xrange(1,11): # Don't try more than 10 times
-            try:
-                self.raw_requestline = self.rfile.readline()
-            except socket.error, e:
-                if e.args[0] == errno.EAGAIN:
-                    self.log_message('EAGAIN (%d) while reading from raw_requestline' % i)
-                    time.sleep(0.01)
-                    continue
-                raise
-            else:
-                break
-        if not self.raw_requestline:
-            self.close_connection = 1
-            return
-        if not self.parse_request(): # An error code has been sent, just exit
-            return
-        mname = 'do_' + self.command
-        if not hasattr(self, mname):
-            self.send_error(501, "Unsupported method (%r)" % self.command)
-            return
-        method = getattr(self, mname)
-        method()
-
-class TestingHTTPServer(BaseHTTPServer.HTTPServer):
-    def __init__(self, server_address, RequestHandlerClass, test_case):
-        BaseHTTPServer.HTTPServer.__init__(self, server_address,
-                                                RequestHandlerClass)
-        self.test_case = test_case
-
-
-class TestCaseWithWebserver(TestCaseInTempDir):
-    """Derived class that starts a localhost-only webserver
-    (in addition to what TestCaseInTempDir does).
-
-    This is useful for testing RemoteBranch.
-    """
-
-    _HTTP_PORTS = range(13000, 0x8000)
-
-    def _http_start(self):
-        import SimpleHTTPServer, BaseHTTPServer, socket, errno
-        httpd = None
-        for port in self._HTTP_PORTS:
-            try:
-                httpd = TestingHTTPServer(('localhost', port),
-                                          TestingHTTPRequestHandler,
-                                          self)
-            except socket.error, e:
-                if e.args[0] == errno.EADDRINUSE:
-                    continue
-                print >>sys.stderr, "Cannot run webserver :-("
-                raise
-            else:
-                break
-
-        if httpd is None:
-            raise WebserverNotAvailable("Cannot run webserver :-( "
-                                        "no free ports in range %s..%s" %
-                                        (_HTTP_PORTS[0], _HTTP_PORTS[-1]))
-
-        self._http_base_url = 'http://localhost:%s/' % port
-        self._http_starting.release()
-        httpd.socket.settimeout(0.1)
-
-        while self._http_running:
-            try:
-                httpd.handle_request()
-            except socket.timeout:
-                pass
-
-    def get_remote_url(self, path):
-        import os
-
-        path_parts = path.split(os.path.sep)
-        if os.path.isabs(path):
-            if path_parts[:len(self._local_path_parts)] != \
-                   self._local_path_parts:
-                raise BadWebserverPath(path, self.test_dir)
-            remote_path = '/'.join(path_parts[len(self._local_path_parts):])
-        else:
-            remote_path = '/'.join(path_parts)
-
-        self._http_starting.acquire()
-        self._http_starting.release()
-        return self._http_base_url + remote_path
-
-    def setUp(self):
-        TestCaseInTempDir.setUp(self)
-        import threading, os
-        self._local_path_parts = self.test_dir.split(os.path.sep)
-        self._http_starting = threading.Lock()
-        self._http_starting.acquire()
-        self._http_running = True
-        self._http_base_url = None
-        self._http_thread = threading.Thread(target=self._http_start)
-        self._http_thread.setDaemon(True)
-        self._http_thread.start()
-
-    def tearDown(self):
-        self._http_running = False
-        self._http_thread.join()
-        TestCaseInTempDir.tearDown(self)
-

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/__init__.py	2005-09-20 08:58:39 +0000
@@ -15,7 +15,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from cStringIO import StringIO
 import logging
 import unittest
 import tempfile
@@ -27,6 +26,7 @@
 
 import testsweet
 import bzrlib.commands
+
 import bzrlib.trace
 import bzrlib.fetch
 
@@ -76,6 +76,7 @@
         
         self._log_file_name = name
 
+        
     def tearDown(self):
         logging.getLogger('').removeHandler(self._log_hdlr)
         bzrlib.trace.enable_default_logging()
@@ -83,6 +84,7 @@
         self._log_file.close()
         unittest.TestCase.tearDown(self)
 
+
     def log(self, *args):
         logging.debug(*args)
 
@@ -90,16 +92,8 @@
         """Return as a string the log for this test"""
         return open(self._log_file_name).read()
 
-
-    def capture(self, cmd):
-        """Shortcut that splits cmd into words, runs, and returns stdout"""
-        return self.run_bzr_captured(cmd.split())[0]
-
-    def run_bzr_captured(self, argv, retcode=0):
-        """Invoke bzr and return (result, stdout, stderr).
-
-        Useful for code that wants to check the contents of the
-        output, the way error messages are presented, etc.
+    def run_bzr(self, *args, **kwargs):
+        """Invoke bzr, as if it were run from the command line.
 
         This should be the main method for tests that want to exercise the
         overall behavior of the bzr application (rather than a unit test
@@ -107,51 +101,13 @@
 
         Much of the old code runs bzr by forking a new copy of Python, but
         that is slower, harder to debug, and generally not necessary.
-
-        This runs bzr through the interface that catches and reports
-        errors, and with logging set to something approximating the
-        default, so that error reporting can be checked.
-
-        argv -- arguments to invoke bzr
-        retcode -- expected return code, or None for don't-care.
-        """
-        stdout = StringIO()
-        stderr = StringIO()
-        self.log('run bzr: %s', ' '.join(argv))
-        handler = logging.StreamHandler(stderr)
-        handler.setFormatter(bzrlib.trace.QuietFormatter())
-        handler.setLevel(logging.INFO)
-        logger = logging.getLogger('')
-        logger.addHandler(handler)
-        try:
-            result = self.apply_redirected(None, stdout, stderr,
-                                           bzrlib.commands.run_bzr_catch_errors,
-                                           argv)
-        finally:
-            logger.removeHandler(handler)
-        out = stdout.getvalue()
-        err = stderr.getvalue()
-        if out:
-            self.log('output:\n%s', out)
-        if err:
-            self.log('errors:\n%s', err)
-        if retcode is not None:
-            self.assertEquals(result, retcode)
-        return out, err
-
-    def run_bzr(self, *args, **kwargs):
-        """Invoke bzr, as if it were run from the command line.
-
-        This should be the main method for tests that want to exercise the
-        overall behavior of the bzr application (rather than a unit test
-        or a functional test of the library.)
-
-        This sends the stdout/stderr results into the test's log,
-        where it may be useful for debugging.  See also run_captured.
-        """
-        retcode = kwargs.pop('retcode', 0)
-        return self.run_bzr_captured(args, retcode)
-
+        """
+        retcode = kwargs.get('retcode', 0)
+        result = self.apply_redirected(None, None, None,
+                                       bzrlib.commands.run_bzr, args)
+        self.assertEquals(result, retcode)
+        
+        
     def check_inventory_shape(self, inv, shape):
         """Compare an inventory to a list of expected names.
 
@@ -177,20 +133,15 @@
         """Call callable with redirected std io pipes.
 
         Returns the return code."""
+        from StringIO import StringIO
         if not callable(a_callable):
             raise ValueError("a_callable must be callable.")
         if stdin is None:
             stdin = StringIO("")
         if stdout is None:
-            if hasattr(self, "_log_file"):
-                stdout = self._log_file
-            else:
-                stdout = StringIO()
+            stdout = self._log_file
         if stderr is None:
-            if hasattr(self, "_log_file"):
-                stderr = self._log_file
-            else:
-                stderr = StringIO()
+            stderr = self._log_file
         real_stdin = sys.stdin
         real_stdout = sys.stdout
         real_stderr = sys.stderr
@@ -231,7 +182,7 @@
         if contents != expect:
             self.log("expected: %r" % expect)
             self.log("actually: %r" % contents)
-            self.fail("contents of %s not as expected" % filename)
+            self.fail("contents of %s not as expected")
 
     def _make_test_root(self):
         if TestCaseInTempDir.TEST_ROOT is not None:
@@ -256,6 +207,7 @@
 
     def setUp(self):
         super(TestCaseInTempDir, self).setUp()
+        import os
         self._make_test_root()
         self._currentdir = os.getcwdu()
         short_id = self.id().replace('bzrlib.selftest.', '') \
@@ -265,9 +217,54 @@
         os.chdir(self.test_dir)
         
     def tearDown(self):
+        import os
         os.chdir(self._currentdir)
         super(TestCaseInTempDir, self).tearDown()
 
+    def _formcmd(self, cmd):
+        if isinstance(cmd, basestring):
+            cmd = cmd.split()
+        if cmd[0] == 'bzr':
+            cmd[0] = self.BZRPATH
+            if self.OVERRIDE_PYTHON:
+                cmd.insert(0, self.OVERRIDE_PYTHON)
+        self.log('$ %r' % cmd)
+        return cmd
+
+    def runcmd(self, cmd, retcode=0):
+        """Run one command and check the return code.
+
+        Returns a tuple of (stdout,stderr) strings.
+
+        If a single string is based, it is split into words.
+        For commands that are not simple space-separated words, please
+        pass a list instead."""
+        cmd = self._formcmd(cmd)
+        self.log('$ ' + ' '.join(cmd))
+        actual_retcode = subprocess.call(cmd, stdout=self._log_file,
+                                         stderr=self._log_file)
+        if retcode != actual_retcode:
+            raise CommandFailed("test failed: %r returned %d, expected %d"
+                                % (cmd, actual_retcode, retcode))
+
+    def backtick(self, cmd, retcode=0):
+        """Run a command and return its output"""
+        cmd = self._formcmd(cmd)
+        child = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=self._log_file)
+        outd, errd = child.communicate()
+        self.log(outd)
+        actual_retcode = child.wait()
+
+        outd = outd.replace('\r', '')
+
+        if retcode != actual_retcode:
+            raise CommandFailed("test failed: %r returned %d, expected %d"
+                                % (cmd, actual_retcode, retcode))
+
+        return outd
+
+
+
     def build_tree(self, shape):
         """Build a test tree according to a pattern.
 
@@ -277,6 +274,7 @@
         This doesn't add anything to a branch.
         """
         # XXX: It's OK to just create them using forward slashes on windows?
+        import os
         for name in shape:
             assert isinstance(name, basestring)
             if name[-1] == '/':
@@ -285,6 +283,7 @@
                 f = file(name, 'wt')
                 print >>f, "contents of", name
                 f.close()
+                
 
 
 class MetaTestLog(TestCase):
@@ -307,29 +306,28 @@
     import bzrlib, bzrlib.store, bzrlib.inventory, bzrlib.branch
     import bzrlib.osutils, bzrlib.commands, bzrlib.merge3, bzrlib.plugin
     from doctest import DocTestSuite
+    import os
+    import shutil
+    import time
+    import sys
 
     global MODULES_TO_TEST, MODULES_TO_DOCTEST
 
     testmod_names = \
                   ['bzrlib.selftest.MetaTestLog',
                    'bzrlib.selftest.testinv',
-                   'bzrlib.selftest.test_ancestry',
                    'bzrlib.selftest.test_commit',
                    'bzrlib.selftest.test_commit_merge',
                    'bzrlib.selftest.versioning',
                    'bzrlib.selftest.testmerge3',
-                   'bzrlib.selftest.testmerge',
                    'bzrlib.selftest.testhashcache',
                    'bzrlib.selftest.teststatus',
                    'bzrlib.selftest.testlog',
                    'bzrlib.selftest.testrevisionnamespaces',
                    'bzrlib.selftest.testbranch',
-                   'bzrlib.selftest.testremotebranch',
                    'bzrlib.selftest.testrevision',
-                   'bzrlib.selftest.test_revision_info',
                    'bzrlib.selftest.test_merge_core',
                    'bzrlib.selftest.test_smart_add',
-                   'bzrlib.selftest.test_bad_files',
                    'bzrlib.selftest.testdiff',
                    'bzrlib.selftest.test_parent',
                    'bzrlib.selftest.test_xml',
@@ -338,7 +336,6 @@
                    'bzrlib.selftest.whitebox',
                    'bzrlib.selftest.teststore',
                    'bzrlib.selftest.blackbox',
-                   'bzrlib.selftest.testgraph',
                    ]
 
     for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-09-29 02:01:49 +0000
+++ bzrlib/selftest/blackbox.py	2005-09-13 23:18:12 +0000
@@ -26,25 +26,24 @@
 it's normally invoked.
 """
 
-from cStringIO import StringIO
-import os
-import shutil
 import sys
 
 from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
 from bzrlib.branch import Branch
+from bzrlib.commands import run_bzr
 
 
 class ExternalBase(TestCaseInTempDir):
-
-    def runbzr(self, args, retcode=0, backtick=False):
+    def runbzr(self, args, retcode=0,backtick=False):
         if isinstance(args, basestring):
             args = args.split()
 
         if backtick:
-            return self.run_bzr_captured(args, retcode=retcode)[0]
+            return self.backtick(['python', self.BZRPATH,] + args,
+                           retcode=retcode)
         else:
-            return self.run_bzr_captured(args, retcode=retcode)
+            return self.runcmd(['python', self.BZRPATH,] + args,
+                           retcode=retcode)
 
 
 class TestCommands(ExternalBase):
@@ -73,22 +72,10 @@
         f = file('.bzr/email', 'wt')
         f.write('Branch Identity <branch@identi.ty>')
         f.close()
-        bzr_email = os.environ.get('BZREMAIL')
-        if bzr_email is not None:
-            del os.environ['BZREMAIL']
         whoami = self.runbzr("whoami",backtick=True)
         whoami_email = self.runbzr("whoami --email",backtick=True)
         self.assertTrue(whoami.startswith('Branch Identity <branch@identi.ty>'))
         self.assertTrue(whoami_email.startswith('branch@identi.ty'))
-        # Verify that the environment variable overrides the value 
-        # in the file
-        os.environ['BZREMAIL'] = 'Different ID <other@environ.ment>'
-        whoami = self.runbzr("whoami",backtick=True)
-        whoami_email = self.runbzr("whoami --email",backtick=True)
-        self.assertTrue(whoami.startswith('Different ID <other@environ.ment>'))
-        self.assertTrue(whoami_email.startswith('other@environ.ment'))
-        if bzr_email is not None:
-            os.environ['BZREMAIL'] = bzr_email
 
     def test_invalid_commands(self):
         self.runbzr("pants", retcode=1)
@@ -105,36 +92,37 @@
     def test_ignore_patterns(self):
         from bzrlib.branch import Branch
         
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.assertEquals(list(b.unknowns()), [])
 
         file('foo.tmp', 'wt').write('tmp files are ignored')
         self.assertEquals(list(b.unknowns()), [])
-        assert self.capture('unknowns') == ''
+        assert self.backtick('bzr unknowns') == ''
 
         file('foo.c', 'wt').write('int main() {}')
         self.assertEquals(list(b.unknowns()), ['foo.c'])
-        assert self.capture('unknowns') == 'foo.c\n'
+        assert self.backtick('bzr unknowns') == 'foo.c\n'
 
         self.runbzr(['add', 'foo.c'])
-        assert self.capture('unknowns') == ''
+        assert self.backtick('bzr unknowns') == ''
 
         # 'ignore' works when creating the .bzignore file
         file('foo.blah', 'wt').write('blah')
         self.assertEquals(list(b.unknowns()), ['foo.blah'])
         self.runbzr('ignore *.blah')
         self.assertEquals(list(b.unknowns()), [])
-        assert file('.bzrignore', 'rU').read() == '*.blah\n'
+        assert file('.bzrignore', 'rb').read() == '*.blah\n'
 
         # 'ignore' works when then .bzrignore file already exists
         file('garh', 'wt').write('garh')
         self.assertEquals(list(b.unknowns()), ['garh'])
-        assert self.capture('unknowns') == 'garh\n'
+        assert self.backtick('bzr unknowns') == 'garh\n'
         self.runbzr('ignore garh')
         self.assertEquals(list(b.unknowns()), [])
-        assert file('.bzrignore', 'rU').read() == '*.blah\ngarh\n'
+        assert file('.bzrignore', 'rb').read() == '*.blah\ngarh\n'
 
     def test_revert(self):
+        import os
         self.runbzr('init')
 
         file('hello', 'wt').write('foo')
@@ -159,29 +147,16 @@
         os.rmdir('revertdir')
         self.runbzr('revert')
 
-        file('hello', 'wt').write('xyz')
-        self.runbzr('commit -m xyz hello')
-        self.runbzr('revert -r 1 hello')
-        self.check_file_contents('hello', 'foo')
-        self.runbzr('revert hello')
-        self.check_file_contents('hello', 'xyz')
-        os.chdir('revertdir')
-        self.runbzr('revert')
-        os.chdir('..')
-
-
-    def test_mv_modes(self):
+    def skipped_test_mv_modes(self):
         """Test two modes of operation for mv"""
         from bzrlib.branch import Branch
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.build_tree(['a', 'c', 'subdir/'])
-        self.run_bzr_captured(['add', self.test_dir])
-        self.run_bzr_captured(['mv', 'a', 'b'])
-        self.run_bzr_captured(['mv', 'b', 'subdir'])
-        self.run_bzr_captured(['mv', 'subdir/b', 'a'])
-        self.run_bzr_captured(['mv', 'a', 'c', 'subdir'])
-        self.run_bzr_captured(['mv', 'subdir/a', 'subdir/newa'])
-
+        self.run_bzr('mv', 'a', 'b')
+        self.run_bzr('mv', 'b', 'subdir')
+        self.run_bzr('mv', 'subdir/b', 'a')
+        self.run_bzr('mv', 'a', 'b', 'subdir')
+        self.run_bzr('mv', 'subdir/a', 'subdir/newa')
 
     def test_main_version(self):
         """Check output from version command and master option is reasonable"""
@@ -207,38 +182,23 @@
         test.runbzr('add goodbye')
         test.runbzr('commit -m setup goodbye')
 
-    def test_diff(self):
-        self.example_branch()
-        file('hello', 'wt').write('hello world!')
-        self.runbzr('commit -m fixing hello')
-        output = self.runbzr('diff -r 2..3', backtick=1)
-        self.assert_('\n+hello world!' in output)
-        output = self.runbzr('diff -r last:3..last:1', backtick=1)
-        self.assert_('\n+baz' in output)
-
-    def test_branch(self):
-        """Branch from one branch to another."""
-        os.mkdir('a')
-        os.chdir('a')
-        self.example_branch()
-        os.chdir('..')
-        self.runbzr('branch a b')
-        self.runbzr('branch a c -r 1')
-        os.chdir('b')
-        self.runbzr('commit -m foo --unchanged')
-        os.chdir('..')
-        # naughty - abstraction violations RBC 20050928  
-        print "test_branch used to delete the stores, how is this meant to work ?"
-        #shutil.rmtree('a/.bzr/revision-store')
-        #shutil.rmtree('a/.bzr/inventory-store', ignore_errors=True)
-        #shutil.rmtree('a/.bzr/text-store', ignore_errors=True)
-        self.runbzr('branch a d --basis b')
+    def test_revert(self):
+        self.example_branch()
+        file('hello', 'wt').write('bar')
+        file('goodbye', 'wt').write('qux')
+        self.runbzr('revert hello')
+        self.check_file_contents('hello', 'foo')
+        self.check_file_contents('goodbye', 'qux')
+        self.runbzr('revert')
+        self.check_file_contents('goodbye', 'baz')
 
     def test_merge(self):
         from bzrlib.branch import Branch
+        import os
         
         os.mkdir('a')
         os.chdir('a')
+
         self.example_branch()
         os.chdir('..')
         self.runbzr('branch a b')
@@ -254,83 +214,35 @@
         self.runbzr('merge ../b')
         self.check_file_contents('goodbye', 'quux')
         # Merging a branch pulls its revision into the tree
-        a = Branch.open('.')
-        b = Branch.open('../b')
+        a = Branch('.')
+        b = Branch('../b')
         a.get_revision_xml(b.last_revision())
+
         self.log('pending merges: %s', a.pending_merges())
         #        assert a.pending_merges() == [b.last_revision()], "Assertion %s %s" \
         #        % (a.pending_merges(), b.last_revision())
 
-    def test_pull(self):
-        """Pull changes from one branch to another."""
-        os.mkdir('a')
-        os.chdir('a')
-
-        self.example_branch()
-        self.runbzr('pull', retcode=1)
-        self.runbzr('missing', retcode=1)
-        self.runbzr('missing .')
-        self.runbzr('missing')
-        self.runbzr('pull')
-        self.runbzr('pull /', retcode=1)
-        self.runbzr('pull')
-
-        os.chdir('..')
-        self.runbzr('branch a b')
-        os.chdir('b')
-        self.runbzr('pull')
-        os.mkdir('subdir')
-        self.runbzr('add subdir')
-        self.runbzr('commit -m blah --unchanged')
-        os.chdir('../a')
-        a = Branch.open('.')
-        b = Branch.open('../b')
-        assert a.revision_history() == b.revision_history()[:-1]
-        self.runbzr('pull ../b')
-        assert a.revision_history() == b.revision_history()
-        self.runbzr('commit -m blah2 --unchanged')
-        os.chdir('../b')
-        self.runbzr('commit -m blah3 --unchanged')
-        self.runbzr('pull ../a', retcode=1)
-        print "DECIDE IF PULL CAN CONVERGE, blackbox.py"
-        return
-        os.chdir('../a')
-        self.runbzr('merge ../b')
-        self.runbzr('commit -m blah4 --unchanged')
-        os.chdir('../b/subdir')
-        self.runbzr('pull ../../a')
-        assert a.revision_history()[-1] == b.revision_history()[-1]
-        self.runbzr('commit -m blah5 --unchanged')
-        self.runbzr('commit -m blah6 --unchanged')
-        os.chdir('..')
-        self.runbzr('pull ../a')
-        os.chdir('../a')
-        self.runbzr('commit -m blah7 --unchanged')
-        self.runbzr('merge ../b')
-        self.runbzr('commit -m blah8 --unchanged')
-        self.runbzr('pull ../b')
-        self.runbzr('pull ../b')
-        
+
     def test_add_reports(self):
         """add command prints the names of added files."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
-        out = self.run_bzr_captured(['add'], retcode = 0)[0]
+
+        from cStringIO import StringIO
+        out = StringIO()
+
+        ret = self.apply_redirected(None, out, None,
+                                    run_bzr,
+                                    ['add'])
+        self.assertEquals(ret, 0)
+
         # the ordering is not defined at the moment
-        results = sorted(out.rstrip('\n').split('\n'))
+        results = sorted(out.getvalue().rstrip('\n').split('\n'))
         self.assertEquals(['added dir',
-                           'added dir'+os.sep+'sub.txt',
+                           'added dir/sub.txt',
                            'added top.txt',],
                           results)
 
-    def test_unknown_command(self):
-        """Handling of unknown command."""
-        out, err = self.run_bzr_captured(['fluffy-badger'],
-                                         retcode=1)
-        self.assertEquals(out, '')
-        err.index('unknown command')
-        
-
 
 class OldTests(ExternalBase):
     """old tests moved from ./testbzr."""
@@ -338,9 +250,10 @@
     def test_bzr(self):
         from os import chdir, mkdir
         from os.path import exists
+        import os
 
         runbzr = self.runbzr
-        capture = self.capture
+        backtick = self.backtick
         progress = self.log
 
         progress("basic branch creation")
@@ -348,7 +261,7 @@
         chdir('branch1')
         runbzr('init')
 
-        self.assertEquals(capture('root').rstrip(),
+        self.assertEquals(backtick('bzr root').rstrip(),
                           os.path.join(self.test_dir, 'branch1'))
 
         progress("status of new file")
@@ -357,25 +270,26 @@
         f.write('hello world!\n')
         f.close()
 
-        self.assertEquals(capture('unknowns'), 'test.txt\n')
+        out = backtick("bzr unknowns")
+        self.assertEquals(out, 'test.txt\n')
 
-        out = capture("status")
+        out = backtick("bzr status")
         assert out == 'unknown:\n  test.txt\n'
 
-        out = capture("status --all")
+        out = backtick("bzr status --all")
         assert out == "unknown:\n  test.txt\n"
 
-        out = capture("status test.txt --all")
+        out = backtick("bzr status test.txt --all")
         assert out == "unknown:\n  test.txt\n"
 
         f = file('test2.txt', 'wt')
         f.write('goodbye cruel world...\n')
         f.close()
 
-        out = capture("status test.txt")
+        out = backtick("bzr status test.txt")
         assert out == "unknown:\n  test.txt\n"
 
-        out = capture("status")
+        out = backtick("bzr status")
         assert out == ("unknown:\n"
                        "  test.txt\n"
                        "  test2.txt\n")
@@ -383,11 +297,11 @@
         os.unlink('test2.txt')
 
         progress("command aliases")
-        out = capture("st --all")
+        out = backtick("bzr st --all")
         assert out == ("unknown:\n"
                        "  test.txt\n")
 
-        out = capture("stat")
+        out = backtick("bzr stat")
         assert out == ("unknown:\n"
                        "  test.txt\n")
 
@@ -397,7 +311,7 @@
         runbzr("help commands")
         runbzr("help slartibartfast", 1)
 
-        out = capture("help ci")
+        out = backtick("bzr help ci")
         out.index('aliases: ')
 
         progress("can't rename unversioned file")
@@ -406,8 +320,8 @@
         progress("adding a file")
 
         runbzr("add test.txt")
-        assert capture("unknowns") == ''
-        assert capture("status --all") == ("added:\n"
+        assert backtick("bzr unknowns") == ''
+        assert backtick("bzr status --all") == ("added:\n"
                                                 "  test.txt\n")
 
         progress("rename newly-added file")
@@ -415,7 +329,7 @@
         assert os.path.exists("hello.txt")
         assert not os.path.exists("test.txt")
 
-        assert capture("revno") == '0\n'
+        assert backtick("bzr revno") == '0\n'
 
         progress("add first revision")
         runbzr(['commit', '-m', 'add first revision'])
@@ -429,7 +343,7 @@
         runbzr("add sub1")
         runbzr("rename sub1 sub2")
         runbzr("move hello.txt sub2")
-        assert capture("relpath sub2/hello.txt") == os.path.join("sub2", "hello.txt\n")
+        assert backtick("bzr relpath sub2/hello.txt") == os.path.join("sub2", "hello.txt\n")
 
         assert exists("sub2")
         assert exists("sub2/hello.txt")
@@ -450,16 +364,15 @@
         runbzr(['commit', '-m', 'rename nested subdirectories'])
 
         chdir('sub1/sub2')
-        self.assertEquals(capture('root')[:-1],
+        self.assertEquals(backtick('bzr root')[:-1],
                           os.path.join(self.test_dir, 'branch1'))
         runbzr('move ../hello.txt .')
         assert exists('./hello.txt')
-        self.assertEquals(capture('relpath hello.txt'),
-                          os.path.join('sub1', 'sub2', 'hello.txt') + '\n')
-        assert capture('relpath ../../sub1/sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
+        assert backtick('bzr relpath hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
+        assert backtick('bzr relpath ../../sub1/sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
         runbzr(['commit', '-m', 'move to parent directory'])
         chdir('..')
-        assert capture('relpath sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
+        assert backtick('bzr relpath sub2/hello.txt') == os.path.join('sub1', 'sub2', 'hello.txt\n')
 
         runbzr('move sub2/hello.txt .')
         assert exists('hello.txt')
@@ -474,7 +387,7 @@
 
         runbzr('commit -F msg.tmp')
 
-        assert capture('revno') == '5\n'
+        assert backtick('bzr revno') == '5\n'
         runbzr('export -r 5 export-5.tmp')
         runbzr('export export.tmp')
 
@@ -482,11 +395,11 @@
         runbzr('log -v')
         runbzr('log -v --forward')
         runbzr('log -m', retcode=1)
-        log_out = capture('log -m commit')
+        log_out = backtick('bzr log -m commit')
         assert "this is my new commit" in log_out
         assert "rename nested" not in log_out
         assert 'revision-id' not in log_out
-        assert 'revision-id' in capture('log --show-ids -m commit')
+        assert 'revision-id' in backtick('bzr log --show-ids -m commit')
 
 
         progress("file with spaces in name")

=== modified file 'bzrlib/selftest/test_ancestry.py'
--- bzrlib/selftest/test_ancestry.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/test_ancestry.py	2005-09-13 05:11:27 +0000
@@ -21,14 +21,12 @@
 
 from bzrlib.selftest import TestCase, TestCaseInTempDir
 from bzrlib.branch import Branch
-from bzrlib.revision import is_ancestor
 
 
 class TestAncestry(TestCaseInTempDir):
-
     def test_straightline_ancestry(self):
         """Test ancestry file when just committing."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         b.commit(message='one',
                  allow_pointless=True,
@@ -40,16 +38,12 @@
 
         ancs = b.get_ancestry('tester@foo--2')
 
-    def test_none_is_always_an_ancestor(self):
-        b = Branch.initialize('.')
-        # note this is tested before any commits are done.
-        self.assertEqual(True, is_ancestor(None, None, b))
-        b.commit(message='one',
-                 allow_pointless=True,
-                 rev_id='tester@foo--1')
-        self.assertEqual(True, is_ancestor(None, None, b))
-        self.assertEqual(True, is_ancestor('tester@foo--1', None, b))
-        self.assertEqual(False, is_ancestor(None, 'tester@foo--1', b))
 
 
 # TODO: check that ancestry is updated to include indirectly merged revisions
+        
+        
+
+if __name__ == '__main__':
+    import unittest
+    sys.exit(unittest.main())

=== removed file 'bzrlib/selftest/test_bad_files.py'
--- bzrlib/selftest/test_bad_files.py	2005-09-18 16:09:41 +0000
+++ bzrlib/selftest/test_bad_files.py	1970-01-01 00:00:00 +0000
@@ -1,93 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Tests being able to ignore mad filetypes.
-"""
-
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.errors import BadFileKindError
-import os
-
-def verify_status(tester, branch, value):
-    from bzrlib.status import show_status
-    from cStringIO import StringIO
-
-    tof = StringIO()
-    show_status(branch, to_file=tof)
-    tof.seek(0)
-    tester.assertEquals(tof.readlines(), value)
-
-
-class TestBadFiles(TestCaseInTempDir):
-    
-    def test_bad_files(self): 
-        """Test that bzr will ignore files it doesn't like"""
-        from bzrlib.commit import commit
-        from bzrlib.add import smart_add
-        from bzrlib.branch import Branch
-
-        b = Branch.initialize('.')
-
-        self.build_tree(['one', 'two', 'three'])
-        smart_add('.')
-        commit(b, "Commit one", rev_id="a@u-0-0")
-        self.build_tree(['four'])
-        smart_add('.')
-        commit(b, "Commit two", rev_id="a@u-0-1")
-        self.build_tree(['five'])
-        smart_add('.')
-        commit(b, "Commit three", rev_id="a@u-0-2")
-
-        # We should now have a few files, lets try to
-        # put some bogus stuff in the tree
-
-        # We can only continue if we have mkfifo
-        if not hasattr(os, 'mkfifo'):
-            return
-
-        # status with nothing
-        verify_status(self, b, [])
-
-        os.mkfifo('a-fifo')
-        self.build_tree(['six'])
-
-        verify_status(self, b,
-                          ['unknown:\n',
-                           '  a-fifo\n',
-                           '  six\n'
-                           ])
-        
-        # Make sure smart_add can handle having a bogus
-        # file in the way
-        smart_add('.')
-        verify_status(self, b,
-                          ['added:\n',
-                           '  six\n',
-                           'unknown:\n',
-                           '  a-fifo\n',
-                           ])
-        commit(b, "Commit four", rev_id="a@u-0-3")
-
-        verify_status(self, b,
-                          ['unknown:\n',
-                           '  a-fifo\n',
-                           ])
-
-        # We should raise an error if we are adding a bogus file
-        # Is there a way to test the actual error that should be raised?
-        self.run_bzr('add', 'a-fifo', retcode=1)
-

=== modified file 'bzrlib/selftest/test_commit.py'
--- bzrlib/selftest/test_commit.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/test_commit.py	2005-09-16 09:47:48 +0000
@@ -26,10 +26,9 @@
 # TODO: Test commit with some added, and added-but-missing files
 
 class TestCommit(TestCaseInTempDir):
-
     def test_simple_commit(self):
         """Commit and check two versions of a single file."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         file('hello', 'w').write('hello world')
         b.add('hello')
         b.commit(message='add hello')
@@ -54,7 +53,7 @@
 
     def test_delete_commit(self):
         """Test a commit with a deleted file"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         file('hello', 'w').write('hello world')
         b.add(['hello'], ['hello-id'])
         b.commit(message='add hello')
@@ -68,7 +67,7 @@
 
     def test_pointless_commit(self):
         """Commit refuses unless there are changes or it's forced."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         file('hello', 'w').write('hello')
         b.add(['hello'])
         b.commit(message='add hello')
@@ -83,7 +82,7 @@
 
     def test_commit_empty(self):
         """Commiting an empty tree works."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         b.commit(message='empty tree', allow_pointless=True)
         self.assertRaises(PointlessCommit,
                           b.commit,
@@ -95,7 +94,7 @@
 
     def test_selective_delete(self):
         """Selective commit in tree with deletions"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         file('hello', 'w').write('hello')
         file('buongia', 'w').write('buongia')
         b.add(['hello', 'buongia'],
@@ -130,7 +129,7 @@
 
     def test_commit_rename(self):
         """Test commit of a revision where a file is renamed."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.build_tree(['hello'])
         b.add(['hello'], ['hello-id'])
         b.commit(message='one', rev_id='test@rev-1', allow_pointless=False)
@@ -157,7 +156,7 @@
 
     def test_reused_rev_id(self):
         """Test that a revision id cannot be reused in a branch"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         b.commit('initial', rev_id='test@rev-1', allow_pointless=True)
         self.assertRaises(Exception,
                           b.commit,
@@ -170,7 +169,7 @@
     def test_commit_move(self):
         """Test commit of revisions with moved files and directories"""
         eq = self.assertEquals
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         r1 = 'test@rev-1'
         self.build_tree(['hello', 'a/', 'b/'])
         b.add(['hello', 'a', 'b'], ['hello-id', 'a-id', 'b-id'])
@@ -205,7 +204,7 @@
         
     def test_removed_commit(self):
         """Test a commit with a removed file"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         file('hello', 'w').write('hello world')
         b.add(['hello'], ['hello-id'])
         b.commit(message='add hello')
@@ -219,7 +218,7 @@
 
     def test_committed_ancestry(self):
         """Test commit appends revisions to ancestry."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         rev_ids = []
         for i in range(4):
             file('hello', 'w').write((str(i) * 4) + '\n')
@@ -233,4 +232,12 @@
         eq(b.revision_history(), rev_ids)
         for i in range(4):
             anc = b.get_ancestry(rev_ids[i])
-            eq(anc, [None] + rev_ids[:i+1])
+            eq(anc, rev_ids[:i+1])
+            
+        
+
+
+if __name__ == '__main__':
+    import unittest
+    unittest.main()
+    

=== modified file 'bzrlib/selftest/test_commit_merge.py'
--- bzrlib/selftest/test_commit_merge.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/test_commit_merge.py	2005-09-21 08:57:00 +0000
@@ -38,8 +38,8 @@
         """Simple commit of two-way merge of empty trees."""
         os.mkdir('x')
         os.mkdir('y')
-        bx = Branch.initialize('x')
-        by = Branch.initialize('y')
+        bx = Branch('x', init=True)
+        by = Branch('y', init=True)
 
         commit(bx, 'commit one', rev_id='x@u-0-1', allow_pointless=True)
         commit(by, 'commit two', rev_id='y@u-0-1', allow_pointless=True)
@@ -66,8 +66,8 @@
         """Commit merge of two trees with no overlapping files."""
         self.build_tree(['x/', 'x/ecks', 'y/', 'y/why'])
 
-        bx = Branch.initialize('x')
-        by = Branch.initialize('y')
+        bx = Branch('x', init=True)
+        by = Branch('y', init=True)
         bx.add(['ecks'], ['ecks-id'])
         by.add(['why'], ['why-id'])
 
@@ -96,3 +96,9 @@
 
         check(bx)
         check(by)
+
+
+if __name__ == '__main__':
+    import unittest
+    unittest.main()
+    

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-09-26 08:56:15 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-09-01 06:33:48 +0000
@@ -1,19 +1,20 @@
 import os
-import shutil
-import tempfile
 import unittest
 
 from bzrlib.selftest import TestCaseInTempDir, TestCase
 from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import NotBranchError, NotVersionedError
+
+
+import tempfile
+import shutil
 from bzrlib.inventory import InventoryEntry, RootEntry
-from bzrlib.osutils import file_kind, rename
+from bzrlib.osutils import file_kind
 from bzrlib import changeset
 from bzrlib.merge_core import (ApplyMerge3, make_merge_changeset,
                                 BackupBeforeChange, PermissionsMerge)
 from bzrlib.changeset import Inventory, apply_changeset, invert_dict
 
-
 class FalseTree(object):
     def __init__(self, realtree):
         self._realtree = realtree
@@ -99,7 +100,7 @@
 
     def change_path(self, id, path):
         old_path = os.path.join(self.dir, self.inventory[id])
-        rename(old_path, self.abs_path(path))
+        os.rename(old_path, self.abs_path(path))
         self.inventory[id] = path
 
 
@@ -239,7 +240,7 @@
         os.chmod(tree.full_path(id), mode)
 
     def merge_changeset(self, merge_factory):
-        conflict_handler = changeset.ExceptionConflictHandler()
+        conflict_handler = changeset.ExceptionConflictHandler(self.this.dir)
         return make_merge_changeset(self.cset, self.this, self.base,
                                     self.other, conflict_handler,
                                     merge_factory)
@@ -474,7 +475,7 @@
         from bzrlib.merge import merge
         # John starts a branch
         self.build_tree(("original/", "original/file1", "original/file2"))
-        branch = Branch.initialize("original")
+        branch = Branch("original", init=True)
         smart_add_branch(branch, ["original"], True, add_reporter_null)
         branch.commit("start branch.", verbose=False)
         # Mary branches it.
@@ -486,7 +487,7 @@
         file.close()
         branch.commit("change file1")
         # Mary does too
-        mary_branch = Branch.open("mary")
+        mary_branch = Branch("mary")
         file = open("mary/file2", "wt")
         file.write("Mary\n")
         file.close()

=== modified file 'bzrlib/selftest/test_parent.py'
--- bzrlib/selftest/test_parent.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/test_parent.py	2005-09-12 09:35:43 +0000
@@ -26,13 +26,13 @@
 class TestParent(TestCaseInTempDir):
     def test_no_default_parent(self):
         """Branches should have no parent by default"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.assertEquals(b.get_parent(), None)
         
     
     def test_set_get_parent(self):
         """Set and then re-get the parent"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         url = 'http://bazaar-ng.org/bzr/bzr.dev'
         b.set_parent(url)
         self.assertEquals(b.get_parent(), url)
@@ -42,7 +42,7 @@
         from bzrlib.commands import run_bzr
 
         os.mkdir('from')
-        branch_from = Branch.initialize('from')
+        branch_from = Branch('from', init=True)
         file('from/foo', 'wt').write('contents of foo')
         branch_from.add('foo')
         branch_from.commit('initial commit')
@@ -50,7 +50,7 @@
         os.mkdir('to')
         copy_branch(branch_from, 'to', None)
 
-        branch_to = Branch.open('to')
+        branch_to = Branch('to')
         abspath = os.path.abspath('from')
         self.assertEquals(branch_to.get_parent(), abspath)
         

=== removed file 'bzrlib/selftest/test_revision_info.py'
--- bzrlib/selftest/test_revision_info.py	2005-09-19 06:05:19 +0000
+++ bzrlib/selftest/test_revision_info.py	1970-01-01 00:00:00 +0000
@@ -1,110 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.errors import BzrCommandError, NoSuchRevision
-from bzrlib.branch import Branch
-from bzrlib.revisionspec import RevisionSpec
-
-class TestRevisionInfo(TestCaseInTempDir):
-    
-    def check_error(self, output, *args):
-        """Verify that the expected error matches what bzr says.
-        
-        The output is supplied first, so that you can supply a variable
-        number of arguments to bzr.
-        """
-        self.assertEquals(self.run_bzr_captured(args, retcode=1)[1], output)
-
-    def check_output(self, output, *args):
-        """Verify that the expected output matches what bzr says.
-        
-        The output is supplied first, so that you can supply a variable
-        number of arguments to bzr.
-        """
-        self.assertEquals(self.run_bzr_captured(args)[0], output)
-
-    def test_revision_info(self):
-        """Test that 'bzr revision-info' reports the correct thing.
-        """
-
-        b = Branch.initialize('.')
-
-        b.commit('Commit one', rev_id='a@r-0-1')
-        b.commit('Commit two', rev_id='a@r-0-2')
-        b.commit('Commit three', rev_id='a@r-0-3')
-
-        # Make sure revision-info without any arguments throws an exception
-        self.check_error('bzr: ERROR: You must supply a revision identifier\n',
-                         'revision-info')
-
-        values = {
-            1:'   1 a@r-0-1\n',
-            2:'   2 a@r-0-2\n',
-            3:'   3 a@r-0-3\n'
-        }
-
-        # Check the results of just specifying a numeric revision
-        self.check_output(values[1], 'revision-info', '1')
-        self.check_output(values[2], 'revision-info', '2')
-        self.check_output(values[3], 'revision-info', '3')
-        self.check_output(values[1]+values[2], 'revision-info', '1', '2')
-        self.check_output(values[1]+values[2]+values[3], 'revision-info', '1', '2', '3')
-        self.check_output(values[2]+values[1], 'revision-info', '2', '1')
-
-        # Check as above, only using the '--revision' syntax
-        
-        self.check_output('   1 a@r-0-1\n', 'revision-info', '-r', '1')
-        self.check_output('   2 a@r-0-2\n', 'revision-info', '--revision', '2')
-        self.check_output('   3 a@r-0-3\n', 'revision-info', '-r', '3')
-        self.check_output('   1 a@r-0-1\n   2 a@r-0-2\n', 'revision-info', '-r', '1..2')
-        self.check_output('   1 a@r-0-1\n   2 a@r-0-2\n   3 a@r-0-3\n'
-                , 'revision-info', '-r', '1..2..3')
-        self.check_output('   2 a@r-0-2\n   1 a@r-0-1\n', 'revision-info', '-r', '2..1')
-
-        # Now try some more advanced revision specifications
-        
-        self.check_output('   1 a@r-0-1\n', 'revision-info', '-r', 'revid:a@r-0-1')
-        self.check_output('   2 a@r-0-2\n', 'revision-info', '--revision', 'revid:a@r-0-2')
-
-    def test_cat_revision(self):
-        """Test bzr cat-revision.
-        """
-        b = Branch.initialize('.')
-
-        b.commit('Commit one', rev_id='a@r-0-1')
-        b.commit('Commit two', rev_id='a@r-0-2')
-        b.commit('Commit three', rev_id='a@r-0-3')
-
-        revs = {
-            1:b.get_revision_xml_file('a@r-0-1').read(),
-            2:b.get_revision_xml_file('a@r-0-2').read(),
-            3:b.get_revision_xml_file('a@r-0-3').read()
-        }
-
-        self.check_output(revs[1], 'cat-revision', 'a@r-0-1')
-        self.check_output(revs[2], 'cat-revision', 'a@r-0-2')
-        self.check_output(revs[3], 'cat-revision', 'a@r-0-3')
-
-        self.check_output(revs[1], 'cat-revision', '-r', '1')
-        self.check_output(revs[2], 'cat-revision', '-r', '2')
-        self.check_output(revs[3], 'cat-revision', '-r', '3')
-
-        self.check_output(revs[1], 'cat-revision', '-r', 'revid:a@r-0-1')
-        self.check_output(revs[2], 'cat-revision', '-r', 'revid:a@r-0-2')
-        self.check_output(revs[3], 'cat-revision', '-r', 'revid:a@r-0-3')
-

=== modified file 'bzrlib/selftest/test_smart_add.py'
--- bzrlib/selftest/test_smart_add.py	2005-09-09 11:37:44 +0000
+++ bzrlib/selftest/test_smart_add.py	2005-09-01 06:33:48 +0000
@@ -12,7 +12,7 @@
         from bzrlib.add import smart_add
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        branch = Branch.initialize(".")
+        branch = Branch(".", init=True)
         smart_add((".",), recurse=True)
         for path in paths:
             self.assertNotEqual(branch.inventory.path2id(path), None)
@@ -22,7 +22,7 @@
         from bzrlib.add import smart_add
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        branch = Branch.initialize(".")
+        branch = Branch(".", init=True)
         os.chdir("original")
         smart_add((".",), recurse=True)
         for path in paths:
@@ -35,7 +35,7 @@
         branch_paths = ("branch/", "branch/original/", "branch/original/file1",
                         "branch/original/file2")
         self.build_tree(branch_paths)
-        branch = Branch.initialize("branch")
+        branch = Branch("branch", init=True)
         smart_add(("branch",))
         for path in paths:
             self.assertNotEqual(branch.inventory.path2id(path), None)
@@ -51,8 +51,8 @@
                        "original/child/", "original/child/path")
         
         self.build_tree(build_paths)
-        branch = Branch.initialize(".")
-        child_branch = Branch.initialize("original/child")
+        branch = Branch(".", init=True)
+        child_branch = Branch("original/child", init=True)
         smart_add((".",), True, add_reporter_null)
         for path in paths:
             self.assertNotEqual((path, branch.inventory.path2id(path)),
@@ -68,7 +68,7 @@
         from bzrlib.add import smart_add
         paths = ("file1", "file2")
         self.build_tree(paths)
-        branch = Branch.initialize(".")
+        branch = Branch(".", init=True)
         smart_add(paths)
         for path in paths:
             self.assertNotEqual(branch.inventory.path2id(path), None)
@@ -81,7 +81,7 @@
         from bzrlib.add import smart_add_branch
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        branch = Branch.initialize(".")
+        branch = Branch(".", init=True)
         smart_add_branch(branch, (".",))
         for path in paths:
             self.assertNotEqual(branch.inventory.path2id(path), None)
@@ -91,7 +91,7 @@
         from bzrlib.add import smart_add_branch
         paths = ("original/", "original/file1", "original/file2")
         self.build_tree(paths)
-        branch = Branch.initialize(".")
+        branch = Branch(".", init=True)
         os.chdir("original")
         smart_add_branch(branch, (".",))
         for path in paths:
@@ -104,7 +104,7 @@
         branch_paths = ("branch/", "branch/original/", "branch/original/file1",
                         "branch/original/file2")
         self.build_tree(branch_paths)
-        branch = Branch.initialize("branch")
+        branch = Branch("branch", init=True)
         smart_add_branch(branch, ("branch",))
         for path in paths:
             self.assertNotEqual(branch.inventory.path2id(path), None)
@@ -118,8 +118,8 @@
         build_paths = ("original/", "original/file1", "original/file2", 
                        "original/child/", "original/child/path")
         self.build_tree(build_paths)
-        branch = Branch.initialize(".")
-        child_branch = Branch.initialize("original/child")
+        branch = Branch(".", init=True)
+        child_branch = Branch("original/child", init=True)
         smart_add_branch(branch, (".",))
         for path in paths:
             self.assertNotEqual((path, branch.inventory.path2id(path)),
@@ -135,7 +135,7 @@
         from bzrlib.add import smart_add_branch
         paths = ("file1", "file2")
         self.build_tree(paths)
-        branch = Branch.initialize(".")
+        branch = Branch(".", init=True)
         smart_add_branch(branch, paths)
         for path in paths:
             self.assertNotEqual(branch.inventory.path2id(path), None)

=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-09-28 09:35:50 +0000
+++ bzrlib/selftest/testbranch.py	2005-09-15 08:37:41 +0000
@@ -14,33 +14,34 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+
 import os
-from bzrlib.branch import Branch, copy_branch
-from bzrlib.commit import commit
-from bzrlib.errors import NoSuchRevision, UnlistableBranch
+
 from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.branch import Branch
 from bzrlib.trace import mutter
 
-class TestBranch(TestCaseInTempDir):
 
+class TestAppendRevisions(TestCaseInTempDir):
+    """Test appending more than one revision"""
     def test_append_revisions(self):
-        """Test appending more than one revision"""
-        br = Branch.initialize(".")
+        from bzrlib.branch import Branch
+        br = Branch(".", init=True)
         br.append_revision("rev1")
         self.assertEquals(br.revision_history(), ["rev1",])
         br.append_revision("rev2", "rev3")
         self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
 
 
+
 class TestFetch(TestCaseInTempDir):
-
     def test_fetch_revisions(self):
         """Test fetch-revision operation."""
         from bzrlib.fetch import Fetcher
         os.mkdir('b1')
         os.mkdir('b2')
-        b1 = Branch.initialize('b1')
-        b2 = Branch.initialize('b2')
+        b1 = Branch('b1', init=True)
+        b2 = Branch('b2', init=True)
         file(os.sep.join(['b1', 'foo']), 'w').write('hello')
         b1.add(['foo'], ['foo-id'])
         b1.commit('lala!', rev_id='revision-1', allow_pointless=False)
@@ -55,35 +56,7 @@
         tree = b2.revision_tree('revision-1')
         eq(tree.get_file_text('foo-id'), 'hello')
 
-    def test_push_stores(self):
-        """Copy the stores from one branch to another"""
-        os.mkdir('a')
-        br_a = Branch.initialize("a")
-        file('a/b', 'wb').write('b')
-        br_a.add('b')
-        commit(br_a, "silly commit")
-
-        os.mkdir('b')
-        br_b = Branch.initialize("b")
-        self.assertRaises(NoSuchRevision, br_b.get_revision, 
-                          br_a.revision_history()[0])
-        br_a.push_stores(br_b)
-        rev = br_b.get_revision(br_a.revision_history()[0])
-        tree = br_b.revision_tree(br_a.revision_history()[0])
-        for file_id in tree:
-            if tree.inventory[file_id].kind == "file":
-                tree.get_file(file_id).read()
-        return br_a, br_b
-
-    def test_copy_branch(self):
-        """Copy the stores from one branch to another"""
-        br_a, br_b = self.test_push_stores()
-        commit(br_b, "silly commit")
-        os.mkdir('c')
-        br_c = copy_branch(br_a, 'c', basis_branch=br_b)
-        self.assertEqual(br_a.revision_history(), br_c.revision_history())
-        assert br_b.last_revision() not in br_c.revision_history()
-        br_c.get_revision(br_b.last_revision())
+
 # TODO: rewrite this as a regular unittest, without relying on the displayed output        
 #         >>> from bzrlib.commit import commit
 #         >>> bzrlib.trace.silent = True

=== modified file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-09-29 02:01:49 +0000
+++ bzrlib/selftest/testfetch.py	2005-09-16 06:41:34 +0000
@@ -14,8 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import sys
 import os
-import sys
 
 import bzrlib.errors
 from bzrlib.selftest.testrevision import make_branches
@@ -24,7 +24,7 @@
 from bzrlib.fetch import greedy_fetch
 
 from bzrlib.selftest import TestCaseInTempDir
-
+        
 
 def has_revision(branch, revision_id):
     try:
@@ -33,75 +33,77 @@
     except bzrlib.errors.NoSuchRevision:
         return False
 
-def fetch_steps(self, br_a, br_b, writable_a):
-    """A foreign test method for testing fetch locally and remotely."""
-    def new_branch(name):
-        os.mkdir(name)
-        return Branch.initialize(name)
+
+
+class TestFetch(TestCaseInTempDir):
+    def SKIPPED_old_test_fetch(self):
+        """obsolete: new commit code depends on parents being present
+        so the test data no longer suits this test."""
+        
+        def new_branch(name):
+            os.mkdir(name)
+            return Branch(name, init=True)
             
-    assert not has_revision(br_b, br_a.revision_history()[3])
-    assert has_revision(br_b, br_a.revision_history()[2])
-    assert len(br_b.revision_history()) == 7
-    assert greedy_fetch(br_b, br_a, br_a.revision_history()[2])[0] == 0
-
-    # greedy_fetch is not supposed to alter the revision history
-    assert len(br_b.revision_history()) == 7
-    assert not has_revision(br_b, br_a.revision_history()[3])
-
-    assert len(br_b.revision_history()) == 7
-    assert greedy_fetch(br_b, br_a, br_a.revision_history()[3])[0] == 1
-    assert has_revision(br_b, br_a.revision_history()[3])
-    assert not has_revision(br_a, br_b.revision_history()[6])
-    assert has_revision(br_a, br_b.revision_history()[5])
-
-    # When a non-branch ancestor is missing, it should be a failure, not
-    # exception
-    print ("CANNOT TEST MISSING NON REVISION_HISTORY ANCESTORS WITHOUT"
-           " GHOSTS")
-#    br_a4 = new_branch('br_a4')
-#    count, failures = greedy_fetch(br_a4, br_a)
-#    self.assertEqual(count, 6)
-#    self.assertEqual(failures, set((br_b.revision_history()[4],
-#                                    br_b.revision_history()[5]))) 
-
-    self.assertEqual(greedy_fetch(writable_a, br_b)[0], 1)
-    assert has_revision(br_a, br_b.revision_history()[3])
-    assert has_revision(br_a, br_b.revision_history()[4])
-        
-    br_b2 = new_branch('br_b2')
-    assert greedy_fetch(br_b2, br_b)[0] == 7
-    assert has_revision(br_b2, br_b.revision_history()[4])
-    assert has_revision(br_b2, br_a.revision_history()[2])
-    assert not has_revision(br_b2, br_a.revision_history()[3])
-
-    br_a2 = new_branch('br_a2')
-    assert greedy_fetch(br_a2, br_a)[0] == 9
-    assert has_revision(br_a2, br_b.revision_history()[4])
-    assert has_revision(br_a2, br_a.revision_history()[3])
-    assert has_revision(br_a2, br_a.revision_history()[2])
-
-    br_a3 = new_branch('br_a3')
-    assert greedy_fetch(br_a3, br_a2)[0] == 0
-    for revno in range(4):
-        assert not has_revision(br_a3, br_a.revision_history()[revno])
-    self.assertEqual(greedy_fetch(br_a3, br_a2, br_a.revision_history()[2])[0], 3)
-    fetched = greedy_fetch(br_a3, br_a2, br_a.revision_history()[3])[0]
-    assert fetched == 3, "fetched %d instead of 3" % fetched
-    # InstallFailed should be raised if the branch is missing the revision
-    # that was requested.
-    self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
-                      br_a2, 'pizza')
-    # InstallFailed should be raised if the branch is missing a revision
-    # from its own revision history
-    br_a2.append_revision('a-b-c')
-    self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
-                      br_a2)
-
-
-class TestFetch(TestCaseInTempDir):
-
-    def test_fetch(self):
-        
         #highest indices a: 5, b: 7
         br_a, br_b = make_branches()
-        fetch_steps(self, br_a, br_b, br_a)
+        assert not has_revision(br_b, br_a.revision_history()[3])
+        assert has_revision(br_b, br_a.revision_history()[2])
+        assert len(br_b.revision_history()) == 7
+        assert greedy_fetch(br_b, br_a, br_a.revision_history()[2])[0] == 0
+
+        # greedy_fetch is not supposed to alter the revision history
+        assert len(br_b.revision_history()) == 7
+        assert not has_revision(br_b, br_a.revision_history()[3])
+
+        assert len(br_b.revision_history()) == 7
+        assert greedy_fetch(br_b, br_a, br_a.revision_history()[3])[0] == 1
+        assert has_revision(br_b, br_a.revision_history()[3])
+        assert not has_revision(br_a, br_b.revision_history()[3])
+        assert not has_revision(br_a, br_b.revision_history()[4])
+
+        # When a non-branch ancestor is missing, it should be a failure, not
+        # exception
+        br_a4 = new_branch('br_a4')
+        count, failures = greedy_fetch(br_a4, br_a)
+        assert count == 6
+        assert failures == set((br_b.revision_history()[4],
+                                br_b.revision_history()[5])) 
+
+        assert greedy_fetch(br_a, br_b)[0] == 4
+        assert has_revision(br_a, br_b.revision_history()[3])
+        assert has_revision(br_a, br_b.revision_history()[4])
+
+        br_b2 = new_branch('br_b2')
+        assert greedy_fetch(br_b2, br_b)[0] == 7
+        assert has_revision(br_b2, br_b.revision_history()[4])
+        assert has_revision(br_b2, br_a.revision_history()[2])
+        assert not has_revision(br_b2, br_a.revision_history()[3])
+
+        br_a2 = new_branch('br_a2')
+        assert greedy_fetch(br_a2, br_a)[0] == 9
+        assert has_revision(br_a2, br_b.revision_history()[4])
+        assert has_revision(br_a2, br_a.revision_history()[3])
+
+        br_a3 = new_branch('br_a3')
+        assert greedy_fetch(br_a3, br_a2)[0] == 0
+        for revno in range(4):
+            assert not has_revision(br_a3, br_a.revision_history()[revno])
+        assert greedy_fetch(br_a3, br_a2, br_a.revision_history()[2])[0] == 3
+        fetched = greedy_fetch(br_a3, br_a2, br_a.revision_history()[3])[0]
+        assert fetched == 3, "fetched %d instead of 3" % fetched
+        # InstallFailed should be raised if the branch is missing the revision
+        # that was requested.
+        self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
+                          br_a2, 'pizza')
+        # InstallFailed should be raised if the branch is missing a revision
+        # from its own revision history
+        br_a2.append_revision('a-b-c')
+        self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
+                          br_a2)
+
+
+
+if __name__ == '__main__':
+    import unittest
+    unittest.main()
+    

=== removed file 'bzrlib/selftest/testgraph.py'
--- bzrlib/selftest/testgraph.py	2005-09-21 15:33:23 +0000
+++ bzrlib/selftest/testgraph.py	1970-01-01 00:00:00 +0000
@@ -1,49 +0,0 @@
-from bzrlib.selftest import TestCase
-from bzrlib.graph import node_distances, nodes_by_distance
-
-class TestBase(TestCase):
-    def edge_add(self, *args):
-        for start, end in zip(args[:-1], args[1:]):
-            if start not in self.graph:
-                self.graph[start] = {}
-            if end not in self.graph:
-                self.graph[end] = {}
-            self.graph[start][end] = 1
-
-    def setUp(self):
-        TestCase.setUp(self)
-        self.graph = {}
-        self.edge_add('A', 'B', 'C', 'D')
-        self.edge_add('A', 'E', 'F', 'C')
-        self.edge_add('A', 'G', 'H', 'I', 'B')
-        self.edge_add('A', 'J', 'K', 'L', 'M', 'N')
-        self.edge_add('O', 'N')
-
-    def node_descendants(self):
-        descendants = {'A':set()}
-        for node in self.graph:
-            for ancestor in self.graph[node]:
-                if ancestor not in descendants:
-                    descendants[ancestor] = set()
-                descendants[ancestor].add(node)
-        return descendants
-    
-    def test_distances(self):
-        descendants = self.node_descendants()
-        distances = node_distances(self.graph, descendants, 'A')
-        nodes = nodes_by_distance(distances)
-        self.assertEqual(nodes[0], 'D')
-        assert nodes[1] in ('N', 'C')
-        assert nodes[2] in ('N', 'C')
-        assert nodes[3] in ('B', 'M')
-        assert nodes[4] in ('B', 'M')
-
-        #Ensure we don't shortcut through B when there's only a difference of
-        # 1 in distance
-        self.graph = {}
-        self.edge_add('A', 'B', 'C')
-        self.edge_add('A', 'D', 'E', 'C')
-        descendants = self.node_descendants()
-        distances = node_distances(self.graph, descendants, 'A')
-        self.assertEqual(distances['C'], 3)
-

=== modified file 'bzrlib/selftest/testhashcache.py'
--- bzrlib/selftest/testhashcache.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/testhashcache.py	2005-09-16 06:43:57 +0000
@@ -14,8 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import os
-import time
 from bzrlib.selftest import TestCaseInTempDir
 
 
@@ -27,14 +25,12 @@
 
 def pause():
     if False:
-        return
-    if os.name == 'nt':
-        time.sleep(3)
-        return
-    # allow it to stabilize
-    start = int(time.time())
-    while int(time.time()) == start:
-        time.sleep(0.2)
+        # enable this to get more accurate testing
+        import time
+        # allow it to stabilize
+        start = int(time.time())
+        while int(time.time()) == start:
+            time.sleep(0.2)
     
 
 class TestHashCache(TestCaseInTempDir):

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-09-23 09:25:16 +0000
+++ bzrlib/selftest/testinv.py	2005-09-05 08:00:35 +0000
@@ -14,7 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import os
 from bzrlib.selftest import TestCase
 
 from bzrlib.inventory import Inventory, InventoryEntry
@@ -24,10 +23,9 @@
 
     def test_is_within(self):
         from bzrlib.osutils import is_inside_any
-
-        SRC_FOO_C = os.path.join('src', 'foo.c')
-        for dirs, fn in [(['src', 'doc'], SRC_FOO_C),
-                         (['src'], SRC_FOO_C),
+        
+        for dirs, fn in [(['src', 'doc'], 'src/foo.c'),
+                         (['src'], 'src/foo.c'),
                          (['src'], 'src'),
                          ]:
             self.assert_(is_inside_any(dirs, fn))

=== modified file 'bzrlib/selftest/testlog.py'
--- bzrlib/selftest/testlog.py	2005-09-23 03:05:48 +0000
+++ bzrlib/selftest/testlog.py	2005-09-05 01:31:37 +0000
@@ -65,7 +65,7 @@
             self.assertEquals(expected, got)
 
     def test_cur_revno(self):
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         lf = LogCatcher()
         b.commit('empty commit')
@@ -86,7 +86,7 @@
     def test_simple_log(self):
         eq = self.assertEquals
         
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         lf = LogCatcher()
         show_log(b, lf)
@@ -132,12 +132,3 @@
         self.log('log 2 delta: %r' % d)
         # self.checkDelta(d, added=['hello'])
         
-        # commit a log message with control characters
-        msg = "All 8-bit chars: " +  ''.join([unichr(x) for x in range(256)])
-        b.commit(msg)
-        lf = LogCatcher()
-        show_log(b, lf, verbose=True)
-        committed_msg = lf.logs[0].rev.message
-        self.log("escaped commit message: %r", committed_msg)
-        self.assert_(msg != committed_msg)
-        self.assert_(len(committed_msg) > len(msg))

=== removed file 'bzrlib/selftest/testmerge.py'
--- bzrlib/selftest/testmerge.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/testmerge.py	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-import os
-
-from bzrlib.branch import Branch
-from bzrlib.commit import commit
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.merge import merge
-from bzrlib.errors import UnrelatedBranches, NoCommits
-from bzrlib.revision import common_ancestor
-from bzrlib.fetch import fetch
-
-
-class TestMerge(TestCaseInTempDir):
-    """Test appending more than one revision"""
-    def test_pending(self):
-        br = Branch.initialize(".")
-        commit(br, "lala!")
-        self.assertEquals(len(br.pending_merges()), 0)
-        merge(['.', -1], [None, None])
-        self.assertEquals(len(br.pending_merges()), 0)
-
-    def test_nocommits(self):
-        self.test_pending()
-        os.mkdir('branch2')
-        br2 = Branch.initialize('branch2')
-        self.assertRaises(NoCommits, merge, ['branch2', -1], 
-                          [None, None])
-        return br2
-
-    def test_unrelated(self):
-        br2 = self.test_nocommits()
-        commit(br2, "blah")
-        self.assertRaises(UnrelatedBranches, merge, ['branch2', -1], 
-                          [None, None])
-        return br2
-
-    def test_pending_with_null(self):
-        """When base is forced to revno 0, pending_merges is set"""
-        br2 = self.test_unrelated()
-        br1 = Branch.open('.')
-        fetch(from_branch=br2, to_branch=br1)
-        # merge all of branch 2 into branch 1 even though they 
-        # are not related.
-        merge(['branch2', -1], ['branch2', 0])
-        self.assertEquals(len(br1.pending_merges()), 1)
-        return (br1, br2)
-
-    def test_two_roots(self):
-        """Merge base is sane when two unrelated branches are merged"""
-        br1, br2 = self.test_pending_with_null()
-        commit(br1, "blah")
-        last = br1.last_revision()
-        self.assertEquals(common_ancestor(last, last, br1), last)

=== removed file 'bzrlib/selftest/testremotebranch.py'
--- bzrlib/selftest/testremotebranch.py	2005-09-29 02:01:49 +0000
+++ bzrlib/selftest/testremotebranch.py	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-import bzrlib.errors
-from bzrlib.selftest.testrevision import make_branches
-from bzrlib.trace import mutter
-from bzrlib.branch import Branch, find_branch
-import gzip
-import sys
-import os
-
-from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
-
-from bzrlib.selftest.testfetch import fetch_steps
-
-class TestFetch(TestCaseWithWebserver):
-    def runTest(self):
-        from bzrlib.fetch import greedy_fetch
-        from bzrlib.selftest.testfetch import has_revision
-
-        def new_branch(name):
-            os.mkdir(name)
-            return Branch.initialize(name)
-            
-        #highest indices a: 5, b: 7
-        br_a, br_b = make_branches()
-        # unpack one of br_a's revision files to test .gz fallbacks
-        to_unzip = br_a.revision_history()[-1]
-        to_unzip_source = gzip.open(os.path.join(br_a.base, '.bzr', 
-                                                  'revision-store',
-                                                  to_unzip + '.gz'))
-        content = to_unzip_source.read()
-        to_unzip_source.close()
-        os.unlink(os.path.join(br_a.base, '.bzr', 'revision-store',
-                               to_unzip + '.gz'))
-        to_unzip_output = open(os.path.join(br_a.base, '.bzr', 
-                                             'revision-store', to_unzip), 'wb')
-        to_unzip_output.write(content)
-        to_unzip_output.close()
-        
-        br_rem = Branch.open(self.get_remote_url(br_a.base))
-        fetch_steps(self, br_rem, br_b, br_a)
-

=== modified file 'bzrlib/selftest/testrevision.py'
--- bzrlib/selftest/testrevision.py	2005-09-29 00:24:44 +0000
+++ bzrlib/selftest/testrevision.py	2005-09-16 06:21:56 +0000
@@ -21,41 +21,21 @@
 from bzrlib.branch import Branch
 from bzrlib.commit import commit
 from bzrlib.fetch import fetch
-from bzrlib.revision import (find_present_ancestors, combined_graph,
-                             is_ancestor, MultipleRevisionSources)
+from bzrlib.revision import (find_present_ancestors, common_ancestor,
+                             is_ancestor)
 from bzrlib.trace import mutter
 from bzrlib.errors import NoSuchRevision
 
 def make_branches():
-    """Create two branches
-
-    branch 1 has 6 commits, branch 2 has 3 commits
-    commit 10 was a psuedo merge from branch 1
-    but has been disabled until ghost support is
-    implemented.
-
-    the object graph is
-    B:     A:
-    a..0   a..0 
-    a..1   a..1
-    a..2   a..2
-    b..3   a..3 merges b..4
-    b..4   a..4
-    b..5   a..5 merges b..5
-    b..6
-
-    so A is missing b6 at the start
-    and B is missing a3, a4, a5
-    """
     os.mkdir("branch1")
-    br1 = Branch.initialize("branch1")
+    br1 = Branch("branch1", init=True)
     
     commit(br1, "Commit one", rev_id="a@u-0-0")
     commit(br1, "Commit two", rev_id="a@u-0-1")
     commit(br1, "Commit three", rev_id="a@u-0-2")
 
     os.mkdir("branch2")
-    br2 = Branch.initialize("branch2")
+    br2 = Branch("branch2", init=True)
     br2.update_revisions(br1)
     commit(br2, "Commit four", rev_id="b@u-0-3")
     commit(br2, "Commit five", rev_id="b@u-0-4")
@@ -71,14 +51,12 @@
     fetch(from_branch=br2, to_branch=br1)
     br1.add_pending_merge(br2.revision_history()[5])
     commit(br1, "Commit nine", rev_id="a@u-0-5")
-    # disabled - it makes testing fetch too hard,
-    # but can be easily reenabled (without the fetch
-    # when GHOSTS are supported. RBC 20050928
-    #fetch(from_branch=br1, to_branch=br2)
-    #br2.add_pending_merge(br1.revision_history()[4])
-    commit(br2, "Commit ten - no merge", rev_id="b@u-0-6")
-
-    #fetch(from_branch=br2, to_branch=br1)
+
+    fetch(from_branch=br1, to_branch=br2)
+    br2.add_pending_merge(br1.revision_history()[4])
+    commit(br2, "Commit ten", rev_id="b@u-0-6")
+
+    fetch(from_branch=br2, to_branch=br1)
     
     return br1, br2
 
@@ -102,22 +80,16 @@
              ('a@u-0-5', ['a@u-0-0', 'a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4',
                           'b@u-0-3', 'b@u-0-4',
                           'b@u-0-5', 'a@u-0-5']),
-             ('b@u-0-6', ['a@u-0-0', 'a@u-0-1', 'a@u-0-2',
+             ('b@u-0-6', ['a@u-0-0', 'a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4',
                           'b@u-0-3', 'b@u-0-4',
                           'b@u-0-5', 'b@u-0-6']),
              ]
-        br1_only = ('a@u-0-3', 'a@u-0-4', 'a@u-0-5')
-        br2_only = ('b@u-0-6',)
         for branch in br1, br2:
             for rev_id, anc in d:
-                if rev_id in br1_only and not branch is br1:
-                    continue
-                if rev_id in br2_only and not branch is br2:
-                    continue
                 mutter('ancestry of {%s}: %r',
                        rev_id, branch.get_ancestry(rev_id))
                 self.assertEquals(sorted(branch.get_ancestry(rev_id)),
-                                  [None] + sorted(anc))
+                                  sorted(anc))
     
     
     def test_is_ancestor(self):
@@ -131,7 +103,7 @@
         assert is_ancestor(revisions[1], revisions[0], sources)
         assert not is_ancestor(revisions[0], revisions[1], sources)
         assert is_ancestor(revisions_2[3], revisions[0], sources)
-        # disabled mbp 20050914, doesn't seem to happen anymore
+	# disabled mbp 20050914, doesn't seem to happen anymore
         ## self.assertRaises(NoSuchRevision, is_ancestor, revisions_2[3],
         ##                  revisions[0], br1)        
         assert is_ancestor(revisions[3], revisions_2[4], sources)
@@ -152,11 +124,11 @@
         self.br2.commit("Commit twelve", rev_id="b@u-0-8")
         self.br2.commit("Commit thirtteen", rev_id="b@u-0-9")
 
-        fetch(from_branch=self.br2, to_branch=self.br1)
+	fetch(from_branch=self.br2, to_branch=self.br1)
         self.br1.add_pending_merge(self.br2.revision_history()[6])
         self.br1.commit("Commit fourtten", rev_id="a@u-0-6")
 
-        fetch(from_branch=self.br1, to_branch=self.br2)
+	fetch(from_branch=self.br1, to_branch=self.br2)
         self.br2.add_pending_merge(self.br1.revision_history()[6])
         self.br2.commit("Commit fifteen", rev_id="b@u-0-10")
 
@@ -186,15 +158,13 @@
                                         self.br1.revision_history()), 
                          ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
                           'a@u-0-5'])
-        print ("testrevision.py 191 - intervene appears to return b..6 even"
-               "though it is not reachable!")
-#        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-6', 
-#                         self.br1.revision_history()), 
-#                         ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
-#                          'b@u-0-6'])
-#        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-5'), 
-#                         ['a@u-0-1', 'a@u-0-2', 'b@u-0-3', 'b@u-0-4', 
-#                          'b@u-0-5'])
+        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-6', 
+                         self.br1.revision_history()), 
+                         ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
+                          'b@u-0-6'])
+        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-5'), 
+                         ['a@u-0-1', 'a@u-0-2', 'b@u-0-3', 'b@u-0-4', 
+                          'b@u-0-5'])
         self.assertEqual(self.intervene('b@u-0-3', 'b@u-0-6', 
                          self.br2.revision_history()), 
                          ['b@u-0-4', 'b@u-0-5', 'b@u-0-6'])
@@ -214,52 +184,11 @@
 class TestCommonAncestor(TestCaseInTempDir):
     """Test checking whether a revision is an ancestor of another revision"""
 
-    def test_old_common_ancestor(self):
-        """Pick a resonable merge base using the old functionality"""
-        from bzrlib.revision import old_common_ancestor as common_ancestor
-        br1, br2 = make_branches()
-        revisions = br1.revision_history()
-        revisions_2 = br2.revision_history()
-        sources = br1
-
-        expected_ancestors_list = {revisions[3]:(0, 0), 
-                                   revisions[2]:(1, 1),
-                                   revisions_2[4]:(2, 1), 
-                                   revisions[1]:(3, 2),
-                                   revisions_2[3]:(4, 2),
-                                   revisions[0]:(5, 3) }
-        ancestors_list = find_present_ancestors(revisions[3], sources)
-        assert len(expected_ancestors_list) == len(ancestors_list)
-        for key, value in expected_ancestors_list.iteritems():
-            self.assertEqual(ancestors_list[key], value, 
-                              "key %r, %r != %r" % (key, ancestors_list[key],
-                                                    value))
-
-        self.assertEqual(common_ancestor(revisions[0], revisions[0], sources),
-                          revisions[0])
-        self.assertEqual(common_ancestor(revisions[1], revisions[2], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[1], revisions[1], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[2], revisions_2[4], sources),
-                          revisions[2])
-        self.assertEqual(common_ancestor(revisions[3], revisions_2[4], sources),
-                          revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
-                          revisions_2[4])
-        fetch(from_branch=br2, to_branch=br1)
-        self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions_2[5])
-        self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
-                          revisions_2[5])
-
     def test_common_ancestor(self):
-        """Pick a reasonable merge base"""
-        from bzrlib.revision import common_ancestor
         br1, br2 = make_branches()
         revisions = br1.revision_history()
         revisions_2 = br2.revision_history()
-        sources = MultipleRevisionSources(br1, br2)
+        sources = br1
 
         expected_ancestors_list = {revisions[3]:(0, 0), 
                                    revisions[2]:(1, 1),
@@ -287,21 +216,12 @@
         self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
                           revisions_2[4])
         self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions_2[5])
+                          revisions[4])
         self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
                           revisions_2[5])
 
-    def test_combined(self):
-        """combined_graph
-        Ensure it's not order-sensitive
-        """
-        br1, br2 = make_branches()
-        source = MultipleRevisionSources(br1, br2)
-        combined_1 = combined_graph(br1.last_revision(), 
-                                    br2.last_revision(), source)
-        combined_2 = combined_graph(br2.last_revision(),
-                                    br1.last_revision(), source)
-        assert combined_1[1] == combined_2[1]
-        assert combined_1[2] == combined_2[2]
-        assert combined_1[3] == combined_2[3]
-        assert combined_1 == combined_2
+
+if __name__ == '__main__':
+    import unittest, sys
+    unittest.main()
+    

=== modified file 'bzrlib/selftest/testrevisionnamespaces.py'
--- bzrlib/selftest/testrevisionnamespaces.py	2005-09-23 08:54:16 +0000
+++ bzrlib/selftest/testrevisionnamespaces.py	2005-09-04 02:59:56 +0000
@@ -15,66 +15,33 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-import time
 from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.errors import NoCommonAncestor, NoCommits
-from bzrlib.branch import copy_branch
-from bzrlib.merge import merge
 
 class TestRevisionNamespaces(TestCaseInTempDir):
-
     def test_revision_namespaces(self):
-        """Test revision specifiers.
-
-        These identify revisions by date, etc."""
+        """Functional tests for hashcache"""
         from bzrlib.errors import NoSuchRevision
         from bzrlib.branch import Branch
-        from bzrlib.revisionspec import RevisionSpec
-
-        b = Branch.initialize('.')
-
-        b.commit('Commit one', rev_id='a@r-0-1', timestamp=time.time() - 60*60*24)
+
+        b = Branch('.', init=True)
+
+        b.commit('Commit one', rev_id='a@r-0-1')
         b.commit('Commit two', rev_id='a@r-0-2')
         b.commit('Commit three', rev_id='a@r-0-3')
 
-        self.assertEquals(RevisionSpec(None).in_history(b), (0, None))
-        self.assertEquals(RevisionSpec(1).in_history(b), (1, 'a@r-0-1'))
-        self.assertEquals(RevisionSpec('revno:1').in_history(b),
-                          (1, 'a@r-0-1'))
-        self.assertEquals(RevisionSpec('revid:a@r-0-1').in_history(b),
-                          (1, 'a@r-0-1'))
-        self.assertRaises(NoSuchRevision,
-                          RevisionSpec('revid:a@r-0-0').in_history, b)
-        self.assertRaises(TypeError, RevisionSpec, object)
-
-        self.assertEquals(RevisionSpec('date:today').in_history(b),
-                          (2, 'a@r-0-2'))
-        self.assertEquals(RevisionSpec('date:yesterday').in_history(b),
-                          (1, 'a@r-0-1'))
-        self.assertEquals(RevisionSpec('before:date:today').in_history(b),
-                          (1, 'a@r-0-1'))
-
-        self.assertEquals(RevisionSpec('last:1').in_history(b),
-                          (3, 'a@r-0-3'))
-        self.assertEquals(RevisionSpec('-1').in_history(b), (3, 'a@r-0-3'))
-#        self.assertEquals(b.get_revision_info('last:1'), (3, 'a@r-0-3'))
-#        self.assertEquals(b.get_revision_info('-1'), (3, 'a@r-0-3'))
-
-        self.assertEquals(RevisionSpec('ancestor:.').in_history(b).rev_id,
-                          'a@r-0-3')
+        self.assertEquals(b.get_revision_info(None), (0, None))
+        self.assertEquals(b.get_revision_info(1), (1, 'a@r-0-1'))
+        self.assertEquals(b.get_revision_info('revno:1'), (1, 'a@r-0-1'))
+        self.assertEquals(b.get_revision_info('revid:a@r-0-1'), (1, 'a@r-0-1'))
+        self.assertRaises(NoSuchRevision, b.get_revision_info, 'revid:a@r-0-0')
+        self.assertRaises(TypeError, b.get_revision_info, object)
+
+        self.assertEquals(b.get_revision_info('date:-tomorrow'), (3, 'a@r-0-3'))
+        self.assertEquals(b.get_revision_info('date:+today'), (1, 'a@r-0-1'))
+
+        self.assertEquals(b.get_revision_info('last:1'), (3, 'a@r-0-3'))
+        self.assertEquals(b.get_revision_info('-1'), (3, 'a@r-0-3'))
 
         os.mkdir('newbranch')
-        b2 = Branch.initialize('newbranch')
-        self.assertRaises(NoCommits, RevisionSpec('ancestor:.').in_history, b2)
-
-        os.mkdir('copy')
-        b3 = copy_branch(b, 'copy')
-        b3.commit('Commit four', rev_id='b@r-0-4')
-        self.assertEquals(RevisionSpec('ancestor:.').in_history(b3).rev_id,
-                          'a@r-0-3')
-        merge(['copy', -1], [None, None])
-        b.commit('Commit five', rev_id='a@r-0-4')
-        self.assertEquals(RevisionSpec('ancestor:copy').in_history(b).rev_id,
-                          'b@r-0-4')
-        self.assertEquals(RevisionSpec('ancestor:.').in_history(b3).rev_id,
-                          'b@r-0-4')
+        b2 = Branch('newbranch', init=True)
+        self.assertEquals(b2.lookup_revision('revid:a@r-0-1'), 'a@r-0-1')

=== modified file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-09-23 02:58:03 +0000
+++ bzrlib/selftest/teststatus.py	2005-09-04 02:59:56 +0000
@@ -22,7 +22,6 @@
 
 
 from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.revisionspec import RevisionSpec
 
 class BranchStatus(TestCaseInTempDir):
     
@@ -32,7 +31,7 @@
         from bzrlib.status import show_status
         from bzrlib.branch import Branch
         
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         # status with nothing
         tof = StringIO()
@@ -52,44 +51,3 @@
                            '  pending@pending-0-0\n'
                            ])
 
-    def test_branch_status_revisions(self):
-        """Tests branch status with revisions"""
-        from cStringIO import StringIO
-        from bzrlib.status import show_status
-        from bzrlib.branch import Branch
-        
-        b = Branch.initialize('.')
-
-        tof = StringIO()
-        self.build_tree(['hello.c', 'bye.c'])
-        b.add('hello.c')
-        b.add('bye.c')
-        b.commit('Test message')
-
-        tof = StringIO()
-        revs =[]
-        revs.append(RevisionSpec(0))
-        
-        show_status(b, to_file=tof, revision=revs)
-        
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['added:\n',
-                           '  bye.c\n',
-                           '  hello.c\n'])
-
-        self.build_tree(['more.c'])
-        b.add('more.c')
-        b.commit('Another test message')
-        
-        tof = StringIO()
-        revs.append(RevisionSpec(1))
-        
-        show_status(b, to_file=tof, revision=revs)
-        
-        tof.seek(0)
-        self.assertEquals(tof.readlines(),
-                          ['added:\n',
-                           '  bye.c\n',
-                           '  hello.c\n'])
-

=== modified file 'bzrlib/selftest/teststore.py'
--- bzrlib/selftest/teststore.py	2005-09-28 07:08:18 +0000
+++ bzrlib/selftest/teststore.py	2005-09-04 02:59:56 +0000
@@ -16,15 +16,10 @@
 
 """Test Store implementation
 """
-
+from bzrlib.store import ImmutableStore
+from bzrlib.selftest import TestCaseInTempDir
 from StringIO import StringIO
-import os
-
-from bzrlib.remotebranch import RemoteStore
-from bzrlib.store import ImmutableStore, copy_all
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.errors import BzrError, UnlistableStore
-
+from bzrlib.errors import BzrError
 
 class TestStore(TestCaseInTempDir):
     def test_multiple_add(self):
@@ -33,15 +28,6 @@
         store.add(StringIO('goodbye'), '123123')
         self.assertRaises(BzrError, store.add, StringIO('goodbye'), '123123')
 
-    def test_copy_all(self):
-        """Test copying"""
-        os.mkdir('a')
-        store_a = ImmutableStore('a')
-        store_a.add('foo', '1')
-        os.mkdir('b')
-        store_b = ImmutableStore('b')
-        copy_all(store_a, store_b)
-        self.assertEqual(store_a['1'].read(), 'foo')
-        self.assertEqual(store_b['1'].read(), 'foo')
-        store_c = RemoteStore('http://example.com/')
-        self.assertRaises(UnlistableStore, copy_all, store_c, store_b)
+TEST_CLASSES = [
+    TestStore,
+    ]

=== modified file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/versioning.py	2005-09-22 12:12:53 +0000
@@ -17,6 +17,7 @@
 
 """Tests of simple versioning operations"""
 
+# TODO: test adding a file whose directory is not versioned
 # TODO: test trying to commit within a directory that is not yet added
 
 
@@ -44,7 +45,7 @@
 
         from bzrlib.diff import compare_trees
         from bzrlib.branch import Branch
-        b = Branch.open('.')
+        b = Branch('.')
         
         delta = compare_trees(b.basis_tree(), b.working_tree())
 
@@ -54,16 +55,16 @@
         self.assertEquals(delta.added[0][0], 'foo')
         self.failIf(delta.modified)
 
-    def test_branch_add_in_unversioned(self):
+    def test_add_in_unversioned(self):
         """Try to add a file in an unversioned directory.
 
-        "bzr add" adds the parent as necessary, but simple branch add
-        doesn't do that.
+        smart_add may eventually add the parent as necessary, but simple
+        branch add doesn't do that.
         """
         from bzrlib.branch import Branch
         from bzrlib.errors import NotVersionedError
 
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         self.build_tree(['foo/',
                          'foo/hello'])
@@ -74,53 +75,7 @@
         
         self.check_branch()
 
-
-    def test_add_in_unversioned(self):
-        """Try to add a file in an unversioned directory.
-
-        "bzr add" should add the parent(s) as necessary.
-        """
-        from bzrlib.branch import Branch
-        from bzrlib.commands import run_bzr
-        eq = self.assertEqual
-
-        b = Branch.initialize('.')
-
-        self.build_tree(['inertiatic/', 'inertiatic/esp'])
-        eq(list(b.unknowns()), ['inertiatic'])
-        run_bzr(['add', 'inertiatic/esp'])
-        eq(list(b.unknowns()), [])
-
-        # Multiple unversioned parents
-        self.build_tree(['veil/', 'veil/cerpin/', 'veil/cerpin/taxt'])
-        eq(list(b.unknowns()), ['veil'])
-        run_bzr(['add', 'veil/cerpin/taxt'])
-        eq(list(b.unknowns()), [])
-
-        # Check whacky paths work
-        self.build_tree(['cicatriz/', 'cicatriz/esp'])
-        eq(list(b.unknowns()), ['cicatriz'])
-        run_bzr(['add', 'inertiatic/../cicatriz/esp'])
-        eq(list(b.unknowns()), [])
-
-    def test_add_in_versioned(self):
-        """Try to add a file in a versioned directory.
-
-        "bzr add" should do this happily.
-        """
-        from bzrlib.branch import Branch
-        from bzrlib.commands import run_bzr
-        eq = self.assertEqual
-
-        b = Branch.initialize('.')
-
-        self.build_tree(['inertiatic/', 'inertiatic/esp'])
-        eq(list(b.unknowns()), ['inertiatic'])
-        run_bzr(['add', '--no-recurse', 'inertiatic'])
-        eq(list(b.unknowns()), ['inertiatic'+os.sep+'esp'])
-        run_bzr(['add', 'inertiatic/esp'])
-        eq(list(b.unknowns()), [])
-
+        
     def test_subdir_add(self):
         """Add in subdirectory should add only things from there down"""
         
@@ -131,7 +86,7 @@
         ass = self.assert_
         chdir = os.chdir
         
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.build_tree(['src/', 'README'])
         
         eq(sorted(b.unknowns()),
@@ -159,7 +114,7 @@
         """After all the above changes, run the check and upgrade commands.
 
         The upgrade should be a no-op."""
-        b = Branch.open('.')
+        b = Branch('.')
         debug('branch has %d revisions', b.revno())
         
         debug('check branch...')
@@ -168,6 +123,7 @@
         
 
         
+        
 class SubdirCommit(TestCaseInTempDir):
 
     def test_subdir_commit(self):
@@ -178,7 +134,7 @@
         self.build_tree(['a/', 'b/'])
         
         run_bzr('init')
-        b = Branch.open('.')
+        b = Branch('.')
         
         for fn in ('a/one', 'b/two', 'top'):
             file(fn, 'w').write('old contents')
@@ -192,8 +148,8 @@
         debug('start selective subdir commit')
         run_bzr('commit', 'a', '-m', 'commit a only')
         
-        old = b.revision_tree(b.get_rev_id(1))
-        new = b.revision_tree(b.get_rev_id(2))
+        old = b.revision_tree(b.lookup_revision(1))
+        new = b.revision_tree(b.lookup_revision(2))
         
         eq(new.get_file_by_path('b/two').read(), 'old contents')
         eq(new.get_file_by_path('top').read(), 'old contents')
@@ -202,14 +158,14 @@
         os.chdir('a')
         # commit from here should do nothing
         run_bzr('commit', '.', '-m', 'commit subdir only', '--unchanged')
-        v3 = b.revision_tree(b.get_rev_id(3))
+        v3 = b.revision_tree(b.lookup_revision(3))
         eq(v3.get_file_by_path('b/two').read(), 'old contents')
         eq(v3.get_file_by_path('top').read(), 'old contents')
         eq(v3.get_file_by_path('a/one').read(), 'new contents')
                 
         # commit in subdirectory commits whole tree
         run_bzr('commit', '-m', 'commit whole tree from subdir')
-        v4 = b.revision_tree(b.get_rev_id(4))
+        v4 = b.revision_tree(b.lookup_revision(4))
         eq(v4.get_file_by_path('b/two').read(), 'new contents')        
         eq(v4.get_file_by_path('top').read(), 'new contents')
         

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/whitebox.py	2005-09-16 06:52:59 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/python
+
 import os
 import unittest
 
@@ -9,7 +11,7 @@
 class TestBranch(TestCaseInTempDir):
 
     def test_unknowns(self):
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         self.build_tree(['hello.txt',
                          'hello.txt~'])
@@ -20,8 +22,7 @@
     def test_no_changes(self):
         from bzrlib.errors import PointlessCommit
         
-        b = Branch.initialize('.')
-
+        b = Branch('.', init=True)
         self.build_tree(['hello.txt'])
 
         self.assertRaises(PointlessCommit,
@@ -67,40 +68,10 @@
                           'Martin Pool <mbp@sourcefrog.net>-20050311061123-96a255005c7c9dbe')
 
 
-class PendingMerges(TestCaseInTempDir):
-
-    def test_pending_merges(self):
-        """Tracking pending-merged revisions."""
-        print "GHOST SUPPORT REMOVED"
-        return
-
-        b = Branch.initialize('.')
-
-        self.assertEquals(b.pending_merges(), [])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        b.add_pending_merge('wibble@fofof--20050401--1928390812')
-        self.assertEquals(b.pending_merges(),
-                          ['foo@azkhazan-123123-abcabc',
-                           'wibble@fofof--20050401--1928390812'])
-        b.commit("commit from base with two merges")
-        rev = b.get_revision(b.revision_history()[0])
-        self.assertEquals(len(rev.parents), 2)
-        self.assertEquals(rev.parents[0].revision_id,
-                          'foo@azkhazan-123123-abcabc')
-        self.assertEquals(rev.parents[1].revision_id,
-                           'wibble@fofof--20050401--1928390812')
-        # list should be cleared when we do a commit
-        self.assertEquals(b.pending_merges(), [])
- 
-
 class MoreTests(TestCaseInTempDir):
-
     def test_revert(self):
         """Test selected-file revert"""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
 
         self.build_tree(['hello.txt'])
         file('hello.txt', 'w').write('initial hello')
@@ -127,7 +98,7 @@
 
     def test_rename_dirs(self):
         """Test renaming directories and the files within them."""
-        b = Branch.initialize('.')
+        b = Branch('.', init=True)
         self.build_tree(['dir/', 'dir/sub/', 'dir/sub/file'])
         b.add(['dir', 'dir/sub', 'dir/sub/file'])
 
@@ -198,8 +169,7 @@
             # directory, or nearby
             os.chdir(dtmp)
 
-            FOO_BAR_QUUX = os.path.join('foo', 'bar', 'quux')
-            self.assertEqual(rp('foo/bar/quux'), FOO_BAR_QUUX)
+            self.assertEqual(rp('foo/bar/quux'), 'foo/bar/quux')
 
             self.assertEqual(rp('foo'), 'foo')
 

=== modified file 'bzrlib/shellcomplete.py'
--- bzrlib/shellcomplete.py	2005-09-09 17:12:26 +0000
+++ bzrlib/shellcomplete.py	2005-08-22 16:31:16 +0000
@@ -17,15 +17,15 @@
 
     from inspect import getdoc
     import commands
-    cmdobj = commands.get_cmd_object(cmdname)
+    context, cmdclass = commands.get_cmd_class(cmdname)
 
-    doc = getdoc(cmdobj)
+    doc = getdoc(cmdclass)
     if doc == None:
         raise NotImplementedError("sorry, no detailed shellcomplete yet for %r" % cmdname)
 
-    shellcomplete_on_option(cmdobj.takes_options, outfile = None)
-    for aname in cmdobj.takes_args:
-        outfile.write(aname + '\n')
+    shellcomplete_on_option(cmdclass.takes_options, outfile = None)
+    for aname in cmdclass.takes_args:
+	    outfile.write(aname + '\n')
 
 
 def shellcomplete_on_option(options, outfile = None):

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2005-09-23 02:58:03 +0000
+++ bzrlib/status.py	2005-08-27 04:42:41 +0000
@@ -20,28 +20,17 @@
                 specific_files=None,
                 show_ids=False,
                 to_file=None,
-                show_pending=True,
-                revision=None):
-    """Display status for non-ignored working files.
+                show_pending=True):
+    """Display single-line status for non-ignored working files.
 
-    show_unchanged
-        If set, includes unchanged files.
+    show_all
+        If true, show unmodified files too.
 
     specific_files
         If set, only show the status of files in this list.
 
-    show_ids
-        If set, includes each file's id.
-
     to_file
         If set, write to this file (default stdout.)
-
-    show_pending
-        If set, write pending merges.
-    revision
-        If None the compare latest revision with working tree
-        If one revision show compared it with working tree.
-        If two revisions show status between first and second.
     """
     import sys
     from bzrlib.delta import compare_trees
@@ -51,26 +40,9 @@
     
     branch.lock_read()
     try:
-        new_is_working_tree = True
-        if revision is None:
-            old = branch.basis_tree()
-            new = branch.working_tree()
-        elif len(revision) > 0:
-            try:
-                rev_id = revision[0].in_history(branch).rev_id
-                old = branch.revision_tree(rev_id)
-            except NoSuchRevision, e:
-                raise BzrCommandError(str(e))
-            if len(revision) > 1:
-                try:
-                    rev_id = revision[1].in_history(branch).rev_id
-                    new = branch.revision_tree(rev_id)
-                    new_is_working_tree = False
-                except NoSuchRevision, e:
-                    raise BzrCommandError(str(e))
-            else:
-                new = branch.working_tree()
-                
+
+        old = branch.basis_tree()
+        new = branch.working_tree()
 
         delta = compare_trees(old, new, want_unchanged=show_unchanged,
                               specific_files=specific_files)
@@ -79,23 +51,22 @@
                    show_ids=show_ids,
                    show_unchanged=show_unchanged)
 
-        if new_is_working_tree:
-            unknowns = new.unknowns()
-            done_header = False
-            for path in unknowns:
-                # FIXME: Should also match if the unknown file is within a
-                # specified directory.
-                if specific_files:
-                    if path not in specific_files:
-                        continue
-                if not done_header:
-                    print >>to_file, 'unknown:'
-                    done_header = True
-                print >>to_file, ' ', path
-            if show_pending and len(branch.pending_merges()) > 0:
-                print >>to_file, 'pending merges:'
-                for merge in branch.pending_merges():
-                    print >> to_file, ' ', merge
+        unknowns = new.unknowns()
+        done_header = False
+        for path in unknowns:
+            # FIXME: Should also match if the unknown file is within a
+            # specified directory.
+            if specific_files:
+                if path not in specific_files:
+                    continue
+            if not done_header:
+                print >>to_file, 'unknown:'
+                done_header = True
+            print >>to_file, ' ', path
+        if show_pending and len(branch.pending_merges()) > 0:
+            print >>to_file, 'pending merges:'
+            for merge in branch.pending_merges():
+                print >> to_file, ' ', merge
     finally:
         branch.unlock()
         

=== modified file 'bzrlib/store.py'
--- bzrlib/store.py	2005-09-28 09:35:50 +0000
+++ bzrlib/store.py	2005-09-22 07:17:50 +0000
@@ -24,19 +24,12 @@
 unique ID.
 """
 
-import errno
-import gzip
-import os
-import tempfile
-import types
+import os, tempfile, types, osutils, gzip, errno
 from stat import ST_SIZE
 from StringIO import StringIO
-
-from bzrlib.errors import BzrError, UnlistableStore
+from bzrlib.errors import BzrError
 from bzrlib.trace import mutter
 import bzrlib.ui
-import bzrlib.osutils as osutils
-
 
 ######################################################################
 # stores
@@ -136,8 +129,7 @@
         pb.update('preparing to copy')
         to_copy = [id for id in ids if id not in self]
         if isinstance(other, ImmutableStore):
-            return self.copy_multi_immutable(other, to_copy, pb, 
-                                             permit_failure=permit_failure)
+            return self.copy_multi_immutable(other, to_copy, pb)
         count = 0
         failed = set()
         for id in to_copy:
@@ -148,7 +140,7 @@
             else:
                 try:
                     entry = other[id]
-                except KeyError:
+                except IndexError:
                     failed.add(id)
                     continue
                 self.add(entry, id)
@@ -159,20 +151,21 @@
         return count, failed
 
     def copy_multi_immutable(self, other, to_copy, pb, permit_failure=False):
+        from shutil import copyfile
         count = 0
         failed = set()
         for id in to_copy:
             p = self._path(id)
             other_p = other._path(id)
             try:
-                osutils.link_or_copy(other_p, p)
-            except (IOError, OSError), e:
+                copyfile(other_p, p)
+            except IOError, e:
                 if e.errno == errno.ENOENT:
                     if not permit_failure:
-                        osutils.link_or_copy(other_p+".gz", p+".gz")
+                        copyfile(other_p+".gz", p+".gz")
                     else:
                         try:
-                            osutils.link_or_copy(other_p+".gz", p+".gz")
+                            copyfile(other_p+".gz", p+".gz")
                         except IOError, e:
                             if e.errno == errno.ENOENT:
                                 failed.add(id)
@@ -224,7 +217,7 @@
             if e.errno != errno.ENOENT:
                 raise
 
-        raise KeyError(fileid)
+        raise IndexError(fileid)
 
 
     def total_size(self):
@@ -264,10 +257,3 @@
             os.remove(fpath)
         os.rmdir(self._basedir)
         mutter("%r destroyed" % self)
-
-def copy_all(store_from, store_to):
-    """Copy all ids from one store to another."""
-    if not hasattr(store_from, "__iter__"):
-        raise UnlistableStore(store_from)
-    ids = [f for f in store_from]
-    store_to.copy_multi(store_from, ids)

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2005-09-26 08:56:15 +0000
+++ bzrlib/textinv.py	2005-04-11 02:44:45 +0000
@@ -15,8 +15,8 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib.errors import BzrError
-from bzrlib.inventory import InventoryEntry, Inventory
+from errors import BzrError
+from inventory import InventoryEntry, Inventory
 
 
 START_MARK = "# bzr inventory format 3\n"

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-09-27 07:24:40 +0000
+++ bzrlib/trace.py	2005-09-22 06:04:13 +0000
@@ -104,9 +104,17 @@
             return
         old_fname = trace_fname + '.old'
 
-        from osutils import rename
-        rename(trace_fname, old_fname)
+        try:
+            # must remove before rename on windows
+            os.remove(old_fname)
+        except OSError:
+            pass
 
+        try:
+            # might fail if in use on windows
+            os.rename(trace_fname, old_fname)
+        except OSError:
+            pass
     except OSError:
         return
 
@@ -192,6 +200,7 @@
     logging.getLogger('').addHandler(_stderr_handler)
 
 
+
 def disable_default_logging():
     """Turn off default log handlers.
 

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-09-29 03:44:15 +0000
+++ bzrlib/upgrade.py	2005-09-22 12:11:16 +0000
@@ -78,6 +78,7 @@
 
 import os
 import tempfile
+import hotshot, hotshot.stats
 import sys
 import logging
 import shutil
@@ -102,26 +103,32 @@
         self.absent_revisions = set()
         self.text_count = 0
         self.revisions = {}
+        self.inventories = {}
         self.convert()
 
 
     def convert(self):
-        if not self._open_branch():
-            return
-        note('starting upgrade of %s', os.path.abspath(self.base))
-        self._backup_control_dir()
-        note('starting upgrade')
-        note('note: upgrade may be faster if all store files are ungzipped first')
+        note('starting upgrade of %s', self.base)
+	self._backup_control_dir()
+	note('starting upgrade')
+	note('note: upgrade may be faster if all store files are ungzipped first')
         self.pb = ProgressBar()
-        if not os.path.isdir(self.base + '/.bzr/weaves'):
-            os.mkdir(self.base + '/.bzr/weaves')
-        self.inv_weave = Weave('inventory')
-        self.anc_weave = Weave('ancestry')
+	if not os.path.isdir(self.base + '/.bzr/weaves'):
+	    os.mkdir(self.base + '/.bzr/weaves')
+        self.inv_weave = Weave('__inventory')
+        self.anc_weave = Weave('__ancestry')
         self.ancestries = {}
         # holds in-memory weaves for all files
         self.text_weaves = {}
-        os.remove(self.branch.controlfilename('branch-format'))
-        self._convert_working_inv()
+        self.branch = Branch(self.base, relax_version_check=True)
+        if self.branch._branch_format == 5:
+            note('this branch is already in the most current format')
+            return
+        if self.branch._branch_format != 4:
+            raise BzrError("cannot upgrade from branch format %r" %
+                           self.branch._branch_format)
+	os.remove(self.branch.controlfilename('branch-format'))
+	self._convert_working_inv()
         rev_history = self.branch.revision_history()
         # to_read is a stack holding the revisions we still need to process;
         # appending to it adds new highest-priority revisions
@@ -144,54 +151,42 @@
         note('  %6d texts' % self.text_count)
         self._write_all_weaves()
         self._write_all_revs()
-        self._set_new_format()
-        self._cleanup_spare_files()
-
-
-    def _open_branch(self):
-        self.branch = Branch.open_downlevel(self.base)
-        if self.branch._branch_format == 5:
-            note('this branch is already in the most current format')
-            return False
-        if self.branch._branch_format != 4:
-            raise BzrError("cannot upgrade from branch format %r" %
-                           self.branch._branch_format)
-        return True
+	self._set_new_format()
+	self._cleanup_spare_files()
 
 
     def _set_new_format(self):
-        f = self.branch.controlfile('branch-format', 'wb')
+	f = self.branch.controlfile('branch-format', 'wb')
         try:
-            f.write(BZR_BRANCH_FORMAT_5)
-        finally:
-            f.close()
+	    f.write(BZR_BRANCH_FORMAT_5)
+	finally:
+	    f.close()
 
 
     def _cleanup_spare_files(self):
-        for n in 'merged-patches', 'pending-merged-patches':
-            p = self.branch.controlfilename(n)
-            if not os.path.exists(p):
-                continue
-            ## assert os.path.getsize(p) == 0
-            os.remove(p)
-        shutil.rmtree(self.base + '/.bzr/inventory-store')
-        shutil.rmtree(self.base + '/.bzr/text-store')
+	for n in 'merged-patches', 'pending-merged-patches':
+	    p = self.branch.controlfilename(n)
+	    if not os.path.exists(p):
+		continue
+	    ## assert os.path.getsize(p) == 0
+	    os.remove(p)
+	shutil.rmtree(self.base + '/.bzr/inventory-store')
+	shutil.rmtree(self.base + '/.bzr/text-store')
 
 
     def _backup_control_dir(self):
         orig = self.base + '/.bzr'
         backup = orig + '.backup'
-        note('making backup of tree history')
-        shutil.copytree(orig, backup)
-        note('%s has been backed up to %s', orig, backup)
-        note('if conversion fails, you can move this directory back to .bzr')
-        note('if it succeeds, you can remove this directory if you wish')
+	shutil.copytree(orig, backup)
+	note('%s has been backed up to %s', orig, backup)
+	note('if conversion fails, you can move this directory back to .bzr')
+	note('if it succeeds, you can remove this directory if you wish')
 
 
     def _convert_working_inv(self):
-        branch = self.branch
-        inv = serializer_v4.read_inventory(branch.controlfile('inventory', 'rb'))
-        serializer_v5.write_inventory(inv, branch.controlfile('inventory', 'wb'))
+	branch = self.branch
+	inv = serializer_v4.read_inventory(branch.controlfile('inventory', 'rb'))
+	serializer_v5.write_inventory(inv, branch.controlfile('inventory', 'wb'))
 
 
 
@@ -210,8 +205,8 @@
 
     def _write_all_revs(self):
         """Write all revisions out in new form."""
-        shutil.rmtree(self.base + '/.bzr/revision-store')
-        os.mkdir(self.base + '/.bzr/revision-store')
+	shutil.rmtree(self.base + '/.bzr/revision-store')
+	os.mkdir(self.base + '/.bzr/revision-store')
         try:
             for i, rev_id in enumerate(self.converted_revs):
                 self.pb.update('write revision', i, len(self.converted_revs))
@@ -245,60 +240,32 @@
                 self.known_revisions.add(parent_id)
                 self.to_read.append(parent_id)
             self.revisions[rev_id] = rev
-
-
-    def _load_old_inventory(self, rev_id):
-        assert rev_id not in self.converted_revs
-        old_inv_xml = self.branch.inventory_store[rev_id].read()
-        inv = serializer_v4.read_inventory_from_string(old_inv_xml)
-        rev = self.revisions[rev_id]
-        if rev.inventory_sha1:
-            assert rev.inventory_sha1 == sha_string(old_inv_xml), \
-                'inventory sha mismatch for {%s}' % rev_id
-        return inv
+            old_inv_xml = self.branch.inventory_store[rev_id].read()
+            inv = serializer_v4.read_inventory_from_string(old_inv_xml)
+            assert rev.inventory_sha1 == sha_string(old_inv_xml)
+            self.inventories[rev_id] = inv
         
 
-    def _load_updated_inventory(self, rev_id):
-        assert rev_id in self.converted_revs
-        inv_xml = self.inv_weave.get_text(rev_id)
-        inv = serializer_v5.read_inventory_from_string(inv_xml)
-        return inv
-
-
     def _convert_one_rev(self, rev_id):
         """Convert revision and all referenced objects to new format."""
         rev = self.revisions[rev_id]
-        inv = self._load_old_inventory(rev_id)
+        inv = self.inventories[rev_id]
         for parent_id in rev.parent_ids[:]:
             if parent_id in self.absent_revisions:
                 rev.parent_ids.remove(parent_id)
                 self.pb.clear()
                 note('remove {%s} as parent of {%s}', parent_id, rev_id)
         self._convert_revision_contents(rev, inv)
-        self._store_new_weave(rev, inv)
-        self._make_rev_ancestry(rev)
-        self.converted_revs.add(rev_id)
-
-
-    def _store_new_weave(self, rev, inv):
         # the XML is now updated with text versions
-        if __debug__:
-            for file_id in inv:
-                ie = inv[file_id]
-                if ie.kind == 'root_directory':
-                    continue
-                assert hasattr(ie, 'name_version'), \
-                    'no name_version on {%s} in {%s}' % \
-                    (file_id, rev.revision_id)
-                if ie.kind == 'file':
-                    assert hasattr(ie, 'text_version')
-
         new_inv_xml = serializer_v5.write_inventory_to_string(inv)
         new_inv_sha1 = sha_string(new_inv_xml)
-        self.inv_weave.add(rev.revision_id, rev.parent_ids,
+        self.inv_weave.add(rev_id, rev.parent_ids,
                            new_inv_xml.splitlines(True),
                            new_inv_sha1)
+        # TODO: Upgrade revision XML and write that out
         rev.inventory_sha1 = new_inv_sha1
+        self._make_rev_ancestry(rev)
+        self.converted_revs.add(rev_id)
 
 
     def _make_rev_ancestry(self, rev):
@@ -325,41 +292,38 @@
         rev_id = rev.revision_id
         mutter('converting texts of revision {%s}',
                rev_id)
-        parent_invs = map(self._load_updated_inventory, rev.parent_ids)
         for file_id in inv:
             ie = inv[file_id]
-            self._set_name_version(rev, ie, parent_invs)
+	    self._set_name_version(rev, ie)
             if ie.kind != 'file':
                 continue
-            self._convert_file_version(rev, ie, parent_invs)
-
-
-    def _set_name_version(self, rev, ie, parent_invs):
-        """Set name version for a file.
-
-        Done in a slightly lazy way: if the file is renamed or in a merge revision
-        it gets a new version, otherwise the same as before.
-        """
-        file_id = ie.file_id
-        if ie.kind == 'root_directory':
-            return
-        if len(parent_invs) != 1:
-            ie.name_version = rev.revision_id
-        else:
-            old_inv = parent_invs[0]
-            if not old_inv.has_id(file_id):
-                ie.name_version = rev.revision_id
-            else:
-                old_ie = old_inv[file_id]
-                if (old_ie.parent_id != ie.parent_id
-                    or old_ie.name != ie.name):
-                    ie.name_version = rev.revision_id
-                else:
-                    ie.name_version = old_ie.name_version
-
-
-
-    def _convert_file_version(self, rev, ie, parent_invs):
+            self._convert_file_version(rev, ie)
+
+
+    def _set_name_version(self, rev, ie):
+	"""Set name version for a file.
+
+	Done in a slightly lazy way: if the file is renamed or in a merge revision
+	it gets a new version, otherwise the same as before.
+	"""
+	file_id = ie.file_id
+	if len(rev.parent_ids) != 1:
+	    ie.name_version = rev.revision_id
+	else:
+	    old_inv = self.inventories[rev.parent_ids[0]]
+	    if not old_inv.has_id(file_id):
+		ie.name_version = rev.revision_id
+	    else:
+		old_ie = old_inv[file_id]
+		if (old_ie.parent_id != ie.parent_id
+		    or old_ie.name != ie.name):
+		    ie.name_version = rev.revision_id
+		else:
+		    ie.name_version = old_ie.name_version
+
+
+
+    def _convert_file_version(self, rev, ie):
         """Convert one version of one file.
 
         The file needs to be added into the weave if it is a merge
@@ -373,7 +337,12 @@
             self.text_weaves[file_id] = w
         file_parents = []
         text_changed = False
-        for parent_inv in parent_invs:
+        for parent_id in rev.parent_ids:
+            ##if parent_id in self.absent_revisions:
+            ##    continue
+            assert parent_id in self.converted_revs, \
+                   'parent {%s} not converted' % parent_id
+            parent_inv = self.inventories[parent_id]
             if parent_inv.has_id(file_id):
                 parent_ie = parent_inv[file_id]
                 old_text_version = parent_ie.text_version

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2005-09-29 09:07:09 +0000
+++ bzrlib/weave.py	2005-09-22 06:54:01 +0000
@@ -94,6 +94,7 @@
 from difflib import SequenceMatcher
 
 
+from bzrlib.osutils import sha_strings
 
 
 class WeaveError(Exception):
@@ -272,7 +273,6 @@
         sha -- SHA-1 of the file, if known.  This is trusted to be
             correct if supplied.
         """
-        from bzrlib.osutils import sha_strings
 
         assert isinstance(name, basestring)
         if sha1 is None:
@@ -784,9 +784,12 @@
 
 
 
-def weave_stats(weave_file, pb):
+def weave_stats(weave_file):
+    from bzrlib.progress import ProgressBar
     from bzrlib.weavefile import read_weave
 
+    pb = ProgressBar()
+
     wf = file(weave_file, 'rb')
     w = read_weave(wf)
     # FIXME: doesn't work on pipes
@@ -865,12 +868,6 @@
 def main(argv):
     import sys
     import os
-    try:
-        import bzrlib
-    except ImportError:
-        # in case we're run directly from the subdirectory
-        sys.path.append('..')
-        import bzrlib
     from bzrlib.weavefile import write_weave, read_weave
     from bzrlib.progress import ProgressBar
 
@@ -943,7 +940,7 @@
         weave_toc(readit())
 
     elif cmd == 'stats':
-        weave_stats(argv[2], ProgressBar())
+        weave_stats(argv[2])
         
     elif cmd == 'check':
         w = readit()

=== modified file 'bzrlib/weavefile.py'
--- bzrlib/weavefile.py	2005-09-27 07:24:40 +0000
+++ bzrlib/weavefile.py	2005-09-12 09:11:51 +0000
@@ -1,3 +1,5 @@
+#! /usr/bin/python
+
 # Copyright (C) 2005 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify

=== modified file 'bzrlib/weavestore.py'
--- bzrlib/weavestore.py	2005-09-29 02:01:49 +0000
+++ bzrlib/weavestore.py	2005-09-22 07:14:40 +0000
@@ -34,15 +34,11 @@
 
     This has some shortcuts for reading and writing them.
     """
-    def __init__(self, dir, get_file=None):
+    def __init__(self, dir):
         self._dir = dir
         self._cache = {}
-        self.enable_cache = False
-        if get_file is not None:
-            self.get_file = get_file
+	self.enable_cache = False
 
-    def get_file(self, filename):
-        return file(filename, 'rb')
 
     def filename(self, file_id):
         return self._dir + os.sep + file_id + '.weave'
@@ -52,7 +48,7 @@
         if self.enable_cache:
             if file_id in self._cache:
                 return self._cache[file_id]
-        w = read_weave(self.get_file(self.filename(file_id)))
+        w = read_weave(file(self.filename(file_id), 'rb'))
         if self.enable_cache:
             self._cache[file_id] = w
         return w
@@ -69,7 +65,7 @@
     def get_weave_or_empty(self, file_id):
         """Return a weave, or an empty one if it doesn't exist.""" 
         try:
-            inf = self.get_file(self.filename(file_id))
+            inf = file(self.filename(file_id), 'rb')
         except IOError, e:
             if e.errno == errno.ENOENT:
                 return Weave(weave_name=file_id)
@@ -79,10 +75,6 @@
             return read_weave(inf)
     
 
-    def put_empty_weave(self, file_id):
-        self.put_weave(file_id, Weave())
-
-
     def put_weave(self, file_id, weave):
         """Write back a modified weave"""
         if self.enable_cache:

=== modified file 'bzrlib/xml.py'
--- bzrlib/xml.py	2005-09-27 07:24:40 +0000
+++ bzrlib/xml.py	2005-09-19 07:52:30 +0000
@@ -1,4 +1,4 @@
-# -*- coding: UTF-8 -*-
+#! /usr/bin/env python
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,8 +28,8 @@
     from cElementTree import (ElementTree, SubElement, Element,
                               XMLTreeBuilder, fromstring, tostring)
 except ImportError:
-    ## from warnings import warn
-    ## warn('using slower ElementTree; consider installing cElementTree')
+    from warnings import warn
+    warn('using slower ElementTree; consider installing cElementTree')
     from util.elementtree.ElementTree import (ElementTree, SubElement,
                                               Element, XMLTreeBuilder,
                                               fromstring, tostring)

=== modified file 'contrib/newinventory.py'
--- contrib/newinventory.py	2005-09-27 07:24:40 +0000
+++ contrib/newinventory.py	2005-09-08 11:17:45 +0000
@@ -14,13 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.xml import ElementTree, Element
+from xml import ElementTree, Element
 
 
 def write_inventory(inv, f):
     el = Element('inventory', {'version': '2'})
     el.text = '\n'
-
+    
     root = Element('root_directory', {'id': inv.root.file_id})
     root.tail = root.text = '\n'
     el.append(root)

=== modified file 'setup.py'
--- setup.py	2005-09-23 09:25:16 +0000
+++ setup.py	2005-09-04 03:32:17 +0000
@@ -6,52 +6,8 @@
 
 from distutils.core import setup
 
-# more sophisticated setup script, based on pychecker setup.py
-import sys, os
-from distutils.command.build_scripts import build_scripts
-
-
-###############################
-# Overridden distutils actions
-###############################
-
-class my_build_scripts(build_scripts):
-    """Customized build_scripts distutils action.
-
-    Create bzr.bat for win32.
-    """
-
-    def run(self):
-        if sys.platform == "win32":
-            bat_path = os.path.join(self.build_dir, "bzr.bat")
-            self.scripts.append(bat_path)
-            self.mkpath(self.build_dir)
-            scripts_dir = self.distribution.get_command_obj("install").\
-                                                            install_scripts
-            self.execute(func=self._create_bat,
-                         args=[bat_path, scripts_dir],
-                         msg="Create %s" % bat_path)
-        build_scripts.run(self) # invoke "standard" action
-
-    def _create_bat(self, bat_path, scripts_dir):
-        """ Creates the batch file for bzr on win32.
-        """
-        try:
-            script_path = os.path.join(scripts_dir, "bzr")
-            bat_str = "@%s %s %%*\n" % (sys.executable, script_path)
-            file(bat_path, "w").write(bat_str)
-            print "file written"
-        except Exception, e:
-            print "ERROR: Unable to create %s: %s" % (bat_path, e)
-            raise e
-
-
-########################
-## Setup
-########################
-
 setup(name='bzr',
-      version='0.0.6',
+      version='0.0.0',
       author='Martin Pool',
       author_email='mbp@sourcefrog.net',
       url='http://www.bazaar-ng.org/',

=== modified file 'testsweet.py'
--- testsweet.py	2005-09-27 06:15:35 +0000
+++ testsweet.py	2005-08-30 01:35:40 +0000
@@ -55,6 +55,8 @@
     """Indicates that a test was intentionally skipped, rather than failing."""
     # XXX: Not used yet
 
+
+
 class EarlyStoppingTestResultAdapter(object):
     """An adapter for TestResult to stop at the first first failure or error"""
 
@@ -88,9 +90,12 @@
     def startTest(self, test):
         unittest.TestResult.startTest(self, test)
         # TODO: Maybe show test.shortDescription somewhere?
-        what = test.shortDescription() or test.id()        
+        what = test.id()
+        # python2.3 has the bad habit of just "runit" for doctests
+        if what == 'runit':
+            what = test.shortDescription()
         if self.showAll:
-            self.stream.write('%-70.70s' % what)
+            self.stream.write('%-60.60s' % what)
         self.stream.flush()
 
     def addError(self, test, err):
@@ -113,12 +118,12 @@
         for test, err in errors:
             self.stream.writeln(self.separator1)
             self.stream.writeln("%s: %s" % (flavour,self.getDescription(test)))
+            self.stream.writeln(self.separator2)
+            self.stream.writeln("%s" % err)
             if hasattr(test, '_get_log'):
                 self.stream.writeln()
                 self.stream.writeln('log from this test:')
                 print >>self.stream, test._get_log()
-            self.stream.writeln(self.separator2)
-            self.stream.writeln("%s" % err)
 
 
 class TextTestRunner(unittest.TextTestRunner):
@@ -168,7 +173,7 @@
     # but only a little. Folk not using our testrunner will
     # have to delete their temp directories themselves.
     if result.wasSuccessful():
-        if TestCaseInTempDir.TEST_ROOT is not None:
+        if TestCaseInTempDir.TEST_ROOT:
             shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
     else:
         print "Failed tests working directories are in '%s'\n" % TestCaseInTempDir.TEST_ROOT

=== modified file 'tutorial.txt'
--- tutorial.txt	2005-09-14 09:03:27 +0000
+++ tutorial.txt	2005-09-01 12:34:34 +0000
@@ -289,7 +289,7 @@
 a copy.  Because this new copy is potentially a new branch, the
 command is called *branch*::
 
-    % bzr branch http://bazaar-ng.org/bzr/bzr.dev
+    % bzr branch http://bazaar-ng.org/bzr/bzr.dev 
     % cd bzr.dev
 
 This copies down the complete history of this branch, so we can

